  { Welcome to the wonderful world of XLib Unit.
  
  This unit interfaces Xlib.h and X.h. 

  Copyright (C) 2002,2003 by Eike Lange

  Author: Eike Lange <eike@g-n-u.de>

  Documentation:
  ==============
  Of you need some documentation about XLib-Programming,
  please visit the following sites:
  (I am not responsible for the contents of these sites)
  *  http://www.tronche.com/gui/x/xlib/introduction/
  *  http://www.rahul.net/kenton/xsites.framed.html

  Different to C-Interface:
  =========================
  * Always:
    - underscores removed
    - "class" ==> "Klass"
    - Element "Type"  ==> "EventType" in EventRecords
  * Record TXGcValues (XGcValues):
    Element "FunctionE" is a different name
  * TXSelectionEvent (XSelectionEvent):
    TTarget, TProperty are different names
  * TXColormapEvent (XColormapEvent): ANew is a different name
  * TXIMText (XIMText) and TXIMStringConversionText
    (XIMStringConversionText): AString is a different name
  * TXIMStatusDrawCallbackStruct (XIMStatusDrawCallbackStruct)
      "DataType" is a different name
  * Due to a name clash with constant "XLookupKeysym"
      function XLookupKeysymP is different name
  * Macros are rewritten as functions. See xlibc.c for details.
  
  To Do:
  ======
  * OOP XLib Unit (E-Mail from Markus G.)
  * Fix all those "@@" comments
  * return values of 
    TBool should be Boolean
    PChar should be String
    ...
  (If you need all this, please let me know)

  This unit is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as
  published by the Free Software Foundation, version 2.

  This unit is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; see the file COPYING.LIB. If not,
  write to the Free Software Foundation, Inc., 59 Temple Place -
  Suite 330, Boston, MA 02111-1307, USA. }

{ Please note the original copyright notice on top of
  Xlib.h and X.h }

{$gnu-pascal,I-}
{$if __GPC_RELEASE__ < 20030303}
{$error This unit requires GPC release 20030303 or newer.}
{$endif}

unit Xlib;

interface

{@section Types from X.h }
type
  TXID = MedCard;  { unsigned long in C }
  TMask = TXID;
  PAtom = ^TAtom;
  TAtom = TXID;
  TVisualID = TXID;
  TTime = TXID;
  TWindow = TXID;
  TDrawable = TXID;
  TFont = TXID;
  TPixmap = TXID;
  TCursor = TXID;
  TColormap = TXID;
  TGContext = TXID;
  TKeysym = TXID;
  TKeyCode = Byte;

{@section Consts from X.h}
{ Please do not assign anything to these identifies. They should
be treated as constants }
var
  X_PROTOCOL:           Integer; external name '_p_X_PROTOCOL'; attribute (const);
  X_PROTOCOL_REVISION:  Integer; external name '_p_X_PROTOCOL_REVISION'; attribute (const);
  None:                 Integer; external name '_p_None'; attribute (const);
  ParentRelative:       Integer; external name '_p_ParentRelative'; attribute (const);
  CopyFromParent:       Integer; external name '_p_CopyFromParent'; attribute (const);
  PointerWindow:        Integer; external name '_p_PointerWindow'; attribute (const);
  InputFocus:           Integer; external name '_p_InputFocus'; attribute (const);
  PointerRoot:          Integer; external name '_p_PointerRoot'; attribute (const);
  AnyPropertyType:      Integer; external name '_p_AnyPropertyType'; attribute (const);
  AnyKey:               Integer; external name '_p_AnyKey'; attribute (const);
  AnyButton:            Integer; external name '_p_AnyButton'; attribute (const);
  AllTemporary:         Integer; external name '_p_AllTemporary'; attribute (const);
  CurrentTime:          Integer; external name '_p_CurrentTime'; attribute (const);
  NoSymbol:             Integer; external name '_p_NoSymbol'; attribute (const);
  
  {@subsection EVENT DEFINITIONS }
  { Input Event Masks }
  NoEventMask:          Integer; external name '_p_NoEventMask'; attribute (const);
  KeyPressMask:         Integer; external name '_p_KeyPressMask'; attribute (const);
  KeyReleaseMask:       Integer; external name '_p_KeyReleaseMask'; attribute (const);
  ButtonPressMask:      Integer; external name '_p_ButtonPressMask'; attribute (const);
  ButtonReleaseMask:    Integer; external name '_p_ButtonReleaseMask'; attribute (const);
  EnterWindowMask:      Integer; external name '_p_EnterWindowMask'; attribute (const);
  LeaveWindowMask:      Integer; external name '_p_LeaveWindowMask'; attribute (const);
  PointerMotionMask:    Integer; external name '_p_PointerMotionMask'; attribute (const);
  PointerMotionHintMask:Integer; external name '_p_PointerMotionHintMask'; attribute (const);
  Button1MotionMask:    Integer; external name '_p_Button1MotionMask'; attribute (const);
  Button2MotionMask:    Integer; external name '_p_Button2MotionMask'; attribute (const);
  Button3MotionMask:    Integer; external name '_p_Button3MotionMask'; attribute (const);
  Button4MotionMask:    Integer; external name '_p_Button4MotionMask'; attribute (const);
  Button5MotionMask:    Integer; external name '_p_Button5MotionMask'; attribute (const);
  ButtonMotionMask:     Integer; external name '_p_ButtonMotionMask'; attribute (const);
  KeymapStateMask:      Integer; external name '_p_KeymapStateMask'; attribute (const);
  ExposureMask:         Integer; external name '_p_ExposureMask'; attribute (const);
  VisibilityChangeMask: Integer; external name '_p_VisibilityChangeMask'; attribute (const);
  StructureNotifyMask:  Integer; external name '_p_StructureNotifyMask'; attribute (const);
  ResizeRedirectMask:   Integer; external name '_p_ResizeRedirectMask'; attribute (const);
  SubstructureNotifyMask:   Integer; external name '_p_SubstructureNotifyMask'; attribute (const);
  SubstructureRedirectMask: Integer; external name '_p_SubstructureRedirectMask'; attribute (const);
  FocusChangeMask:      Integer; external name '_p_FocusChangeMask'; attribute (const);
  PropertyChangeMask:   Integer; external name '_p_PropertyChangeMask'; attribute (const);
  ColormapChangeMask:   Integer; external name '_p_ColormapChangeMask'; attribute (const);
  OwnerGrabButtonMask:  Integer; external name '_p_OwnerGrabButtonMask'; attribute (const);
  
  { Event names }
  KeyPress:             Integer; external name '_p_KeyPress'; attribute (const);
  KeyRelease:           Integer; external name '_p_KeyRelease'; attribute (const);
  ButtonPress:          Integer; external name '_p_ButtonPress'; attribute (const);
  ButtonRelease:        Integer; external name '_p_ButtonRelease'; attribute (const);
  MotionNotify:         Integer; external name '_p_MotionNotify'; attribute (const);
  EnterNotify:          Integer; external name '_p_EnterNotify'; attribute (const);
  LeaveNotify:          Integer; external name '_p_LeaveNotify'; attribute (const);
  FocusIn:              Integer; external name '_p_FocusIn'; attribute (const);
  FocusOut:             Integer; external name '_p_FocusOut'; attribute (const);
  KeymapNotify:         Integer; external name '_p_KeymapNotify'; attribute (const);
  Expose:               Integer; external name '_p_Expose'; attribute (const);
  GraphicsExpose:       Integer; external name '_p_GraphicsExpose'; attribute (const);
  NoExpose:             Integer; external name '_p_NoExpose'; attribute (const);
  VisibilityNotify:     Integer; external name '_p_VisibilityNotify'; attribute (const);
  CreateNotify:         Integer; external name '_p_CreateNotify'; attribute (const);
  DestroyNotify:        Integer; external name '_p_DestroyNotify'; attribute (const);
  UnmapNotify:          Integer; external name '_p_UnmapNotify'; attribute (const);
  MapNotify:            Integer; external name '_p_MapNotify'; attribute (const);
  MapRequest:           Integer; external name '_p_MapRequest'; attribute (const);
  ReparentNotify:       Integer; external name '_p_ReparentNotify'; attribute (const);
  ConfigureNotify:      Integer; external name '_p_ConfigureNotify'; attribute (const);
  ConfigureRequest:     Integer; external name '_p_ConfigureRequest'; attribute (const);
  GravityNotify:        Integer; external name '_p_GravityNotify'; attribute (const);
  ResizeRequest:        Integer; external name '_p_ResizeRequest'; attribute (const);
  CirculateNotify:      Integer; external name '_p_CirculateNotify'; attribute (const);
  CirculateRequest:     Integer; external name '_p_CirculateRequest'; attribute (const);
  PropertyNotify:       Integer; external name '_p_PropertyNotify'; attribute (const);
  SelectionClear:       Integer; external name '_p_SelectionClear'; attribute (const);
  SelectionRequest:     Integer; external name '_p_SelectionRequest'; attribute (const);
  SelectionNotify:      Integer; external name '_p_SelectionNotify'; attribute (const);
  ColormapNotify:       Integer; external name '_p_ColormapNotify'; attribute (const);
  ClientMessage:        Integer; external name '_p_ClientMessage'; attribute (const);
  MappingNotify:        Integer; external name '_p_MappingNotify'; attribute (const);
  LASTEvent:            Integer; external name '_p_LASTEvent'; attribute (const);
  
  { Key masks }
  ShiftMask:            Integer; external name '_p_ShiftMask'; attribute (const);
  LockMask:             Integer; external name '_p_LockMask'; attribute (const);
  ControlMask:          Integer; external name '_p_ControlMask'; attribute (const);
  Mod1Mask:             Integer; external name '_p_Mod1Mask'; attribute (const);
  Mod2Mask:             Integer; external name '_p_Mod2Mask'; attribute (const);
  Mod3Mask:             Integer; external name '_p_Mod3Mask'; attribute (const);
  Mod4Mask:             Integer; external name '_p_Mod4Mask'; attribute (const);
  Mod5Mask:             Integer; external name '_p_Mod5Mask'; attribute (const);
  
  { modifier names }
  ShiftMapIndex:        Integer; external name '_p_ShiftMapIndex'; attribute (const);
  LockMapIndex:         Integer; external name '_p_LockMapIndex'; attribute (const);
  ControlMapIndex:      Integer; external name '_p_ControlMapIndex'; attribute (const);
  Mod1MapIndex:         Integer; external name '_p_Mod1MapIndex'; attribute (const);
  Mod2MapIndex:         Integer; external name '_p_Mod2MapIndex'; attribute (const);
  Mod3MapIndex:         Integer; external name '_p_Mod3MapIndex'; attribute (const);
  Mod4MapIndex:         Integer; external name '_p_Mod4MapIndex'; attribute (const);
  Mod5MapIndex:         Integer; external name '_p_Mod5MapIndex'; attribute (const);
  
  { button masks }
  Button1Mask:          Integer; external name '_p_Button1Mask'; attribute (const);
  Button2Mask:          Integer; external name '_p_Button2Mask'; attribute (const);
  Button3Mask:          Integer; external name '_p_Button3Mask'; attribute (const);
  Button4Mask:          Integer; external name '_p_Button4Mask'; attribute (const);
  Button5Mask:          Integer; external name '_p_Button5Mask'; attribute (const);
  AnyModifier:          Integer; external name '_p_AnyModifier'; attribute (const);
  
  { button names }
  Button1:              Integer; external name '_p_Button1'; attribute (const);
  Button2:              Integer; external name '_p_Button2'; attribute (const);
  Button3:              Integer; external name '_p_Button3'; attribute (const);
  Button4:              Integer; external name '_p_Button4'; attribute (const);
  Button5:              Integer; external name '_p_Button5'; attribute (const);
  
  { Notify modes }
  NotifyNormal:         Integer; external name '_p_NotifyNormal'; attribute (const);
  NotifyGrab:           Integer; external name '_p_NotifyGrab'; attribute (const);
  NotifyUngrab:         Integer; external name '_p_NotifyUngrab'; attribute (const);
  NotifyWhileGrabbed:   Integer; external name '_p_NotifyWhileGrabbed'; attribute (const);
  NotifyHint:           Integer; external name '_p_NotifyHint'; attribute (const);
  
  { Notify detail }
  NotifyAncestor:       Integer; external name '_p_NotifyAncestor'; attribute (const);
  NotifyVirtual:        Integer; external name '_p_NotifyVirtual'; attribute (const);
  NotifyInferior:       Integer; external name '_p_NotifyInferior'; attribute (const);
  NotifyNonlinear:      Integer; external name '_p_NotifyNonlinear'; attribute (const);
  NotifyNonlinearVirtual:   Integer; external name '_p_NotifyNonlinearVirtual'; attribute (const);
  NotifyPointer:        Integer; external name '_p_NotifyPointer'; attribute (const);
  NotifyPointerRoot:    Integer; external name '_p_NotifyPointerRoot'; attribute (const);
  NotifyDetailNone:     Integer; external name '_p_NotifyDetailNone'; attribute (const);
  
  { Visibility notify }
  VisibilityUnobscured: Integer; external name '_p_VisibilityUnobscured'; attribute (const);
  VisibilityPartiallyObscured:  Integer; external name '_p_VisibilityPartiallyObscured'; attribute (const);
  VisibilityFullyObscured:      Integer; external name '_p_VisibilityFullyObscured'; attribute (const);
  
  { Circulation reques }
  PlaceOnTop:           Integer; external name '_p_PlaceOnTop'; attribute (const);
  PlaceOnBottom:        Integer; external name '_p_PlaceOnBottom'; attribute (const);
  
  { protocol families }
  FamilyInternet:       Integer; external name '_p_FamilyInternet'; attribute (const);
  FamilyDECnet:         Integer; external name '_p_FamilyDECnet'; attribute (const);
  FamilyChaos:          Integer; external name '_p_FamilyChaos'; attribute (const);
  
  { Property notification }
  PropertyNewValue:     Integer; external name '_p_PropertyNewValue'; attribute (const);
  PropertyDelete:       Integer; external name '_p_PropertyDelete'; attribute (const);
  
  { Color Map notification }
  ColormapUninstalled:  Integer; external name '_p_ColormapUninstalled'; attribute (const);
  ColormapInstalled:    Integer; external name '_p_ColormapInstalled'; attribute (const);
  
  { GrabPointer, GrabButton, GrabKeyboard, GrabKey Modes }
  GrabModeSync:         Integer; external name '_p_GrabModeSync'; attribute (const);
  GrabModeAsync:        Integer; external name '_p_GrabModeAsync'; attribute (const);
  
  { GrabPointer, GrabKeyboard reply status }
  GrabSuccess:          Integer; external name '_p_GrabSuccess'; attribute (const);
  AlreadyGrabbed:       Integer; external name '_p_AlreadyGrabbed'; attribute (const);
  GrabInvalidTime:      Integer; external name '_p_GrabInvalidTime'; attribute (const);
  GrabNotViewable:      Integer; external name '_p_GrabNotViewable'; attribute (const);
  GrabFrozen:           Integer; external name '_p_GrabFrozen'; attribute (const);
  
  { AllowEvents modes }
  AsyncPointer:         Integer; external name '_p_AsyncPointer'; attribute (const);
  SyncPointer:          Integer; external name '_p_SyncPointer'; attribute (const);
  ReplayPointer:        Integer; external name '_p_ReplayPointer'; attribute (const);
  AsyncKeyboard:        Integer; external name '_p_AsyncKeyboard'; attribute (const);
  SyncKeyboard:         Integer; external name '_p_SyncKeyboard'; attribute (const);
  ReplayKeyboard:       Integer; external name '_p_ReplayKeyboard'; attribute (const);
  AsyncBoth:            Integer; external name '_p_AsyncBoth'; attribute (const);
  SyncBoth:             Integer; external name '_p_SyncBoth'; attribute (const);
  
  { Used in SetInputFocus, GetInputFocus }
  RevertToNone:         Integer; external name '_p_RevertToNone'; attribute (const);
  RevertToPointerRoot:  Integer; external name '_p_RevertToPointerRoot'; attribute (const);
  RevertToParent:       Integer; external name '_p_RevertToParent'; attribute (const);
  
  {@subsection ERROR CODES }
  
  Success:              Integer; external name '_p_Success'; attribute (const);
  BadRequest:           Integer; external name '_p_BadRequest'; attribute (const);
  BadValue:             Integer; external name '_p_BadValue'; attribute (const);
  BadWindow:            Integer; external name '_p_BadWindow'; attribute (const);
  BadPixmap:            Integer; external name '_p_BadPixmap'; attribute (const);
  BadAtom:              Integer; external name '_p_BadAtom'; attribute (const);
  BadCursor:            Integer; external name '_p_BadCursor'; attribute (const);
  BadFont:              Integer; external name '_p_BadFont'; attribute (const);
  BadMatch:             Integer; external name '_p_BadMatch'; attribute (const);
  BadDrawable:          Integer; external name '_p_BadDrawable'; attribute (const);
  BadAccess:            Integer; external name '_p_BadAccess'; attribute (const);
  BadAlloc:             Integer; external name '_p_BadAlloc'; attribute (const);
  BadColor:             Integer; external name '_p_BadColor'; attribute (const);
  BadGC:                Integer; external name '_p_BadGC'; attribute (const);
  BadIDChoice:          Integer; external name '_p_BadIDChoice'; attribute (const);
  BadName:              Integer; external name '_p_BadName'; attribute (const);
  BadLength:            Integer; external name '_p_BadLength'; attribute (const);
  BadImplementation:    Integer; external name '_p_BadImplementation'; attribute (const);
  FirstExtensionError:  Integer; external name '_p_FirstExtensionError'; attribute (const);
  LastExtensionError:   Integer; external name '_p_LastExtensionError'; attribute (const);
  
  {@subsection WINDOW DEFINITIONS }
  { Window classes used by CreateWindow }
  InputOutput:          Integer; external name '_p_InputOutput'; attribute (const);
  InputOnly:            Integer; external name '_p_InputOnly'; attribute (const);
  
  { Window attributes for CreateWindow and ChangeWindowAttributes }
  CWBackPixmap:         Integer; external name '_p_CWBackPixmap'; attribute (const);
  CWBackPixel:          Integer; external name '_p_CWBackPixel'; attribute (const);
  CWBorderPixmap:       Integer; external name '_p_CWBorderPixmap'; attribute (const);
  CWBorderPixel:        Integer; external name '_p_CWBorderPixel'; attribute (const);
  CWBitGravity:         Integer; external name '_p_CWBitGravity'; attribute (const);
  CWWinGravity:         Integer; external name '_p_CWWinGravity'; attribute (const);
  CWBackingStore:       Integer; external name '_p_CWBackingStore'; attribute (const);
  CWBackingPlanes:      Integer; external name '_p_CWBackingPlanes'; attribute (const);
  CWBackingPixel:       Integer; external name '_p_CWBackingPixel'; attribute (const);
  CWOverrideRedirect:   Integer; external name '_p_CWOverrideRedirect'; attribute (const);
  CWSaveUnder:          Integer; external name '_p_CWSaveUnder'; attribute (const);
  CWEventMask:          Integer; external name '_p_CWEventMask'; attribute (const);
  CWDontPropagate:      Integer; external name '_p_CWDontPropagate'; attribute (const);
  CWColormap:           Integer; external name '_p_CWColormap'; attribute (const);
  CWCursor:             Integer; external name '_p_CWCursor'; attribute (const);
  
  { ConfigureWindow structure }
  CWX:                  Integer; external name '_p_CWX'; attribute (const);
  CWY:                  Integer; external name '_p_CWY'; attribute (const);
  CWWidth:              Integer; external name '_p_CWWidth'; attribute (const);
  CWHeight:             Integer; external name '_p_CWHeight'; attribute (const);
  CWBorderWidth:        Integer; external name '_p_CWBorderWidth'; attribute (const);
  CWSibling:            Integer; external name '_p_CWSibling'; attribute (const);
  CWStackMode:          Integer; external name '_p_CWStackMode'; attribute (const);
  
  { Bit Gravity }
  ForgetGravity:        Integer; external name '_p_ForgetGravity'; attribute (const);
  NorthWestGravity:     Integer; external name '_p_NorthWestGravity'; attribute (const);
  NorthGravity:         Integer; external name '_p_NorthGravity'; attribute (const);
  NorthEastGravity:     Integer; external name '_p_NorthEastGravity'; attribute (const);
  WestGravity:          Integer; external name '_p_WestGravity'; attribute (const);
  CenterGravity:        Integer; external name '_p_CenterGravity'; attribute (const);
  EastGravity:          Integer; external name '_p_EastGravity'; attribute (const);
  SouthWestGravity:     Integer; external name '_p_SouthWestGravity'; attribute (const);
  SouthGravity:         Integer; external name '_p_SouthGravity'; attribute (const);
  SouthEastGravity:     Integer; external name '_p_SouthEastGravity'; attribute (const);
  StaticGravity:        Integer; external name '_p_StaticGravity'; attribute (const);

  { Window gravity + bit gravity above }
  UnmapGravity:         Integer; external name '_p_UnmapGravity'; attribute (const);

  { Used in CreateWindow for backing-store hint }
  NotUseful:            Integer; external name '_p_NotUseful'; attribute (const);
  WhenMapped:           Integer; external name '_p_WhenMapped'; attribute (const);
  Always:               Integer; external name '_p_Always'; attribute (const);

  { Used in GetWindowAttributes reply }
  IsUnmapped:           Integer; external name '_p_IsUnmapped'; attribute (const);
  IsUnviewable:         Integer; external name '_p_IsUnviewable'; attribute (const);
  IsViewable:           Integer; external name '_p_IsViewable'; attribute (const);
  
  { Used in ChangeSaveSet }
  SetModeInsert:        Integer; external name '_p_SetModeInsert'; attribute (const);
  SetModeDelete:        Integer; external name '_p_SetModeDelete'; attribute (const);
  
  { Used in ChangeCloseDownMode }
  DestroyAll:           Integer; external name '_p_DestroyAll'; attribute (const);
  RetainPermanent:      Integer; external name '_p_RetainPermanent'; attribute (const);
  RetainTemporary:      Integer; external name '_p_RetainTemporary'; attribute (const);
  
  { Window stacking method (in configureWindow)  }
  Above:                Integer; external name '_p_Above'; attribute (const);
  Below:                Integer; external name '_p_Below'; attribute (const);
  TopIf:                Integer; external name '_p_TopIf'; attribute (const);
  BottomIf:             Integer; external name '_p_BottomIf'; attribute (const);
  Opposite:             Integer; external name '_p_Opposite'; attribute (const);
  
  { Circulation direction }
  RaiseLowest:          Integer; external name '_p_RaiseLowest'; attribute (const);
  LowerHighest:         Integer; external name '_p_LowerHighest'; attribute (const);
  
  { Property modes }
  PropModeReplace:      Integer; external name '_p_PropModeReplace'; attribute (const);
  PropModePrepend:      Integer; external name '_p_PropModePrepend'; attribute (const);
  PropModeAppend:       Integer; external name '_p_PropModeAppend'; attribute (const);
  
  {@subsection GRAPHICS DEFINITIONS }
  { graphics functions, as in GC.alu }
  GXclear:              Integer; external name '_p_GXclear'; attribute (const);
  GXand:                Integer; external name '_p_GXand'; attribute (const);
  GXandReverse:         Integer; external name '_p_GXandReverse'; attribute (const);
  GXcopy:               Integer; external name '_p_GXcopy'; attribute (const);
  GXandInverted:        Integer; external name '_p_GXandInverted'; attribute (const);
  GXnoop:               Integer; external name '_p_GXnoop'; attribute (const);
  GXxor:                Integer; external name '_p_GXxor'; attribute (const);
  GXor:                 Integer; external name '_p_GXor'; attribute (const);
  GXnor:                Integer; external name '_p_GXnor'; attribute (const);
  GXequiv:              Integer; external name '_p_GXequiv'; attribute (const);
  GXinvert:             Integer; external name '_p_GXinvert'; attribute (const);
  GXorReverse:          Integer; external name '_p_GXorReverse'; attribute (const);
  GXcopyInverted:       Integer; external name '_p_GXcopyInverted'; attribute (const);
  GXorInverted:         Integer; external name '_p_GXorInverted'; attribute (const);
  GXnand:               Integer; external name '_p_GXnand'; attribute (const);
  GXset:                Integer; external name '_p_GXset'; attribute (const);
  
  { LineStyle }
  LineSolid:            Integer; external name '_p_LineSolid'; attribute (const);
  LineOnOffDash:        Integer; external name '_p_LineOnOffDash'; attribute (const);
  LineDoubleDash:       Integer; external name '_p_LineDoubleDash'; attribute (const);
  
  { capStyle }
  CapNotLast:           Integer; external name '_p_CapNotLast'; attribute (const);
  CapButt:              Integer; external name '_p_CapButt'; attribute (const);
  CapRound:             Integer; external name '_p_CapRound'; attribute (const);
  CapProjecting:        Integer; external name '_p_CapProjecting'; attribute (const);

  { joinStyle }
  JoinMiter:            Integer; external name '_p_JoinMiter'; attribute (const);
  JoinRound:            Integer; external name '_p_JoinRound'; attribute (const);
  JoinBevel:            Integer; external name '_p_JoinBevel'; attribute (const);
  
  { fillStyle }
  FillSolid:            Integer; external name '_p_FillSolid'; attribute (const);
  FillTiled:            Integer; external name '_p_FillTiled'; attribute (const);
  FillStippled:         Integer; external name '_p_FillStippled'; attribute (const);
  FillOpaqueStippled:   Integer; external name '_p_FillOpaqueStippled'; attribute (const);
  
  { fillRule }
  EvenOddRule:          Integer; external name '_p_EvenOddRule'; attribute (const);
  WindingRule:          Integer; external name '_p_WindingRule'; attribute (const);

  { subwindow mode }
  ClipByChildren:       Integer; external name '_p_ClipByChildren'; attribute (const);
  IncludeInferiors:     Integer; external name '_p_IncludeInferiors'; attribute (const);

  { SetClipRectangles ordering }
  Unsorted:             Integer; external name '_p_Unsorted'; attribute (const);
  YSorted:              Integer; external name '_p_YSorted'; attribute (const);
  YXSorted:             Integer; external name '_p_YXSorted'; attribute (const);
  YXBanded:             Integer; external name '_p_YXBanded'; attribute (const);

  { CoordinateMode for drawing routines }
  CoordModeOrigin:      Integer; external name '_p_CoordModeOrigin'; attribute (const);
  CoordModePrevious:    Integer; external name '_p_CoordModePrevious'; attribute (const);

  { Polygon shapes }
  Complex:              Integer; external name '_p_Complex'; attribute (const);
  Nonconvex:            Integer; external name '_p_Nonconvex'; attribute (const);
  Convex:               Integer; external name '_p_Convex'; attribute (const);

  { Arc modes for PolyFillArc }
  ArcChord:             Integer; external name '_p_ArcChord'; attribute (const);
  ArcPieSlice:          Integer; external name '_p_ArcPieSlice'; attribute (const);

  { GC components: masks used in CreateGC, CopyGC, ChangeGC, OR'ed into
    GC.stateChanges }
  GCFunction:           Integer; external name '_p_GCFunction'; attribute (const);
  GCPlaneMask:          Integer; external name '_p_GCPlaneMask'; attribute (const);
  GCForeground:         Integer; external name '_p_GCForeground'; attribute (const);
  GCBackground:         Integer; external name '_p_GCBackground'; attribute (const);
  GCLineWidth:          Integer; external name '_p_GCLineWidth'; attribute (const);
  GCLineStyle:          Integer; external name '_p_GCLineStyle'; attribute (const);
  GCCapStyle:           Integer; external name '_p_GCCapStyle'; attribute (const);
  GCJoinStyle:          Integer; external name '_p_GCJoinStyle'; attribute (const);
  GCFillStyle:          Integer; external name '_p_GCFillStyle'; attribute (const);
  GCFillRule:           Integer; external name '_p_GCFillRule'; attribute (const);
  GCTile:               Integer; external name '_p_GCTile'; attribute (const);
  GCStipple:            Integer; external name '_p_GCStipple'; attribute (const);
  GCTileStipXOrigin:    Integer; external name '_p_GCTileStipXOrigin'; attribute (const);
  GCTileStipYOrigin:    Integer; external name '_p_GCTileStipYOrigin'; attribute (const);
  GCFont:               Integer; external name '_p_GCFont'; attribute (const);
  GCSubwindowMode:      Integer; external name '_p_GCSubwindowMode'; attribute (const);
  GCGraphicsExposures:  Integer; external name '_p_GCGraphicsExposures'; attribute (const);
  GCClipXOrigin:        Integer; external name '_p_GCClipXOrigin'; attribute (const);
  GCClipYOrigin:        Integer; external name '_p_GCClipYOrigin'; attribute (const);
  GCClipMask:           Integer; external name '_p_GCClipMask'; attribute (const);
  GCDashOffset:         Integer; external name '_p_GCDashOffset'; attribute (const);
  GCDashList:           Integer; external name '_p_GCDashList'; attribute (const);
  GCArcMode:            Integer; external name '_p_GCArcMode'; attribute (const);
  GCLastBit:            Integer; external name '_p_GCLastBit'; attribute (const);

  {@subsection FONTS }
  { used in QueryFont -- draw direction }
  FontLeftToRight:      Integer; external name '_p_FontLeftToRight'; attribute (const);
  FontRightToLeft:      Integer; external name '_p_FontRightToLeft'; attribute (const);
  FontChange:           Integer; external name '_p_FontChange'; attribute (const);
  
  {@subsection IMAGING }
  { ImageFormat -- PutImage, GetImage }
  XYBitmap:             Integer; external name '_p_XYBitmap'; attribute (const);
  XYPixmap:             Integer; external name '_p_XYPixmap'; attribute (const);
  ZPixmap:              Integer; external name '_p_ZPixmap'; attribute (const);
  
  {@subsection COLOR MAP STUFF }
  { For CreateColormap }
  AllocNone:            Integer; external name '_p_AllocNone'; attribute (const);
  AllocAll:             Integer; external name '_p_AllocAll'; attribute (const);

  { Flags used in StoreNamedColor, StoreColors }
  DoRed:                Integer; external name '_p_DoRed'; attribute (const);
  DoGreen:              Integer; external name '_p_DoGreen'; attribute (const);
  DoBlue:               Integer; external name '_p_DoBlue'; attribute (const);

  {@subsection CURSOR STUFF }
  { QueryBestSize Class }
  CursorShape:          Integer; external name '_p_CursorShape'; attribute (const);
  TileShape:            Integer; external name '_p_TileShape'; attribute (const);
  StippleShape:         Integer; external name '_p_StippleShape'; attribute (const);

  {@subsection KEYBOARD/POINTER STUFF }
  AutoRepeatModeOff:    Integer; external name '_p_AutoRepeatModeOff'; attribute (const);
  AutoRepeatModeOn:     Integer; external name '_p_AutoRepeatModeOn'; attribute (const);
  AutoRepeatModeDefault:Integer; external name '_p_AutoRepeatModeDefault'; attribute (const);
  LedModeOff:           Integer; external name '_p_LedModeOff'; attribute (const);
  LedModeOn:            Integer; external name '_p_LedModeOn'; attribute (const);

  { masks for ChangeKeyboardControl }
  KBKeyClickPercent:    Integer; external name '_p_KBKeyClickPercent'; attribute (const);
  KBBellPercent:        Integer; external name '_p_KBBellPercent'; attribute (const);
  KBBellPitch:          Integer; external name '_p_KBBellPitch'; attribute (const);
  KBBellDuration:       Integer; external name '_p_KBBellDuration'; attribute (const);
  KBLed:                Integer; external name '_p_KBLed'; attribute (const);
  KBLedMode:            Integer; external name '_p_KBLedMode'; attribute (const);
  KBKey:                Integer; external name '_p_KBKey'; attribute (const);
  KBAutoRepeatMode:     Integer; external name '_p_KBAutoRepeatMode'; attribute (const);
  MappingSuccess:       Integer; external name '_p_MappingSuccess'; attribute (const);
  MappingBusy:          Integer; external name '_p_MappingBusy'; attribute (const);
  MappingFailed:        Integer; external name '_p_MappingFailed'; attribute (const);
  MappingModifier:      Integer; external name '_p_MappingModifier'; attribute (const);
  MappingKeyboard:      Integer; external name '_p_MappingKeyboard'; attribute (const);
  MappingPointer:       Integer; external name '_p_MappingPointer'; attribute (const);

  {@subsection SCREEN SAVER STUFF }
  DontPreferBlanking:   Integer; external name '_p_DontPreferBlanking'; attribute (const);
  PreferBlanking:       Integer; external name '_p_PreferBlanking'; attribute (const);
  DefaultBlanking:      Integer; external name '_p_DefaultBlanking'; attribute (const);
  DisableScreenSaver:   Integer; external name '_p_DisableScreenSaver'; attribute (const);
  DisableScreenInterval:    Integer; external name '_p_DisableScreenInterval'; attribute (const);
  DontAllowExposures:   Integer; external name '_p_DontAllowExposures'; attribute (const);
  AllowExposures:       Integer; external name '_p_AllowExposures'; attribute (const);
  DefaultExposures:     Integer; external name '_p_DefaultExposures'; attribute (const);

  { for ForceScreenSaver }
  ScreenSaverReset:     Integer; external name '_p_ScreenSaverReset'; attribute (const);
  ScreenSaverActive:    Integer; external name '_p_ScreenSaverActive'; attribute (const);

  {@subsection HOSTS AND CONNECTIONS }
  { for ChangeHosts }
  HostInsert:           Integer; external name '_p_HostInsert'; attribute (const);
  HostDelete:           Integer; external name '_p_HostDelete'; attribute (const);

  { for ChangeAccessControl }
  EnableAccess:         Integer; external name '_p_EnableAccess'; attribute (const);
  DisableAccess:        Integer; external name '_p_DisableAccess'; attribute (const);

  { Display classes  used in opening the connection }
  StaticGray:           Integer; external name '_p_StaticGray'; attribute (const);
  GrayScale:            Integer; external name '_p_GrayScale'; attribute (const);
  StaticColor:          Integer; external name '_p_StaticColor'; attribute (const);
  PseudoColor:          Integer; external name '_p_PseudoColor'; attribute (const);
  TrueColor:            Integer; external name '_p_TrueColor'; attribute (const);
  DirectColor:          Integer; external name '_p_DirectColor'; attribute (const);

  { Byte order  used in imageByteOrder and bitmapBitOrder }
  LSBFirst:             Integer; external name '_p_LSBFirst'; attribute (const);
  MSBFirst:             Integer; external name '_p_MSBFirst'; attribute (const);

{@section Consts from Xlib.h}
{ Please do not assign anything to these identifies. They should
be treated as constants }
var
  XTrue:                Integer; external name '_p_True'; attribute (const);
  XFalse:               Integer; external name '_p_False'; attribute (const);
  QueuedAlready:        Integer; external name '_p_QueuedAlready'; attribute (const);
  QueuedAfterReading:   Integer; external name '_p_QueuedAfterReading'; attribute (const);
  QueuedAfterFlush:     Integer; external name '_p_QueuedAfterFlush'; attribute (const);
  XIMPreeditArea:       Integer; external name '_p_XIMPreeditArea'; attribute (const);
  XIMPreeditCallbacks:  Integer; external name '_p_XIMPreeditCallbacks'; attribute (const);
  XIMPreeditPosition:   Integer; external name '_p_XIMPreeditPosition'; attribute (const);
  XIMPreeditNothing:    Integer; external name '_p_XIMPreeditNothing'; attribute (const);
  XIMPreeditNone:       Integer; external name '_p_XIMPreeditNone'; attribute (const);
  XIMStatusArea:        Integer; external name '_p_XIMStatusArea'; attribute (const);
  XIMStatusCallbacks:   Integer; external name '_p_XIMStatusCallbacks'; attribute (const);
  XIMStatusNothing:     Integer; external name '_p_XIMStatusNothing'; attribute (const);
  XIMStatusNone:        Integer; external name '_p_XIMStatusNone'; attribute (const);
  XBufferOverflow:      Integer; external name '_p_XBufferOverflow'; attribute (const);
  XLookupNone:          Integer; external name '_p_XLookupNone'; attribute (const);
  XLookupChars:         Integer; external name '_p_XLookupChars'; attribute (const);
  XLookupKeySym:        Integer; external name '_p_XLookupKeySym'; attribute (const);
  XLookupBoth:          Integer; external name '_p_XLookupBoth'; attribute (const);
  XIMReverse:           Integer; external name '_p_XIMReverse'; attribute (const);
  XIMUnderline:         Integer; external name '_p_XIMUnderline'; attribute (const);
  XIMHighlight:         Integer; external name '_p_XIMHighlight'; attribute (const);
  XIMPrimary:           Integer; external name '_p_XIMPrimary'; attribute (const);
  XIMSecondary:         Integer; external name '_p_XIMSecondary'; attribute (const);
  XIMTertiary:          Integer; external name '_p_XIMTertiary'; attribute (const);
  XIMVisibleToForward:  Integer; external name '_p_XIMVisibleToForward'; attribute (const);
  XIMVisibleToBackword: Integer; external name '_p_XIMVisibleToBackword'; attribute (const);
  XIMVisibleToCenter:   Integer; external name '_p_XIMVisibleToCenter'; attribute (const);
  XNRequiredCharSet:    PChar;   external name '_p_XNRequiredCharSet'; attribute (const);
  XNQueryOrientation:   PChar;   external name '_p_XNQueryOrientation'; attribute (const);
  XNBaseFontName:       PChar;   external name '_p_XNBaseFontName'; attribute (const);
  XNOMAutomatic:        PChar;   external name '_p_XNOMAutomatic'; attribute (const);
  XNMissingCharSet:     PChar;   external name '_p_XNMissingCharSet'; attribute (const);
  XNDefaultString:      PChar;   external name '_p_XNDefaultString'; attribute (const);
  XNOrientation:        PChar;   external name '_p_XNOrientation'; attribute (const);
  XNDirectionalDependentDrawing:PChar; external name '_p_XNDirectionalDependentDrawing'; attribute (const);
  XNContextualDrawing:  PChar; external name '_p_XNContextualDrawing'; attribute (const);
  XNFontInfo:           PChar; external name '_p_XNFontInfo'; attribute (const);
  XNVaNestedList:       PChar; external name '_p_XNVaNestedList'; attribute (const);
  XNQueryInputStyle:    PChar; external name '_p_XNQueryInputStyle'; attribute (const);
  XNClientWindow:       PChar; external name '_p_XNClientWindow'; attribute (const);
  XNInputStyle:         PChar; external name '_p_XNInputStyle'; attribute (const);
  XNFocusWindow:        PChar; external name '_p_XNFocusWindow'; attribute (const);
  XNResourceName:       PChar; external name '_p_XNResourceName'; attribute (const);
  XNResourceClass:      PChar; external name '_p_XNResourceClass'; attribute (const);
  XNGeometryCallback:   PChar; external name '_p_XNGeometryCallback'; attribute (const);
  XNDestroyCallback:    PChar; external name '_p_XNDestroyCallback'; attribute (const);
  XNFilterEvents:       PChar; external name '_p_XNFilterEvents'; attribute (const);
  XNPreeditStartCallback:       PChar; external name '_p_XNPreeditStartCallback'; attribute (const);
  XNPreeditDoneCallback:        PChar; external name '_p_XNPreeditDoneCallback'; attribute (const);
  XNPreeditDrawCallback:        PChar; external name '_p_XNPreeditDrawCallback'; attribute (const);
  XNPreeditCaretCallback:       PChar; external name '_p_XNPreeditCaretCallback'; attribute (const);
  XNPreeditStateNotifyCallback: PChar; external name '_p_XNPreeditStateNotifyCallback'; attribute (const);
  XNPreeditAttributes:          PChar; external name '_p_XNPreeditAttributes'; attribute (const);
  XNStatusStartCallback:        PChar; external name '_p_XNStatusStartCallback'; attribute (const);
  XNStatusDoneCallback: PChar; external name '_p_XNStatusDoneCallback'; attribute (const);
  XNStatusDrawCallback: PChar; external name '_p_XNStatusDrawCallback'; attribute (const);
  XNStatusAttributes:   PChar; external name '_p_XNStatusAttributes'; attribute (const);
  XNArea:               PChar; external name '_p_XNArea'; attribute (const);
  XNAreaNeeded:         PChar; external name '_p_XNAreaNeeded'; attribute (const);
  XNSpotLocation:       PChar; external name '_p_XNSpotLocation'; attribute (const);
  XNColormap:           PChar; external name '_p_XNColormap'; attribute (const);
  XNStdColormap:        PChar; external name '_p_XNStdColormap'; attribute (const);
  XNForeground:         PChar; external name '_p_XNForeground'; attribute (const);
  XNBackground:         PChar; external name '_p_XNBackground'; attribute (const);
  XNBackgroundPixmap:   PChar; external name '_p_XNBackgroundPixmap'; attribute (const);
  XNFontSet:            PChar; external name '_p_XNFontSet'; attribute (const);
  XNLineSpace:          PChar; external name '_p_XNLineSpace'; attribute (const);
  XNCursor:             PChar; external name '_p_XNCursor'; attribute (const);
  XNQueryIMValuesList:  PChar; external name '_p_XNQueryIMValuesList'; attribute (const);
  XNQueryICValuesList:  PChar; external name '_p_XNQueryICValuesList'; attribute (const);
  XNVisiblePosition:    PChar; external name '_p_XNVisiblePosition'; attribute (const);
  XNR6PreeditCallback:  PChar; external name '_p_XNR6PreeditCallback'; attribute (const);
  XNStringConversionCallback:   PChar; external name '_p_XNStringConversionCallback'; attribute (const);
  XNStringConversion:   PChar; external name '_p_XNStringConversion'; attribute (const);
  XNResetState:         PChar; external name '_p_XNResetState'; attribute (const);
  XNHotKey:             PChar; external name '_p_XNHotKey'; attribute (const);
  XNHotKeyState:        PChar; external name '_p_XNHotKeyState'; attribute (const);
  XNPreeditState:       PChar; external name '_p_XNPreeditState'; attribute (const);
  XNSeparatorofNestedList:      PChar; external name '_p_XNSeparatorofNestedList'; attribute (const);
  XIMPreeditUnKnown:    Integer; external name '_p_XIMPreeditUnKnown'; attribute (const);
  XIMPreeditEnable:     Integer; external name '_p_XIMPreeditEnable'; attribute (const);
  XIMPreeditDisable:    Integer; external name '_p_XIMPreeditDisable'; attribute (const);
  XIMInitialState:      Integer; external name '_p_XIMInitialState'; attribute (const);
  XIMPreserveState:     Integer; external name '_p_XIMPreserveState'; attribute (const);
  XIMStringConversionLeftEdge:  Integer; external name '_p_XIMStringConversionLeftEdge'; attribute (const);
  XIMStringConversionRightEdge: Integer; external name '_p_XIMStringConversionRightEdge'; attribute (const);
  XIMStringConversionTopEdge:   Integer; external name '_p_XIMStringConversionTopEdge'; attribute (const);
  XIMStringConversionBottomEdge:Integer; external name '_p_XIMStringConversionBottomEdge'; attribute (const);
  XIMStringConversionConcealed: Integer; external name '_p_XIMStringConversionConcealed'; attribute (const);
  XIMStringConversionWrapped:   Integer; external name '_p_XIMStringConversionWrapped'; attribute (const);
  XIMStringConversionBuffer:    Integer; external name '_p_XIMStringConversionBuffer'; attribute (const);
  XIMStringConversionLine:      Integer; external name '_p_XIMStringConversionLine'; attribute (const);
  XIMStringConversionWord:      Integer; external name '_p_XIMStringConversionWord'; attribute (const);
  XIMStringConversionChar:      Integer; external name '_p_XIMStringConversionChar'; attribute (const);
  XIMStringConversionSubstitution:  Integer; external name '_p_XIMStringConversionSubstitution'; attribute (const);
  XIMStringConversionRetrieval: Integer; external name '_p_XIMStringConversionRetrieval'; attribute (const);
  XIMHotKeyStateON:             Integer; external name '_p_XIMHotKeyStateON'; attribute (const);
  XIMHotKeyStateOFF:            Integer; external name '_p_XIMHotKeyStateOFF'; attribute (const);

  { consts from XOrientation }
  XOMOrientation_LTR_TTB: Integer;  external name '_p_XOMOrientation_LTR_TTB'; attribute (const);
  XOMOrientation_RTL_TTB: Integer;  external name '_p_XOMOrientation_RTL_TTB'; attribute (const);
  XOMOrientation_TTB_LTR: Integer;  external name '_p_XOMOrientation_TTB_LTR'; attribute (const);
  XOMOrientation_TTB_RTL: Integer;  external name '_p_XOMOrientation_TTB_RTL'; attribute (const);
  XOMOrientation_Context: Integer;  external name '_p_XOMOrientation_Context'; attribute (const);

  { consts from XIMCaretDirection }
  XIMForwardChar:         Integer;  external name '_p_XIMForwardChar'; attribute (const);
  XIMBackwardChar:        Integer;  external name '_p_XIMBackwardChar'; attribute (const);
  XIMForwardWord:         Integer;  external name '_p_XIMForwardWord'; attribute (const);
  XIMBackwardWord:        Integer;  external name '_p_XIMForwardWord'; attribute (const);
  XIMCaretUp:             Integer;  external name '_p_XIMCaretUp'; attribute (const);
  XIMCaretDown:           Integer;  external name '_p_XIMCaretDown'; attribute (const);
  XIMNextLine:            Integer;  external name '_p_XIMNextLine'; attribute (const);
  XIMPreviousLine:        Integer;  external name '_p_XIMPreviousLine'; attribute (const);
  XIMLineStart:           Integer;  external name '_p_XIMLineStart'; attribute (const);
  XIMLineEnd:             Integer;  external name '_p_XIMLineEnd'; attribute (const);
  XIMAbsolutePosition:    Integer;  external name '_p_XIMAbsolutePosition'; attribute (const);
  XIMDontChange:          Integer;  external name '_p_XIMDontChange'; attribute (const);

  { consts from XIMCaretStyle }
  XIMIsInvisible:         Integer;  external name '_p_XIMIsInvisible'; attribute (const);
  XIMIsPrimary:           Integer;  external name '_p_XIMIsPrimary'; attribute (const);
  XIMIsSecondary:         Integer;  external name '_p_XIMIsSecondary'; attribute (const);

  { consts from XIMStatusDataType }
  XIMTextType:            Integer;  external name '_p_XIMTextType'; attribute (const);
  XIMBitmapType:          Integer;  external name '_p_XIMBitmapType'; attribute (const);

{@section Types from Xlib.h}
type
  TBool = Integer;
  TStatus = TBool;
  PXPointer = ^TXPointer;
  TXPointer = ^ByteInt;
  PWCharT = ^TWCharT;  { Wide Character }
  TWCharT = MedCard;
  TXIMStyle = MedCard;
  PXIMFeedback = ^TXIMFeedback;
  TXIMFeedback = MedCard;
  TXIMPreeditState = MedCard;
  TXIMStringConversionPosition = ShortCard;
  TXIMStringConversionType = ShortCard;
  TXIMResetState = MedCard;
  PXIMStringConversionFeedback = ^TXIMStringConversionFeedback;
  TXIMStringConversionFeedback = MedCard;
  TXIMStringConversionOperation = ShortCard;
  TXIMHotKeyState = MedCard;

  { XExtData }
  PXExtData = ^TXExtData;
  PFreePrivateProc = ^function (Extension: PXExtData): Integer;
  TXExtData = record
    Number: Integer;
    Next: PXExtData;
    FreePrivate: PFreePrivateProc;
    PrivateData: TXPointer
  end;
  
  { XExtCodes }
  PXExtCodes = ^TXExtCodes;
  TXExtCodes = record
    Extension, MajorOpcode, FirstEvent, FirstError: Integer
  end;
  
  { XPixmapFormatValues }
  PXPixmapFormatValues = ^TXPixmapFormatValues;
  TXPixmapFormatValues = record
    Depth, BitsPerPixel, ScanlinePad: Integer
  end;  
  
  { XGCValues }
  PXGCValues = ^TXGCValues;
  TXGCValues = record
    FunctionE: Integer;  {!! Different name }
    PlaneMask, Foreground, Background: MedCard;
    LineWidth, LineStyle: Integer;
    CapStyle: Integer;
    JoinStyle, FillStyle, FillRule: Integer;
    ArcMode: Integer;
    Tile, Stripple: TPixmap;
    TsXOrigin, TsYOrigin: Integer;
    Font: TFont;
    SubwindowMode: Integer;
    GraphicsExposures: TBool;
    ClipXOrigin, ClipYOrigin: Integer;
    ClipMask: TPixmap;
    DashOffset: Integer;
    Dashes: Char
  end;

  { GC* should be treated as opaque }
  PGC = Pointer;
  
  { Visual }
  PVisual = ^TVisual;
  TVisual = record
    ExtData: PXExtData;
    VisualID: TVisualID;
    Klass: Integer;  {!! Different Name }
    RedMask, GreenMask, BlueMask: MedCard;
    BitsPerRGB: Integer;
    MapEntries: Integer
  end;

  { Depth }
const
  VisualsArrayMax = High (Integer) div SizeOf (TVisual);
type
  PDepth = ^TDepth;
  PVisualsArray = ^TVisualsArray;
  TVisualsArray = array [0 .. VisualsArrayMax] of TVisual;
  TDepth = record
    Depth: Integer;
    NVisuals: Integer;
    Visuals: PVisualsArray;  
  end;

  { Display should be treated as opaque.
    The underlaying record is private to X, so I did not
    interface it. }
  PDisplay = Pointer;

  { Screen }
const
  DepthsArrayMax = High (Integer) div SizeOf (TDepth);
type
  PScreen = ^TScreen;
  PDepthsArray = ^TDepthsArray;
  TDepthsArray = array [0 .. DepthsArrayMax] of TDepth;
  TScreen = record
    ExtData: PXExtData;
    Display: PDisplay;
    Root: TWindow;
    Width, Height: Integer;
    MWidth, MHeight: Integer;
    NDepths: Integer;
    Depths: PDepthsArray;  
    RootDepth: Integer;
    RootVisual: PVisual;
    DefaultGC: PGC;
    CMap: TColormap;
    WhitePixel, BlackPixel: MedCard;
    MaxMaps, MinMaps: Integer;
    BackingStore: Integer;
    SaveUnders: TBool;
    RootInputMask: MedInt
  end;

  { ScreenFormat }
  PScreenFormat = ^TScreenFormat;
  TScreenFormat = record
    ExtData: PXExtData;
    Depth, BitsPerPixel, ScanlinePad: Integer
  end;
  
  { XWindowAttributes }
  PXWindowAttributes = ^TXWindowAttributes;
  TXWindowAttributes = record
    x, y, Width, Height, BorderWidth, Depth: Integer;
    Visual: PVisual;
    Root: TWindow;
    Klass: Integer;  {!! Different Name }
    BitGravity, WinGravity, BackingStore: Integer;
    BackingPlanes, BackingPixel: MedCard;
    SaveUnder: TBool;
    Colormap: TColormap;
    MapInstalled: TBool;
    MapState: Integer;
    AllEventMasks, YourEventMask, DoNotPropagateMask: MedInt;
    OverrideRedirect: TBool;
    Screen: PScreen  { Back Pointer to correct Screen }
  end;
    
  { XSetWindowAttributes }
  PXSetWindowAttributes = ^TXSetWindowAttributes;
  TXSetWindowAttributes = record
    BackgroundPixmap: TPixmap;
    BackgroundPixel: MedCard;
    BorderPixmap: TPixmap;
    BorderPixel: MedCard;
    BitGravity, WinGravity: Integer;
    BackingStore: Integer;
    BackingPlanes, BackingPixel: MedCard;
    SaveUnder: TBool;
    EventMask, DoNotPropagateMask: MedInt;
    OverrideRedirect: TBool;
    Colormap: TColormap;
    Cursor: TCursor
  end;
  
  { XHostAddress }
  PXHostAddress = ^TXHostAddress;
  TXHostAddress = record
    Family, Length: Integer;
    Address: PChar
  end;

  { XImage }
  PXImage = ^TXImage;
  CreateImageProc = ^function (Display: PDisplay; Visual: PVisual;
    Depth: Cardinal; Format: Integer; Offset: Integer; Data: PChar;
    Width, Height: Cardinal; BitmapPad, BytesPerLine: Integer): PXImage;
  DestroyImageProc = ^function (img: PXImage): Integer;
  GetPixelProc = ^function (img: PXImage; x, y: Integer): MedCard;
  PutPixelProc = ^function (img: PXImage; x, y: Integer; c: MedCard): Integer;
  SubImageProc = ^function (img: PXImage; x, y: Integer; a, b: Cardinal): PXImage;
  AddPixelProc = ^function (img: PXImage; pix: MedInt): Integer;
  TXImageFuncs = record
    CreateImage: CreateImageProc;
    DestroyImage: DestroyImageProc;
    GetPixel: GetPixelProc;  
    PutPixel: PutPixelProc;
    SubImage: SubImageProc;
    AddPixel: AddPixelProc
  end;
  TXImage = record
    Width, Height, Offset: Integer;
    Format: Integer;
    Data: PChar;
    ByteOrder, BitmapUnit, BitmapBitOrder, BitmapPad,
      Depth, BytesPerLine, BytesPerPixel: Integer;
    RedMask, GreenMask, BlueMask: MedCard;
    ObData: TXPointer;
    f: TXImageFuncs
  end;

  { XWindowChanges }
  PXWindowChanges = ^TXWindowChanges;
  TXWindowChanges = record
    x, y, Width, Height, BorderWidth: Integer;
    Sibling: TWindow;
    StackMode: Integer
  end;

  { XColor }
  PXColor = ^TXColor;
  TXColor = record
    Pixel: MedCard;
    Red, Green, Blue: ShortCard;
    Flags, Pad: Char
  end;

  { XSegment }
  PXSegment = ^TXSegment;
  TXSegment = record
    x1, y1, x2, y2: Integer
  end;
  
  { XPoint }
  PXPoint = ^TXPoint;
  TXPoint = record
    x, y: Integer
  end;
  
  { XRectangle }
  PXRectangle = ^TXRectangle;
  TXRectangle = record
    x, y: ShortInt;
    Width, Height: ShortCard
  end;

  { XArc }
  PXArc = ^TXArc;
  TXArc = record
    x, y: ShortInt;
    Width, Height: ShortCard;
    Angle1, Angle2: ShortInt
  end;

  { XKeyboardControl }
  PXKeyboardControl = ^TXKeyboardControl;
  TXKeyboardControl = record
    KeyClickPercent, BellPercent, BellPitch, BellDuration,
      Led, LedMode, Key, AutoRepeatMode: Integer
  end;

  { XKeyboardState }
  PXKeyboardState = ^TXKeyboardState;
  TXKeyboardState = record
    KeyClickPercent, BellPercent: Integer;
    BellPitch, BellDuration: Cardinal;
    LedMask: MedCard; 
    GlobalAutoRepeat: Integer;
    AutoRepeats: array [0 .. 31] of Char
  end;

  { XTimeCoord }
  PXTimeCoord = ^TXTimeCoord;
  TXTimeCoord = record
    Time: TTime;
    x, y: ShortInt
  end;
  
  { XModifierKeymap }
const
  ModifierArrayMax = High (Integer) div SizeOf (TKeyCode);
type
  PModifierArray = ^TModifierArray;
  TModifierArray = array [0 .. ModifierArrayMax] of TKeyCode;
  PXModifierKeymap = ^TXModifierKeymap;
  TXModifierKeymap = record
    MaxKeyPerMod: Integer;
    Modifiermap: PModifierArray 
  end;
  
  { XKeyEvent }
  PXKeyEvent = ^TXKeyEvent;
  TXKeyEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window, Root, Subwindow: TWindow;
    Time: TTime;
    x, y, XRoot, YRoot: Integer;
    State, KeyCode: Cardinal;
    SameScreen: TBool
  end;
  
  { XKeyPressedEvent }
  PXKeyPressedEvent = ^TXKeyPressedEvent;
  TXKeyPressedEvent = TXKeyEvent;
  
  { XKeyReleasedEvent }
  PXKeyReleasedEvent = ^TXKeyReleasedEvent;
  TXKeyReleasedEvent = ^TXKeyEvent;
  
  { XButtonEvent }
  PXButtonEvent = ^TXButtonEvent;
  TXButtonEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window, Root, Subwindow: TWindow;
    Time: TTime;
    x, y, XRoot, YRoot: Integer;
    State, Button: Cardinal;
    SameScreen: TBool
  end;
  
  { XButtonPressedEvent }
  PXButtonPressedEvent = ^TXButtonPressedEvent;
  TXButtonPressedEvent = TXButtonEvent;
  
  { XButtonReleasedEvent }
  PXButtonReleasedEvent = ^TXButtonReleasedEvent;
  TXButtonReleasedEvent = TXButtonEvent;

  { XMotionEvent }
  PXMotionEvent = ^TXMotionEvent;
  TXMotionEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window, Root, Subwindow: TWindow;
    Time: TTime;
    x, y, XRoot, YRoot: Integer;
    State: Cardinal;
    IsHint: Char;
    SameScreen: TBool
  end;
  
  { XPointerMovedEvent }
  PXPointerMovedEvent = ^TXPointerMovedEvent;
  TXPointerMovedEvent = TXMotionEvent;

  { XCrossingEvent }
  PXCrossingEvent = ^TXCrossingEvent;
  TXCrossingEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window, Root, Subwindow: TWindow;
    Time: TTime;
    x, y, XRoot, YRoot: Integer;
    Mode, Detail: Integer;
    SameScreen: TBool;
    Focus: TBool;
    State: Cardinal
  end;
  
  { XEnterWindowEvent }
  PXEnterWindowEvent = ^TXEnterWindowEvent;
  TXEnterWindowEvent = TXCrossingEvent;
  
  { XLeaveWindowEvent }
  PXLeaveWindowEvent = ^TXLeaveWindowEvent;
  TXLeaveWindowEvent = TXCrossingEvent;
  
  { XFocusChangeEvent }
  PXFocusChangeEvent = ^TXFocusChangeEvent;
  TXFocusChangeEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    Mode, Detail: Integer
  end;
  
  { XFocusInEvent }
  PXFocusInEvent = ^TXFocusInEvent;
  TXFocusInEvent = TXFocusChangeEvent;
  
  { XFocusOutEvent }
  PXFocusOutEvent = ^TXFocusOutEvent;
  TXFocusOutEvent = TXFocusChangeEvent;
  
  { XKeymapEvent }
  PXKeymapEvent = ^TXKeymapEvent;
  TXKeymapEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    KeyVector: array [0 .. 31] of Char
  end;
  
  { XExposeEvent }
  PXExposeEvent = ^TXExposeEvent;
  TXExposeEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    x, y, Width, Height, Count: Integer
  end;

  { XGraphicsExposeEvent }
  PXGraphicsExposeEvent = ^TXGraphicsExposeEvent;
  TXGraphicsExposeEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Drawable: TDrawable;
    x, y, Width, Height, Count: Integer;
    MajorCode, MinorCode: Integer
  end;

  { XNoExposeEvent }
  PXNoExposeEvent = ^TXNoExposeEvent;
  TXNoExposeEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Drawable: TDrawable;
    MajorCode, MinorCode: Integer
  end;
  
  { XVisibilityEvent }
  PXVisibilityEvent = ^TXVisibilityEvent;
  TXVisibilityEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    State: Integer
  end;

  { XCreateWindowEvent }
  PXCreateWindowEvent = ^TXCreateWindowEvent;
  TXCreateWindowEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Parent, Window: TWindow;
    x, y, Width, Height: Integer;
    BorderWidth: Integer;
    OverrideRedirect: TBool
  end;
  
  { XDestroyWindowEvent }
  PXDestroyWindowEvent = ^TXDestroyWindowEvent;
  TXDestroyWindowEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow
  end;

  { XUnmapEvent }
  PXUnmapEvent = ^TXUnmapEvent;
  TXUnmapEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow;
    FromConfigure: TBool
  end;
  
  { XMapEvent }
  PXMapEvent = ^TXMapEvent;
  TXMapEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow;
    OverrideRedirect: TBool
  end;

  { XMapRequestEvent }
  PXMapRequestEvent = ^TXMapRequestEvent;
  TXMapRequestEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Parent, Window: TWindow
  end;

  { XReparentEvent }
  PXReparentEvent = ^TXReparentEvent;
  TXReparentEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window, Parent: TWindow;
    x, y: Integer;
    OverrideRedirect: TBool
  end;

  { XConfigureEvent }
  PXConfigureEvent = ^TXConfigureEvent;
  TXConfigureEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow;
    x, y, Width, Height: Integer;
    BorderWidth: Integer;
    Above: TWindow;
    OverrideRedirect: TBool
  end;

  { XGravityEvent }
  PXGravityEvent = ^TXGravityEvent;
  TXGravityEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow;
    x, y: Integer
  end;

  { XResizeRequestEvent }
  PXResizeRequestEvent = ^TXResizeRequestEvent;
  TXResizeRequestEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    Width, Height: Integer
  end;
  
  { XConfigureRequestEvent }
  PXConfigureRequestEvent = ^TXConfigureRequestEvent;
  TXConfigureRequestEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Parent, Window: TWindow;
    x, y, Width, Height: Integer;
    BorderWidth: Integer;
    Above: TWindow;
    Detail: Integer;
    ValueMask: MedCard
  end;
  
  { XCirculateEvent }
  PXCirculateEvent = ^TXCirculateEvent;
  TXCirculateEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Event, Window: TWindow;
    Place: Integer
  end;
  
  { XCirculateRequestEvent }
  PXCirculateRequestEvent = ^TXCirculateRequestEvent;
  TXCirculateRequestEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Parent, Window: TWindow;
    Place: Integer
  end;

  { XPropertyEvent }
  PXPropertyEvent = ^TXPropertyEvent;
  TXPropertyEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    Atom: TAtom;
    Time: TTime;
    State: Integer
  end;

  { XSelectionClearEvent }
  PXSelectionClearEvent = ^TXSelectionClearEvent;
  TXSelectionClearEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    Selection: TAtom;
    Time: TTime
  end;
  
  { XSelectionRequestEvent }
  PXSelectionRequestEvent = ^TXSelectionRequestEvent;
  TXSelectionRequestEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Owner, Requestor: TWindow;
    Selection, Target, TProperty: TAtom;  {!! Different Name }
    Time: TTime
  end;

  { XSelectionEvent }
  PXSelectionEvent = ^TXSelectionEvent;
  TXSelectionEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Requestor: TWindow;
    Selection, TTarget, TProperty: TAtom;  {!! Different Names }
    Time: TTime
  end;

  { XColormapEvent }
  PXColormapEvent = ^TXColormapEvent;
  TXColormapEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    ANew: TBool;  {!! Different Name }
    State: Integer
  end;
  
  { XClientMessageEvent }
  TXClientMessageEventData = record
    case Byte of
      0: (b: array [0 .. 19] of Char);
      1: (s: array [0 .. 9] of ShortInt);
      2: (l: array [0 .. 4] of MedInt);
  end;
  PXClientMessageEvent = ^TXClientMessageEvent;
  TXClientMessageEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    MessageType: TAtom;
    Format: Integer;
    Data: TXClientMessageEventData
  end;
    
  { XMappingEvent }
  PXMappingEvent = ^TXMappingEvent;
  TXMappingEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow;
    Request: Integer;
    FirstKeyCode: Integer;
    Count: Integer
  end;

  { XErrorEvent }
  PXErrorEvent = ^TXErrorEvent;
  TXErrorEvent = record
    EventType: Integer;  {!! Different Name }
    Display: PDisplay;
    ResourceId: TXID;
    Serial: MedCard;
    ErrorCode, RequestCode, MinorCode: Byte
  end;
  
  { XAnyEvent }
  PXAnyEvent = ^TXAnyEvent;
  TXAnyEvent = record
    EventType: Integer;  {!! Different Name }
    Serial: MedCard;
    SendEvent: TBool;
    Display: PDisplay;
    Window: TWindow
  end;
    
  { XEvent }
  PXEvent = ^TXEvent;
  TXEvent = record
    case Byte of
       1: (EventType: Integer);  { Must not be changed, First Element }
       2: (XAny: TXAnyEvent);
       3: (XKey: TXKeyEvent);
       4: (XButton: TXButtonEvent);
       5: (XMotion: TXMotionEvent);
       6: (XCrossing: TXCrossingEvent);
       7: (XFocus: TXFocusChangeEvent);
       8: (XExpose: TXExposeEvent);
       9: (XGraphicsExpose: TXExposeEvent);
      10: (XNoExpose: TXNoExposeEvent);
      11: (XVisibility: TXVisibilityEvent);
      12: (XCreateWindow: TXCreateWindowEvent);
      13: (XDestroyWindow: TXDestroyWindowEvent);
      14: (XUnMap: TXUnmapEvent);
      15: (XMap: TXMapEvent);
      16: (XMapRequest: TXMapRequestEvent);
      17: (XReparent: TXReparentEvent);
      18: (XConfigure: TXConfigureEvent);
      19: (XGravity: TXGravityEvent);
      20: (XResizeRequest: TXResizeRequestEvent);
      21: (XConfigureRequest: TXConfigureRequestEvent);
      22: (XCirculate: TXCirculateEvent);
      23: (XCirculateRequest: TXCirculateRequestEvent);
      24: (XProperty: TXPropertyEvent);
      25: (XSelectionClear: TXSelectionClearEvent);
      26: (XSelectionRequest: TXSelectionRequestEvent);
      27: (XSelection: TXSelectionEvent);
      28: (XColormap: TXColormapEvent);
      29: (XClient: TXClientMessageEvent);
      30: (XMapping: TXMappingEvent);
      31: (XError: TXErrorEvent);
      32: (XKeymap: TXKeymapEvent);
      33: (Pad: array [0 .. 23] of MedInt)
  end;

  { XCharStruct }
  PXCharStruct = ^TXCharStruct;
  TXCharStruct = record
    lBearing, rBearing, Width, Ascend, Descend: ShortInt;
    Attributes: ShortCard
  end;
  
  { XFontProp }
  PXFontProp = ^TXFontProp;
  TXFontProp = record
    Name: TAtom;
    Card32: MedCard  {!! Silly Name!!}
  end;
  
  { XFontStruct }
const
  MaxPropertiesArray = High (Integer) div SizeOf (TXFontProp);
type
  PPropertiesArray = ^TPropertiesArray;
  TPropertiesArray = array [0 .. MaxPropertiesArray] of TXFontProp;
  { @@ Should be an array?? }
  PPXFontStruct = ^PXFontStruct;
  PXFontStruct = ^TXFontStruct;
  TXFontStruct = record
    ExtData: PXExtData;
    FID: TFont;
    Direction, MinCharOrByte2, MaxCharOrByte2: Cardinal;
    MinByte1, MaxByte1: Cardinal;
    AllCharsExists: TBool;
    DefaultChar: Cardinal;
    NProperties: Integer;
    Properties: PPropertiesArray;  
    MinBounds, MaxBounds: TXCharStruct;
    PerChar: PXCharStruct;  { @@ Don't know what it is:-( }
    Ascend, Descent: Integer
  end;

  { XTextItem }
  PXTextItem = ^TXTextItem;
  TXTextItem = record
    Chars: PChar;  {!! Pointer to String }
    NChars, Delta: Integer;
    Font: TFont
  end;
  
  { XChar2b }
  PXChar2b = ^TXChar2b;
  TXChar2b = record
    Byte1, Byte2: Byte
  end;
  
  { XTextItem16 }
  PXTextItem16 = ^TXTextItem16;
  TXTextItem16 = record
    Chars: PXChar2b;  {!! Pointer to 2Byte Character }
    NChars, Delta: Integer;
    Font: TFont
  end;
  
  { XEDataObject }
  PXEDataObject = ^TXEDataObject;
  TXEDataObject = record
    case Byte of
      1: (Display: PDisplay);
      2: (GC: PGC);
      3: (Visual: PVisual);
      4: (Screen: PScreen);
      5: (PixmapFormat: PScreenFormat);
      6: (Font: PXFontStruct)
  end;

  { XFontSetExtents }
  PXFontSetExtents = ^TXFontSetExtents;
  TXFontSetExtents = record
    MaxIncExtent, MaxLogicalExtent: TXRectangle
  end;
  
  { XOM }
  PXOM = Pointer;  { Output Method }
  
  { XOC }
  PXOC = Pointer;  { Output Context }
  
  { XFontSet }
  PXFontSet = Pointer;
  
  { XmbTextItem }
  PXmbTextItem = ^TXmbTextItem;
  TXmbTextItem = record
    Chars: PChar;
    NChars, Delta: Integer;
    FontSet: PXFontSet
  end;

  { XwcTextItem }
  PXwcTextItem = ^TXwcTextItem;
  TXwcTextItem = record
    Chars: PWCharT;  {!! Array of Wide Chars (kind of String) }
    NChars, Delta: Integer;
    FontSet: PXFontSet
  end;

  { XOMCharSetList }
const
  MaxCharsetList = High (Integer) div SizeOf (PChar);
type
  PCharsetListArray = ^TCharsetListArray;
  TCharsetListArray = array [0 .. MaxCharsetList] of PChar;
  PXOMCharSetList = ^TXOMCharSetList;
  TXOMCharSetList = record
    CharsetCount: Integer;
    CharsetList: PCharsetListArray
  end;

  { XOrientation, see XOMOrientation_* in consts section }
  PXOrientation =^TXOrientation;
  TXOrientation = Integer;

  { XOMOrientation }
  PXOMOrientation = ^TXOMOrientation;
  TXOMOrientation = record
    NumOrientation: Integer;
    Orientation: PXOrientation
  end;

  { XOMFontInfo }
const
  MaxFontStructList = High (Integer) div SizeOf (PXFontStruct);
  MaxFontnameList = High (Integer) div SizeOf (PChar);
type
  PFontStructListArray = ^TFontStructListArray;
  TFontStructListArray = array [0 .. MaxFontStructList] of PXFontStruct;
  PFontnameListArray = ^TFontnameListArray;
  TFontnameListArray = array [0 .. MaxFontnameList] of PChar;
  PXOMFontInfo = ^TXOMFontInfo;
  TXOMFontInfo = record
    NumFont: Integer;
    FontStructList: PFontStructListArray;
    FontNameList: PFontnameListArray
  end;

  { XIM }
  PXIM = Pointer;  { Input Method }
  
  { XIC }
  PXIC = Pointer;  { Input Context }

  PXIMProc = ^procedure (a: PXIM; b, c: TXPointer);
  PXICProc = ^procedure (a: PXIC; b, c: TXPointer);
  PXIDProc = ^procedure (a: PDisplay; b, c: TXPointer);
  PXVaNestedList = ^function: TXPointer;  {!! I'm not sure...}

  { XIMStyles }
const
  MaxSupportedStyles = High (Integer) div SizeOf (TXIMStyle);
type
  PSupportedStylesArray = ^TSupportedStylesArray;
  TSupportedStylesArray = array [0 .. MaxSupportedStyles] of TXIMStyle;
  PXIMStyles = ^TXIMStyles;
  TXIMStyles = record
    CountStyles: ShortCard;
    SupportedStyles: PSupportedStylesArray
  end;

  { XIMCallback }
  PXIMCallback = ^TXIMCallback;
  TXIMCallback = record
    ClientData: TXPointer;
    Callback: PXIMProc
  end;

  { XICCallback }
  PXICCallback = ^TXICCallback;
  TXICCallback = record
    ClientData: TXPointer;
    Callback: PXICProc
  end;

  { XIMText }
  TXIMText_helper = record
    case Byte of
      0: (MultiByte: PChar);
      1: (WideChar: PWCharT);
  end;
  PXIMText = ^TXIMText;
  TXIMText = record
    Length: ShortCard;
    Feedback: PXIMFeedback;
    EncodingIsWChar: TBool;
    aString: TXIMText_helper  {!! different name}
  end;

  { XIMPreeditStateNotifyCallbackStruct }
  PXIMPreeditStateNotifyCallbackStruct = ^TXIMPreeditStateNotifyCallbackStruct;
  TXIMPreeditStateNotifyCallbackStruct = record
    State: TXIMPreeditState
  end;

  { XIMStringConversionText }
  TXIMStringConversionText_helper = record
    case Byte of
      0: (mbs: PChar);
      1: (wcs: PWCharT);
  end;
  PXIMStringConversionText = ^TXIMStringConversionText;
  TXIMStringConversionText = record
    Length: ShortCard;
    Feedback: PXIMStringConversionFeedback;
    EncodingIsWChar: TBool;
    aString: TXIMStringConversionText_helper  {!! Different name}
  end;

  { XIMCaretDirection, see XIM* in consts section above }
  PXIMCaretDirection = ^TXIMCaretDirection;
  TXIMCaretDirection = Integer;

  { XIMStringConversionCallbackStruct }
  PXIMStringConversionCallbackStruct = ^TXIMStringConversionCallbackStruct;
  TXIMStringConversionCallbackStruct = record
    Position: TXIMStringConversionPosition;
    Direction: TXIMCaretDirection;
    Operation: TXIMStringConversionOperation;
    Factor: ShortCard;
    Text: PXIMStringConversionText
  end;

  { XIMPreeditDrawCallbackStruct }
  PXIMPreeditDrawCallbackStruct = ^TXIMPreeditDrawCallbackStruct;
  TXIMPreeditDrawCallbackStruct = record
    Caret, ChgFirst, ChgLength: Integer;
    Text: PXIMText
  end;

  { XIMCaretStyle, See XIMIs* constants above }
  TXIMCaretStyle = Integer;

  { XIMPreeditCaretCallbackStruct }
  TXIMPreeditCaretCallbackStruct = record
    Position: Integer;
    Direction: TXIMCaretDirection;
    Style: TXIMCaretStyle
  end;

  { XIMStatusDataType, See XIM*Type constants above }
  TXIMStatusDataType = Integer;
  
  TXIMStatusDrawCallbackStruct_helper = record
    case Byte of
      0: (Text: PXIMText);
      1: (Bitmap: TPixmap);
  end;
  TXIMStatusDrawCallbackStruct = record
    DataType: TXIMStatusDataType;  {!! Different name}
    Data: TXIMStatusDrawCallbackStruct_helper
  end;  

  PXIMHotKeyTrigger = ^TXIMHotKeyTrigger;
  TXIMHotKeyTrigger = record
    Keysym: TKeysym;
    Modfier, ModifierMask: Integer
  end;
  
  { XIMHotKeyTriggers }
const
  MaxKeysInKeyArray = High (Integer) div SizeOf (TXIMHotKeyTrigger);
type
  PKeysInKeyArray = ^TKeysInKeyArray;
  TKeysInKeyArray = array [0 .. MaxKeysInKeyArray] of TXIMHotKeyTrigger;
  TXIMHotKeyTriggers = record
    NumHotKey: Integer;
    Key: PKeysInKeyArray
  end;

  { XIMValuesList }
const
  MaxSupportedValues = High (Integer) div SizeOf (PChar);
type
  PSupportedValuesArray = ^TSupportedValuesArray;
  TSupportedValuesArray = array [0 .. MaxSupportedValues] of PChar;
  TXIMValuesList = record
    CountValues: ShortCard;
    SupportedValues: PSupportedValuesArray
  end;

{@section Makros from Xlib.h}

function ConnectionNumber (Dpy: PDisplay): Integer;
external name '_p_ConnectionNumber';

function RootWindow (Dpy: PDisplay; Scr: Integer): TWindow;
external name '_p_RootWindow';

function DefaultScreen (Dpy: PDisplay): Integer;
external name '_p_DefaultScreen';

function DefaultRootWindow (Dpy: PDisplay): TWindow;
external name '_p_DefaultRootWindow';

function DefaultVisual (Dpy: PDisplay; Scr: Integer): PVisual;
external name '_p_DefaultVisual';

function DefaultGC (Dpy: PDisplay; Scr: Integer): PGC;
external name '_p_DefaultGC';

function BlackPixel (Dpy: PDisplay; Scr: Integer): MedCard;
external name '_p_BlackPixel';

function WhitePixel (Dpy: PDisplay; Scr: Integer): MedCard;
external name '_p_WhitePixel';

function AllPlanes: MedCard;
external name '_p_AllPlanes';

function QLength (Dpy: PDisplay): Integer;
external name '_p_QLength';

function DisplayWidth (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DisplayWidth';

function DisplayHeight (Dpy:PDisplay; Scr:Integer): Integer;
external name '_p_DisplayHeight';

function DisplayWidthMM (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DisplayWidthMM';

function DisplayHeightMM (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DisplayHeightMM';

function DisplayPlanes (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DisplayPlanes';

function DisplayCells (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DisplayCells';

function ScreenCount (Dpy: PDisplay): Integer;
external name '_p_ScreenCount';

function ServerVendor(Dpy: PDisplay): PChar;
external name '_p_ServerVendor';

function ProtocolVersion (Dpy: PDisplay): Integer;
external name '_p_ProtocolVersion';

function ProtocolRevision (Dpy: PDisplay): Integer;
external name '_p_ProtocolRevision';

function VendorRelease (Dpy: PDisplay): Integer;
external name '_p_VendorRelease';

function DisplayString(Dpy: PDisplay): PChar;
external name '_p_DisplayString';

function DefaultDepth (Dpy: PDisplay; Scr: Integer): Integer;
external name '_p_DefaultDepth';

function DefaultColormap (Dpy: PDisplay; Scr: Integer): TColormap;
external name '_p_DefaultColormap';

function BitmapUnit (Dpy: PDisplay): Integer;
external name '_p_BitmapUnit';

function BitmapBitOrder (Dpy: PDisplay): Integer;
external name '_p_BitmapBitOrder';

function BitmapPad (Dpy: PDisplay): Integer;
external name '_p_BitmapPad';

function ImageByteOrder (Dpy: PDisplay): Integer;
external name '_p_ImageByteOrder';

function NextRequest (Dpy: PDisplay): MedCard;
external name '_p_NextRequest';

function LastKnownRequestProcessed (Dpy: PDisplay): MedCard;
external name '_p_LastKnownRequestProcessed';

{ Toolkit Makros from Xlib.h }

function ScreenOfDisplay (Dpy: PDisplay; Scr: Integer): PScreen;
external name '_p_ScreenOfDisplay';

function DefaultScreenOfDisplay (Dpy: PDisplay): PScreen;
external name '_p_DefaultScreenOfDisplay';

function DisplayOfScreen  (s: PScreen): PDisplay;
external name '_p_DisplayOfScreen';

function RootWindowOfScreen  (s: PScreen): TWindow;
external name '_p_RootWindowOfScreen';

function BlackPixelOfScreen  (s: PScreen): MedCard;
external name '_p_BlackPixelOfScreen';

function WhitePixelOfScreen  (s: PScreen): MedCard;
external name '_p_WhitePixelOfScreen';

function DefaultColormapOfScreen  (s: PScreen): TColormap;
external name '_p_DefaultColormapOfScreen';

function DefaultDepthOfScreen  (s: PScreen): Integer;
external name '_p_DefaultDepthOfScreen';

function DefaultGCOfScreen  (s: PScreen): PGC;
external name '_p_DefaultGCOfScreen';

function DefaultVisualOfScreen  (s: PScreen): PVisual;
external name '_p_DefaultVisualOfScreen';

function WidthOfScreen  (s: PScreen): Integer;
external name '_p_WidthOfScreen';

function HeightOfScreen  (s: PScreen): Integer;
external name '_p_HeightOfScreen';

function WidthMMOfScreen  (s: PScreen): Integer;
external name '_p_WidthMMOfScreen';

function HeightMMOfScreen  (s: PScreen): Integer;
external name '_p_HeightMMOfScreen';

function PlanesOfScreen  (s: PScreen): Integer;
external name '_p_PlanesOfScreen';

function CellsOfScreen  (s: PScreen): Integer;
external name '_p_CellsOfScreen';

function MinCmapsOfScreen  (s: PScreen): Integer;
external name '_p_MinCmapsOfScreen';

function MaxCmapsOfScreen  (s: PScreen): Integer;
external name '_p_MaxCmapsOfScreen';

function DoesSaveUnders  (s: PScreen): TBool;
external name '_p_DoesSaveUnders';

function DoesBackingStore  (s: PScreen): Integer;
external name '_p_DoesBackingStore';

function EventMaskOfScreen  (s: PScreen): MedInt;
external name '_p_EventMaskOfScreen';

function XAllocID (Dpy: PDisplay): TXID;
external name '_p_XAllocID';


{@section Prototypes from Xlib.h}

function XVaCreateNestedList (unused: Integer; ...): PXVaNestedList;
external name 'XVaCreateNestedList';

function XLoadQueryFont (Display: PDisplay; name: PChar): PXFontStruct;
external name 'XLoadQueryFont';

function XQueryFont (Display: PDisplay; FontID: TXID): PXFontStruct;
external name 'XQueryFont';

function XGetMotionEvents (Display: PDisplay; Win: TWindow; 
  Start, Stop: TTime; var NEventsReturn: Integer): PXTimeCoord;
external name 'XGetMotionEvents';

function XDeleteModifiermapEntry (Modmap: PXModifierKeymap;
  KeyCodeEntry: TKeyCode; Modifier: Integer): PXModifierKeymap;
external name 'XDeleteModifiermapEntry';

function XGetModifierMapping (Display: PDisplay): PXModifierKeymap;
external name 'XGetModifierMapping';

function XInsertModifiermapEntry (Modmap: PXModifierKeymap;
  KeyCodeEntry: TKeyCode; Modifier: Integer): PXModifierKeymap;
external name 'XInsertModifiermapEntry';

function XNewModifiermap (MaxKeysPerMod: Integer): PXModifierKeymap;
external name 'XNewModifiermap';

function XCreateImage (Display: PDisplay; Visual: PVisual;
  Depth: MedCard; Format, Offset: Integer; Data: PChar;
  Width, Height: Cardinal; BitmapPad, BytesPerLine: Integer): PXImage;
external name 'XCreateImage';

function XInitImage (Image: PXImage): TStatus;
external name 'XInitImage';

function XGetImage (Display: PDisplay; Draw: TDrawable; x, y: Integer;
  Width, Height: Cardinal; PlaneMask: MedCard; Format: Integer)
 : PXImage;
external name 'XGetImage';

function XGetSubImage (Display: PDisplay; Draw: TDrawable; x, y: Integer;
  Width, Height: Cardinal; PlaneMask: MedCard; Format: Integer;
  DestImage: PXImage; DestX, DestY: Integer): PXImage;
external name 'XGetSubImage';

function XOpenDisplay (Name: PChar): PDisplay;
external name 'XOpenDisplay';

procedure XrmInitialize;
external name 'XrmInitialize';

function XFetchBytes (Display: PDisplay; var NBytesRet: Integer): PChar;
external name 'XFetchBytes';

function XFetchBuffer (Display: PDisplay; var NBytesRet: Integer;
  Buffer: Integer): PChar;
external name 'XFetchBuffer';

function XGetAtomName (Display: PDisplay; Atom: TAtom): PChar;
external name 'XGetAtomName';

const
  AtomsArrayMax = High (Integer) div SizeOf (TAtom);
type
  PAtomsArray = ^TAtomsArray;
  TAtomsArray = array [0 .. AtomsArrayMax] of TAtom;
  
function XGetAtomNames (Display: PDisplay; Atoms: PAtomsArray; Count: Integer;
  var NamesRet: PChar): TStatus;
external name 'XGetAtomNames';

function XGetDefault (Display: PDisplay; ProgramName, Option: PChar): PChar;
external name 'XGetDefault';

function XDisplayName (aString: PChar): PChar;
external name 'XDisplayName';

function XKeysymToString (Keysym: TKeysym): PChar;
external name 'XKeysymToString';

function XSynchronize (Dpy: PDisplay; OnOff: TBool): Integer;
external name 'XSynchronize';

type
  { For XSetAfterFunction () }
  PSetAfterFunction = ^function (Dpy: PDisplay): Integer;

function XSetAfterFunction (Dpy: PDisplay; Proc: PSetAfterFunction): Integer;
external name 'XSetAfterFunction';

function XInternAtom (Dpy: PDisplay; AtomName: PChar; OnlyIfExists: TBool): TAtom;
external name 'Atom';

{ We bought the type "PCharsetListArray" from another type. It's just an
array of Strings in C }
function XInternAtoms (Dpy: PDisplay; Names: PCharsetListArray; 
  Count: Integer; OnlyIfExists: TBool; AtomsRet: PAtomsArray): TStatus;
external name 'XInternAtoms';

function XCopyColormapAndFree (Dpy: PDisplay; Colormap: TColormap): TColormap;
external name 'XCopyColormapAndFree';

function XCreateColormap (Dpy: PDisplay; Win: TWindow; Visual: PVisual;
  alloc: Integer): TColormap;
external name 'XCreateColormap';

function XCreatePixmapCursor (Dpy: PDisplay; Source, Mask: TPixmap;
  FgColor, BgColor: PXColor; x, y: Cardinal): TCursor;
external name 'XCreatePixmapCursor';

function XCreateGlyphCursor (Dpy: PDisplay; SourceFont, MaskFont: TFont;
  SourceChar, MaskChar: Cardinal; FgColor, BgColor: PXColor): TCursor;
external name 'XCreateGlyphCursor';

function XCreateFontCursor (Dpy: PDisplay; Shape: Cardinal): TCursor;
external name 'XCreateFontCursor';

function XLoadFont (Dpy: PDisplay; Name: PChar): TFont;
external name 'XLoadFont';

{ Valuemask is one of GCFunction, GCPlaneMask, GCForeground, 
(and much more) }
function XCreateGC (Dpy: PDisplay; Draw: TDrawable; ValueMask: MedCard;
  Values: PXGCValues): PGC;
external name 'XCreateGC';

function XGContextFromGC (GC: PGC): TGContext;
external name 'XGContextFromGC';

procedure XFlushGC (Dpy: PDisplay; GC: PGC);
external name 'XFlushGC';

function XCreatePixmap (Dpy: PDisplay; Draw: TDrawable;
  Width, Height, Depth: Cardinal): TPixmap;
external name 'XCreatePixmap';

function XCreateBitmapFromData (Dpy: PDisplay; Draw: TDrawable; Data: PChar;
  Width, Height: Cardinal): TPixmap;
external name 'XCreateBitmapFromData';

function XCreatePixmapFromBitmapData (Dpy: PDisplay; Draw: TDrawable; 
  Data: PChar; Width, Height: Cardinal; Fg, Bg: MedCard;
  Depth: Cardinal): TPixmap;
external name 'XCreatePixmapFromBitmapData';

function XCreateSimpleWindow (Dpy: PDisplay; Window: TWindow; x, y: Integer;
  Width, Height, BorderWidth: Cardinal; Border, Background: MedCard): TWindow;
external name 'XCreateSimpleWindow';

function XGetSelectionOwner (Dpy: PDisplay; Atom: TAtom): TWindow;
external name 'XGetSelectionOwner';

function XCreateWindow  (Dpy: PDisplay; Window: TWindow; x, y: Integer;
  Width, Height, BorderWidth: Cardinal; Depth: Integer; Klass: Cardinal;
  Visual: PVisual; ValueMask: MedCard;  Attribs: PXSetWindowAttributes): TWindow;
external name 'XCreateWindow';

const
  ColormapArrayMax = High (Integer) div SizeOf (TColormap);
type
  PColormapArray = ^TColormapArray;
  TColormapArray = array [0 .. ColormapArrayMax] of TColormap;
function XListInstalledColormaps (Dpy: PDisplay; Win: TWindow;
  var NumRet: Integer): PColormapArray;
external name 'XListInstalledColormaps';

{ We bought the type "PCharsetListArray" from another type. It's just an
array of Strings in C }
function XListFonts (Dpy: PDisplay; Pattern: PChar; MaxNames: Integer;
  var ActualCountReturn: Integer): PCharsetListArray;
external name 'XListFonts';

function XListFontsWithInfo (Dpy: PDisplay; Pattern: PChar; MaxNames: Integer;
  var CountReturn: Integer; InfoReturn: PFontStructListArray): PCharsetListArray;
external name 'XListFontsWithInfo';

function XGetFontPath (Dpy: PDisplay; var NPathsRet: Integer):PCharsetListArray;
external name 'XGetFontPath';

function XListExtensions (Dpy: PDisplay; var NExtensionsRet: Integer): PCharsetListArray;
external name 'XListExtensions';

function XListProperties (Dpy: PDisplay; Win: TWindow; var NumPropRet: Integer): PAtomsArray;
external name 'XListProperties';

const
  XHostAddressArrayMax = High (Integer) div SizeOf (TXHostAddress);
type
  PXHostAddressArray = ^TXHostAddressArray;
  TXHostAddressArray = array [0 .. XHostAddressArrayMax] of TXHostAddress;
function XListHosts (Dpy: PDisplay; var NHostsRet: Integer; var StateRet:
TBool): PXHostAddressArray;
external name 'XListHosts';

function XKeyCodeToKeysym (Dpy: PDisplay; KeyCode: TKeyCode; Index: Integer): TKeysym;
external name 'XKeycodeToKeysym';

{ @@ Name clash with constant "XLookupKeysym" above}
{!! Different Name}
function XLookupKeysymP (Dpy: PDisplay; KeyEvent: PXKeyEvent; Index: Integer): TKeysym;
external name 'XLookupKeysym';

function XGetKeyboardMapping (Dpy: PDisplay; FirstKeyCode: TKeyCode;
  KeyCodeCount: Integer; var KeysymsPerKeyCodeRet: Integer): TKeysym;
external name 'XGetKeyboardMapping';

function XStringToKeysym (aString: PChar): TKeysym;
external name 'XStringToKeysym';

function XMaxRequestSize (Dpy: PDisplay): MedInt;
external name 'XMaxRequestSize';

function XExtendedMaxRequestSize (Dpy: PDisplay): MedInt;
external name 'XExtendedMaxRequestSize';

function XResourceManagerStringfunction (Dpy: PDisplay): PChar;
external name 'XResourceManagerString';

function XScreenResourceString (Screen: PScreen): PChar;
external name 'XScreenResourceString';

function XDisplayMotionBufferSize (Dpy: PDisplay): MedCard;
external name 'XDisplayMotionBufferSize';

function XVisualIDFromVisual (Visual: PVisual): TVisualID;
external name 'XVisualIDFromVisual';

{ Multithreading Routines }

function XInitThreads: TStatus;
external name 'XInitThreads';

procedure XLockDisplay (Dpy: PDisplay);
external name 'XLockDisplay';

procedure XUnlockDisplay (Dpy: PDisplay);
external name 'XUnlockDisplay';

{ routines for dealing with extensions }

function XInitExtension (Dpy: PDisplay; Name: PChar): PXExtCodes;
external name 'XInitExtension';

function XAddExtension (Dpy: PDisplay): PXExtCodes;
external name 'XAddExtension';

const
  XExtDataArrayMax = High (Integer) div SizeOf (TXExtData);
type
  PXExtDataArray = ^TXExtDataArray;
  TXExtDataArray = array [0 .. XExtDataArrayMax] of TXExtData;
function XFindOnExtensionList (Structure: PXExtDataArray; Number: Integer): PXExtData;
external name 'XFindOnExtensionList';

function XEHeadOfExtensionList (obj: TXEDataObject): PXExtDataArray;
external name 'XEHeadOfExtensionList';

{ Routines, which also have a C-Macro }

function XRootWindow (Dpy: PDisplay; ScreenNum: Integer): TWindow;
external name 'XRootWindow';

function XDefaultRootWindow (Dpy: PDisplay): TWindow;
external name 'XDefaultRootWindow';

function XRootWindowOfScreen (Screen: PScreen): TWindow;
external name 'XRootWindowOfScreen';

function XDefaultVisual (Dpy: PDisplay; ScreenNum: Integer): PVisual;
external name 'XDefaultVisual';

function XDefaultVisualOfScreen (Screen: PScreen): PVisual;
external name 'XDefaultVisualOfScreen';

function XDefaultGC (Dpy: PDisplay; ScreenNum: Integer): PGC;
external name 'XDefaultGC';

function XDefaultGCOfScreen (Screen: PScreen): PGC;
external name 'XDefaultGCOfScreen';

function XBlackPixel (Dpy: PDisplay; ScreenNum: Integer): MedCard;
external name 'XBlackPixel';

function XWhitePixel (Dpy: PDisplay; ScreenNum: Integer): MedCard;
external name 'XWhitePixel';

function XAllPlanes : MedCard;
external name 'XAllPlanes';

function XBlackPixelOfScreen (Screen: PScreen): MedCard;
external name 'XBlackPixelOfScreen';

function XWhitePixelOfScreen (Screen: PScreen): MedCard;
external name 'XWhitePixelOfScreen';

function XNextRequest (Dpy: PDisplay): MedCard;
external name 'XNextRequest';

function XLastKnownRequestProcessed (Dpy: PDisplay): MedCard;
external name 'XLastKnownRequestProcessed';

function XServerVendor (Dpy: PDisplay): PChar;
external name 'XServerVendor';

function XDisplayString (Dpy: PDisplay): PChar;
external name 'XDisplayString';

function XDefaultColormap (Dpy: PDisplay; ScrrenNumber: Integer): TColormap;
external name 'XDefaultColormap';

function XDefaultColormapOfScreen (Screen: PScreen): TColormap;
external name 'XDefaultColormapOfScreen';

function XDisplayOfScreen (Screen: PScreen): PDisplay;
external name 'XDisplayOfScreen';

function XScreenOfDisplay (Dpy: PDisplay; ScreenNumber: Integer): PScreen;
external name 'XScreenOfDisplay';

function XDefaultScreenOfDisplay (Dpy: PDisplay): PScreen;
external name 'XDefaultScreenOfDisplay';

function XEventMaskOfScreen (Screen: PScreen): MedInt;
external name 'XEventMaskOfScreen';

function XScreenNumberOfScreen (Screen: PScreen): Integer;
external name 'XScreenNumberOfScreen';

type
  PXErrorHandler = ^function (Dpy: PDisplay; ErrEvent: PXErrorEvent): Integer;

function XSetErrorHandler (Handler: PXErrorHandler): PXErrorHandler;
external name 'XSetErrorHandler';

type
  PXIOErrorHandler = ^function (Dpy: PDisplay): Integer;

function XSetIOErrorHandler (Handler: PXIOErrorHandler): PXIOErrorHandler;
external name 'XSetIOErrorHandler';

const
  XPixmapFormatValuesArrayMax = High (Integer) div SizeOf (TXExtData);
type
  PXPixmapFormatValuesArray = ^TXPixmapFormatValuesArray;
  TXPixmapFormatValuesArray = array [0 .. XPixmapFormatValuesArrayMax] of TXPixmapFormatValues;

function XListPixmapFormats (Dpy: PDisplay; var CountRet: Integer):
  PXPixmapFormatValuesArray;
external name 'XListPixmapFormats';

const
  IntegerArrayMax = High (Integer) div SizeOf (Integer);
type
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = array [0 .. IntegerArrayMax] of Integer;

function XListDepths (Dpy: PDisplay; ScreenNumber: Integer;
  var CountRet: Integer): PIntegerArray;
external name 'XListDepths';

function XReconfigureWMWindow (Dpy: PDisplay; Win: TWindow; ScreenNumber: Integer;
  Mask: Cardinal; Changes: PXWindowChanges): TStatus;
external name 'XReconfigureWMWindow';

function XGetWMProtocols (Dpy: PDisplay; Win: TWindow; var Atoms: PAtomsArray;
  var CountRet: Integer): TStatus;
external name 'XGetWMProtocols';

function XSetWMProtocols (Dpy: PDisplay; Win: TWindow; Atoms: PAtomsArray;
  Count: Integer): TStatus;
external name 'XSetWMProtocols';

function XIconifyWindow (Dpy: PDisplay; Win: TWindow; ScreenNum: Integer): TStatus;
external name 'XIconifyWindow';

function XWithdrawWindow (Dpy: PDisplay; Win: TWindow; ScreenNum: Integer): TStatus;
external name 'XWithdrawWindow';

function XGetCommand (Dpy: PDisplay; Win: TWindow; 
  var ArgVRet: PCharsetListArray; var ArgC: Integer): TStatus;
external name 'XGetCommand';

const
  WindowsArrayMax = High (Integer) div SizeOf (TWindow);
type
  PWindowsArray = ^TWindowsArray;
  TWindowsArray = array [0 .. WindowsArrayMax] of TWindow;

function XGetWMColormapWindows (Dpy: PDisplay; Win: TWindow;
  var WindowsRet: PWindowsArray; var CountRet: Integer): TStatus;
external name 'XGetWMColormapWindows';

function XSetWMColormapWindows (Dpy: PDisplay; Win: TWindow;
  ColormapWindows: PWindowsArray; Count: Integer): TStatus;
external name 'XSetWMColormapWindows';

procedure XFreeStringList (List: PCharsetListArray);
external name 'XFreeStringList';

function XSetTransientForHint (Dpy: PDisplay; Win, PropWindow: TWindow): Integer;
external name 'XSetTransientForHint';

{ The following are given in alphabetical order }

function XActivateScreenSaver (Dpy: PDisplay): Integer;
external name 'XActivateScreenSaver';

function XAddHost (Dpy: PDisplay; var Hosts: TXHostAddress): Integer;
external name 'XAddHost';

function XAddHosts (Dpy: PDisplay; Hosts: PXHostAddressArray;
  NumHosts: Integer): Integer;
external name 'XAddHosts';

{ @@ I'm not sure with the parameters}
function XAddToExtensionList (Structure: PXExtDataArray; Data: PXExtData): Integer;
external name 'XAddToExtensionList';

function XAddToSaveSet (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XAddToSaveSet';

function XAllocColor (Dpy: PDisplay; Colormap: TColormap;
  var ScreenInOut: TXColor): TStatus;
external name 'XAllocColor';

function XAllocColorCells (Dpy: PDisplay; ColMap: TColormap; Contig: TBool;
  var PlaneMaskRet: MedCard; NPlanes: Cardinal; var PixelRet: MedCard;
  NPixels: Cardinal): TStatus;
external name 'XAllocColorCells';

function XAllocColorPlanes (Dpy: PDisplay; ColMap: TColormap; Contig: TBool;
  var PixelsRet: MedCard; NColors, NReds, NGreens, NBlues: Integer;
  var RMaskRet: MedCard; var GMaskRet: MedCard; BMaskRet: MedCard): TStatus;
external name 'XAllocColorPlanes';

function XAllocNamedColor (Dpy: PDisplay; ColMap: TColormap;
  ColorName: PChar; var ScreenDefRet: TXColor; ExactDefRet: TXColor): TStatus;
external name 'XAllocNamedColor';

function XAllowEvents (Dpy: PDisplay; EventMode: Integer; Time: TTime): Integer;
external name 'XAllowEvents';

function XAutoRepeatOff (Dpy: PDisplay): Integer;
external name 'XAutoRepeatOff';

function XAutoRepeatOn (Dpy: PDisplay): Integer;
external name 'XAutoRepeatOn';

function XBell (Dpy: PDisplay; Percent: Integer): Integer;
external name 'XBell';

function XBitmapBitOrder (Dpy: PDisplay): Integer;
external name 'XBitmapBitOrder';

function XBitmapPad (Dpy: PDisplay): Integer;
external name 'XBitmapPad';

function XBitmapUnit (Dpy: PDisplay): Integer;
external name 'XBitmapUnit';

function XCellsOfScreen (Screen: PScreen): Integer;
external name 'XCellsOfScreen';

function XChangeActivePointerGrab (Dpy: PDisplay; EventMask: Cardinal;
  Cursor: TCursor; Time: TTime): Integer;
external name 'XChangeActivePointerGrab';

function XChangeGC (Dpy: PDisplay; GC: PGC; ValueMask: MedCard;
  var Values: TXGCValues): Integer;
external name 'XChangeGC';

function XChangeKeyboardControl (Dpy: PDisplay; ValueMask: MedCard;
  var Values: TXKeyboardControl): Integer;
external name 'XChangeKeyboardControl';

const
  KeysymsArrayMax = High (Integer) div SizeOf (TKeysym);
type
  PKeysymsArray = ^TKeysymsArray;
  TKeysymsArray = array [0 .. KeysymsArrayMax] of TKeysym;

function XChangeKeyboardMapping (Dpy: PDisplay; FirstKeyCode,
  KeysymsPerKeyCode: Integer; Keysyms: PKeysymsArray;
  NumCodes: Integer): Integer;
external name 'XChangeKeyboardMapping';

function XChangePointerControl (Dpy: PDisplay; DoAccel, DoTreshold: TBool;
  AccelNumerator, AccelDenominator, Treshold: Integer): Integer;
external name 'XChangePointerControl';

function XChangeProperty (Dpy: PDisplay; Win: TWindow; Propert, aType: TAtom;
  Format, Mode: Integer; Data: PChar; NElements: Integer): Integer;
external name 'XChangeProperty';

function XChangeSaveSet (Dpy: PDisplay; Win: TWindow; ChangeMode: Integer): Integer;
external name 'XChangeSaveSet';

function XChangeWindowAttributes (Dpy: PDisplay; Win: TWindow;
  ValueMask: MedCard; var Attrib: TXSetWindowAttributes): Integer;
external name 'XChangeWindowAttributes';

type
  PPredicateFunc = ^function (Dpy: PDisplay; Evt: PXEvent; Arg: TXPointer): TBool;

function XCheckIfEvent (Dpy: PDisplay; var EvtRet: TXEvent;
  Peedicate: PPredicateFunc; Arg: TXPointer): TBool;
external name 'XCheckIfEvent';

function XCheckMaskEvent (Dpy: PDisplay; EvtMask: MedInt;
  var EvtRet: TXEvent): TBool;
external name 'XCheckMaskEvent';

function XCheckTypedEvent (Dpy: PDisplay; EvtType: Integer;
  var EvtRet: TXEvent): TBool;
external name 'XCheckTypedEvent';

function XCheckTypedWindowEvent (Dpy: PDisplay; Win: TWindow; EvtType: Integer;
  var EvtRet: TXEvent): TBool;
external name 'XCheckTypedWindowEvent';

function XCheckWindowEvent (Dpy: PDisplay; Win: TWindow; EvtMask: MedInt;
  var EvtRet: TXEvent): TBool;
external name 'XCheckWindowEvent';

function XCirculateSubwindows (Dpy: PDisplay; Win: TWindow;
  Direction: Integer): Integer;
external name 'XCirculateSubwindows';

function XCirculateSubwindowsDown (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XCirculateSubwindowsDown';

function XCirculateSubwindowsUp (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XCirculateSubwindowsUp';

function XClearArea (Dpy: PDisplay; Win: TWindow; x, y: Integer;
  Width, Height: Cardinal; Exposures: TBool): Integer;
external name 'XClearArea';

function XClearWindow (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XClearWindow';

function XCloseDisplay (Dpy: PDisplay): Integer;
external name 'XCloseDisplay';

function XConfigureWindow (Dpy: PDisplay; Win: TWindow; ValueMask: Cardinal;
  var Values: TXWindowChanges): Integer;
external name 'XConfigureWindow';

function XConnectionNumber (Dpy: PDisplay): Integer;
external name 'XConnectionNumber';

function XConvertSelection (Dpy: PDisplay; Selection, Target, Propert: TAtom;
  Requestor: TWindow; Time: TTime): Integer;
external name 'XConvertSelection';

function XCopyArea (Dpy: PDisplay; Src, Dest: TDrawable; GC: PGC;
  SrcX, SrcY: Integer; Width, Height: Cardinal; DestX, DestY: Integer): Integer;
external name 'XCopyArea';

function XCopyGC (Dpy: PDisplay; GC: PGC; ValueMask: MedCard; Dest: PGC): Integer;
external name 'XCopyGC';

function XCopyPlane (Dpy: PDisplay; Src, Dest: TDrawable; GC: PGC;
  SrcX, SrcY: Integer; Width, Height: Cardinal; DestX, DestY: Integer;
  Plane: MedCard): Integer;
external name 'XCopyPlane';

function XDefaultDepth (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDefaultDepth';

function XDefaultDepthOfScreen (Screen: PScreen): Integer;
external name 'XDefaultDepthOfScreen';

function XDefaultScreen (Dpy: PDisplay): Integer;
external name 'XDefaultScreen';

function XDefineCursor (Dpy: PDisplay; Win: TWindow; Cursor: TCursor): Integer;
external name 'XDefineCursor';

function XDeleteProperty (Dpy: PDisplay; Win: TWindow; Propert: TAtom): Integer;
external name 'XDeleteProperty';

function XDestroyWindow (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XDestroyWindow';

function XDestroySubwindows (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XDestroySubwindows';

function XDoesBackingStore (Screen: PScreen): Integer;
external name 'XDoesBackingStore';

function XDoesSaveUnders (Screen: PScreen): TBool;
external name 'XDoesSaveUnders';

function XDisableAccessControl (Dpy: PDisplay): Integer;
external name 'XDisableAccessControl';

function XDisplayCells (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayCells';

function XDisplayHeight (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayHeight';

function XDisplayHeightMM (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayHeightMM';

function XDisplayKeyCodes (Dpy: PDisplay; var MinKeyCodesRet,
  MaxKeyCodesRet: Integer): Integer;
external name 'XDisplayKeycodes';

function XDisplayPlanes (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayPlanes';

function XDisplayWidth (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayWidth';

function XDisplayWidthMM (Dpy: PDisplay; ScreenNum: Integer): Integer;
external name 'XDisplayWidthMM';

function XDrawArc (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  Width, Height: Cardinal; Angle1, Angle2: Integer): Integer;
external name 'XDrawArc';

const
  XArcsArrayMax = High (Integer) div SizeOf (TXArc);
type
  PXArcsArray = ^TXArcsArray;
  TXArcsArray = array [0 .. XArcsArrayMax] of TXArc;

function XDrawArcs (Dpy: PDisplay; d: TDrawable; GC: PGC;
  arcs: PXArcsArray; NumArcs: Integer): Integer;
external name 'XDrawArcs';

function XDrawImageString (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; aString: PChar; Len: Integer): Integer;
external name 'XDrawImageString';

function XDrawImageString16 (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; aString: PXChar2b; Len: Integer): Integer;
external name 'XDrawImageString16';

function XDrawLine (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x0, y0, x1, y1: Integer): Integer;
external name 'XDrawLine';

const
  XPointsArrayMax = High (Integer) div SizeOf (TXPoint);
type
  PXPointsArray = ^TXPointsArray;
  TXPointsArray = array [0 .. XPointsArrayMax] of TXPoint;

function XDrawLines (Dpy: PDisplay; d: TDrawable; GC: PGC;
  points: PXPointsArray; NumPoints, Mode: Integer): Integer;
external name 'XDrawLines';

function XDrawPoint (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer): Integer;
external name 'XDrawPoint';

function XDrawPoints (Dpy: PDisplay; d: TDrawable; GC: PGC;
  points: PXPointsArray; NumPoints, Mode: Integer): Integer;
external name 'XDrawPoints';

function XDrawRectangle (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; Width, Height: Cardinal): Integer;
external name 'XDrawRectangle';

const
  XRectanglesArrayMax = High (Integer) div SizeOf (TXRectangle);
type
  PXRectanglesArray = ^TXRectanglesArray;
  TXRectanglesArray = array [0 .. XRectanglesArrayMax] of TXRectangle;

function XDrawRectangles (Dpy: PDisplay; d: TDrawable; GC: PGC;
  rects: PXRectanglesArray; NumRects: Integer): Integer;
external name 'XDrawRectangles';

const
  XSegmentsArrayMax = High (Integer) div SizeOf (TXSegment);
type
  PXSegmentsArray = ^TXSegmentsArray;
  TXSegmentsArray = array [0 .. XSegmentsArrayMax] of TXSegment;

function XDrawSegments (Dpy: PDisplay; d: TDrawable; GC: PGC;
  segments: PXSegmentsArray; NumSegments: Integer): Integer;
external name 'XDrawSegments';

function XDrawString (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  s: PChar; Len: Integer): Integer;
external name 'XDrawString';

function XDrawString16 (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  s: PXChar2b; Len: Integer): Integer;
external name 'XDrawString16';

const
  XTextItemsArrayMax = High (Integer) div SizeOf (TXTextItem);
type
  PXTextItemsArray = ^TXTextItemsArray;
  TXTextItemsArray = array [0 .. XTextItemsArrayMax] of TXTextItem;

function XDrawText (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  s: PXTextItemsArray; NumItems: Integer): Integer;
external name 'XDrawText';

const
  XTextItem16sArrayMax = High (Integer) div SizeOf (TXTextItem16);
type
  PXTextItem16sArray = ^TXTextItem16sArray;
  TXTextItem16sArray = array [0 .. XTextItem16sArrayMax] of TXTextItem16;

function XDrawText16 (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  s: PXTextItem16sArray; NumItems: Integer): Integer;
external name 'XDrawText16';

function XEnableAccessControl (Dpy: PDisplay): Integer;
external name 'XEnableAccessControl';

function XEventsQueued (Dpy: PDisplay; Mode: Integer): Integer;
external name 'XEventsQueued';

function XFetchName (Dpy: PDisplay; Win: TWindow;
  var WinNameRet: PChar): Integer;
external name 'XFetchName';

function XFillArc (Dpy: PDisplay; d: TDrawable; GC: PGC; x, y: Integer;
  Width, Height: Cardinal; Angle1, Angle2: Integer): Integer;
external name 'XFillArc';

function XFillArcs (Dpy: PDisplay; d: TDrawable; GC: PGC;
  arcs: PXArcsArray; NumArcs: Integer): Integer;
external name 'XFillArcs';

function XFillPolygon (Dpy: PDisplay; d: TDrawable; GC: PGC;
  points: PXPointsArray; NPoints, Shape, Mode: Integer): Integer;
external name 'XFillPolygon';

function XFillRectangle (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; Width, Height: Cardinal): Integer;
external name 'XFillRectangle';

function XFillRectangles (Dpy: PDisplay; d: TDrawable; GC: PGC;
  rectangles: PXRectanglesArray; NumRets: Integer): Integer;
external name 'XFillRectangles';

function XFlush (Dpy: PDisplay): Integer;
external name 'XFlush';

function XForceScreenSaver (Dpy: PDisplay; Mode: Integer): Integer;
external name 'XForceScreenSaver';

function XFree (Data: Pointer): Integer;
external name 'XFree';

function XFreeColormap (Dpy: PDisplay; Colormap: TColormap): Integer;
external name 'XFreeColormap';

const
  MedCardsArrayMax = High (Integer) div SizeOf (MedCard);
type
  PMedCardsArray = ^TMedCardsArray;
  TMedCardsArray = array [0 .. MedCardsArrayMax] of MedCard;

function XFreeColors (Dpy: PDisplay; Colormap: TColormap; 
  Pixels: PMedCardsArray; NumPixel: Integer; Planes: MedCard): Integer;
external name 'XFreeColors';

function XFreeCursor (Dpy: PDisplay; Cursor: TCursor): Integer;
external name 'XFreeCursor';

{ @@ I'm not sure with the type, Could be of type PCharsetListArray }
function XFreeExtensionList (var List: PChar): Integer;
external name 'XFreeExtensionList';

function XFreeFont (Dpy: PDisplay; FonstStruct: PXFontStruct): Integer;
external name 'XFreeFont';

function XFreeFontInfo (Names: PCharsetListArray; FreeInfo: PXFontStruct;
  actualCount: Integer): Integer;
external name 'XFontStruct';

function XFreeFontNames (List: PCharsetListArray): Integer;
external name 'XFreeFontNames';

function XFreeFontPath (List: PCharsetListArray): Integer;
external name 'XFreeFontPath';

function XFreeGC (Dpy: PDisplay; GC: PGC): Integer;
external name 'XFreeGC';

function XFreeModifiermap (Modmap: PXModifierKeymap): Integer;
external name 'XFreeModifiermap';

function XFreePixmap (Dpy: PDisplay; Pixmap: TPixmap): Integer;
external name 'XFreePixmap';

function XGeometry (Dpy: PDisplay; ScreenNum: Integer; Pos, defaultpos: PChar;
  bWidth, fWidth, fHeight: Cardinal; xAdder, yAdder: Integer;
  var xRet, yRet, WidthRet, HeightRet: Integer): Integer;
external name 'XGeometry';

function XGetErrorDatabaseText (Dpy: PDisplay; name, Msg, DefStr: PChar;
  BufferRet: PChar; Len: Integer): Integer;
external name 'XGetErrorDatabaseText';

function XGetErrorText (Dpy: PDisplay; ErrCode: Integer; BuffRet: PChar;
  Len: Integer): Integer;
external name 'XGetErrorText';

function XGetFontProperty (var FontStruct: TXFontStruct; Atom: TAtom;
  var ValueRet: MedCard): TBool;
external name 'XGetFontProperty';

function XGetGCValues (Dpy: PDisplay; GC: PGC; ValueMask: MedCard;
  var ValRet: PXGCValues): TStatus;
external name 'XGetGCValues';

function XGetGeometry (Dpy: PDisplay; d: TDrawable; var RootWindow: TWindow;
  var x, y: Integer; var Width, Height, BorderWidth, Depth: Cardinal): TStatus;
external name 'XGetGeometry';

function XGetIconName (Dpy: PDisplay; Win: TWindow; var Name: PChar): TStatus;
external name 'XGetIconName';

function XGetInputFocus (Dpy: PDisplay; var Focus: TWindow; var Revert:
  Integer): Integer;
external name 'XGetInputFocus';

function XGetKeyboardControl (Dpy: PDisplay; var Values: TXKeyboardState): Integer;
external name 'XGetKeyboardControl';

function XGetPointerControl (Dpy: PDisplay; var Nominator, Denominitaor,
  Treshold: Integer): Integer;
external name 'XGetPointerControl';

const
  ByteCardsArrayMax = High (Integer) div SizeOf (ByteCard);
type
  PByteCardsArray = ^TByteCardsArray;
  TByteCardsArray = array [0 .. ByteCardsArrayMax] of ByteCard;

function XGetPointerMapping (Dpy: PDisplay; MapRet: PByteCardsArray;
  NMap: Integer): Integer;
external name 'XGetPointerMapping';

function XGetScreenSaver (Dpy: PDisplay; var TimeoutRet, IntervalRet,
  PreferBlankingRet, AllowExposRet: Integer): Integer;
external name 'XGetScreenSaver';

function XGetTransientForHint (Dpy: PDisplay; Win: TWindow;
  var PropWinRet: TWindow): TStatus;
external name 'XGetTransientForHint';

{ @@ Not sure with PropRet}
function XGetWindowProperty (Dpy: PDisplay; Win: TWindow; Propert: TAtom;
  LongOffset, LongLength: MedInt; Del: TBool; ReqType: TAtom;
  var ActualTypeRet: TAtom; var ActualFormatRet: Integer;
  var NItemsRet, BytesAfterRet: MedCard; var PropRet: PChar): Integer;
external name 'XGetWindowProperty';

function XGetWindowAttributes (Dpy: PDisplay; Win: TWindow;
  var WinAttrRet: TXWindowAttributes): TStatus;
external name 'XGetWindowAttributes';

function XGrabButton (Dpy: PDisplay; Button, Modifier: Cardinal;
  GrabWin: TWindow; OwnEvts: TBool; EvtMask: Cardinal;
  PointerMode, KeyboardMode: Integer; ConfineTo: TWindow;
  Cursor: TCursor): Integer;
external name 'XGrabButton';

function XGrabKey (Dpy: PDisplay; KeyCode: Integer; Modifiers: Cardinal;
  GrabWin: TWindow; OwnerEvt: TBool; PointerMode, KeyboardMode: Integer): Integer;
external name 'XGrabKey';

function XGrabKeyboard (Dpy: PDisplay; GrabWin: TWindow; OwnEvts: TBool;
  PointerMode, KeyboardMode: Integer; Time: TTime): Integer;
external name 'XGrabKeyboard';

function XGrabPointer (Dpy: PDisplay; GrabWin: TWindow; OwnEvts: TBool;
  EventMask: Cardinal; PointerMode, KeyboardMode: Integer; ConfineTo: TWindow;
  Cursor: TCursor; Time: TTime): Integer;
external name 'XGrabPointer';

function XGrabServer (Dpy: PDisplay): Integer;
external name 'XGrabServer';

function XHeightMMOfScreen (Screen: PScreen): Integer;
external name 'XHeightMMOfScreen';

function XHeightOfScreen (Screen: PScreen): Integer;
external name 'XHeightOfScreen';

function XIfEvent (Dpy: PDisplay; var EvtRet: TXEvent; Peedicate: PPredicateFunc;
  Arg: TXPointer): Integer;
external name 'XIfEvent';

function XImageByteOrder (Dpy: PDisplay): Integer;
external name 'XImageByteOrder';

function XInstallColormap (Dpy: PDisplay; ColMap: TColormap): Integer;
external name 'XInstallColormap';

function XKeysymToKeyCode (Dpy: PDisplay; Keysym: TKeysym): TKeyCode;
external name 'XKeysymToKeycode';

function XKillClient (Dpy: PDisplay; Resource: TXID): Integer;
external name 'XKillClient';

function XLookupColor (Dpy: PDisplay; ColMap: TColormap; ColorName: PChar;
  var ExactDefRet, ScreenDefRet: TXColor): TStatus;
external name 'XLookupColor';

function XLowerWindow (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XLowerWindow';

function XMapRaised (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XMapRaised';

function XMapSubwindows (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XMapSubwindows';

function XMapWindow (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XMapWindow';

function XMaskEvent (Dpy: PDisplay; EvtMask: MedInt; var EvtRet: TXEvent): Integer;
external name 'XMaskEvent';

function XMaxCmapsOfScreen (Screen: PScreen): Integer;
external name 'XMaxCmapsOfScreen';

function XMinCmapsOfScreen (Screen: PScreen): Integer;
external name 'XMinCmapsOfScreen';

function XMoveResizeWindow (Dpy: PDisplay; Win: TWindow; x, y: Integer;
  Width, Height: Cardinal): Integer;
external name 'XMoveResizeWindow';

function XMoveWindow (Dpy: PDisplay; Win: TWindow; x, y: Integer): Integer;
external name 'XMoveWindow';

function XNextEvent (Dpy: PDisplay; var EvtRet: TXEvent): Integer;
external name 'XNextEvent';

function XNoOp (Dpy: PDisplay): Integer;
external name 'XNoOp';

function XParseColor (Dpy: PDisplay; ColMap: TColormap; Spec: PChar;
  var ExactDefRet: TXColor): TStatus;
external name 'XParseColor';

function XParseGeometry (ParseStr: PChar; var x, y: Integer;
  var Width, Height: Cardinal): Integer;
external name 'XParseGeometry';

function XPeekEvent (Dpy: PDisplay; var EvtRet: TXEvent): Integer;
external name 'XPeekEvent';

function XPeekIfEvent (Dpy: PDisplay; var EvtRet: TXEvent;
  Predicate: PPredicateFunc; Arg: TXPointer): Integer;
external name 'XPeekIfEvent';

function XPending (Dpy: PDisplay): Integer;
external name 'XPending';

function XPlanesOfScreen (Screen: PScreen): Integer;
external name 'XPlanesOfScreen';

function XProtocolRevision (Dpy: PDisplay): Integer;
external name 'XProtocolRevision';

function XProtocolVersion (Dpy: PDisplay): Integer;
external name 'XProtocolVersion';

function XPutBackEvent (Dpy: PDisplay; Evt: PXEvent): Integer;
external name 'XPutBackEvent';

function XPutImage (Dpy: PDisplay; d: TDrawable; GC: PGC; Image: PXImage;
  SrcX, SrcY, DestX, DestY: Integer; Width, Height: Cardinal): Integer;
external name 'XPutImage';

function XQLength (Dpy: PDisplay): Integer;
external name 'XQLength';

function XQueryBestCursor (Dpy: PDisplay; d: TDrawable; Width, Height: Cardinal;
  var WidthRet, HeightRet: Cardinal): TStatus;
external name 'XQueryBestCursor';

function XQueryBestSize (Dpy: PDisplay; Klass: Integer; WhichScreen: TDrawable;
  Width, Height: Cardinal; var WithRet, HeightRet: Cardinal): TStatus;
external name 'XQueryBestSize';

function XQueryBestStipple (Dpy: PDisplay; WhichScreen: TDrawable;
  Width, Height: Cardinal; var WithRet, HeightRet: Cardinal): TStatus;
external name 'XQueryBestStipple';

function XQueryBestTile (Dpy: PDisplay; WhichScreen: TDrawable;
  Width, Height: Cardinal; var WithRet, HeightRet: Cardinal): TStatus;
external name 'XQueryBestTile';

function XQueryColor (Dpy: PDisplay; ColMap: TColormap; var Color: TXColor): Integer;
external name 'XQueryColor';

const
  XColorsArrayMax = High (Integer) div SizeOf (TXColor);
type
  PXColorsArray = ^TXColorsArray;
  TXColorsArray = array [0 .. XColorsArrayMax] of TXColor;

function XQueryColors (Dpy: PDisplay; Colormap: TColormap; 
  Colors: PXColorsArray; NumColors: Integer): Integer;
external name 'XQueryColors';

function XQueryExtension (Dpy: PDisplay; Name: PChar; var MajorOpcodeRet,
  FirstEvtRet, FirstErrRet: Integer): TBool;
external name 'XQueryExtension';

type
  TChar32Array = array [0 .. 31] of Char;

function XQueryKeymap (Dpy: PDisplay; KeysRet: TChar32Array): Integer;
external name 'XQueryKeymap';

function XQueryPointer (Dpy: PDisplay; Win: TWindow; var RootRet, ChildRet: TWindow;
  var RootXRet, RootYRet, WinXRet, WinYRet: Integer; var MaskRet: Cardinal): TBool;
external name 'XQueryPointer';

function XQueryTextExtents (Dpy: PDisplay; FontID: TXID; aString: PChar;
  NChars: Integer; var DirRet, FontAscendRet, FontDescentRet: Integer;
  var OverallRet: TXCharStruct): Integer;
external name 'XQueryTextExtents';

function XQueryTextExtents16 (Dpy: PDisplay; FontID: TXID; aString: PXChar2b;
  NChars: Integer; var DirRet, FontAscendRet, FontDescentRet: Integer;
  var OverallRet: TXCharStruct): Integer;
external name 'XQueryTextExtents';

function XQueryTree (Dpy: PDisplay; Win: TWindow; var RootRet, ParentRet: TWindow;
  var ChildrenRet: PWindowsArray; var NChildRet: Cardinal): TStatus;
external name 'XQueryTree';

function XRaiseWindow (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XRaiseWindow';

function XReadBitmapFile (Dpy: PDisplay; d: TDrawable; FileName: PChar;
  var WidthRet, HeightRet: Cardinal; var BitmapRet: TPixmap; var XHotRet,
  YHotRet: Integer): Integer;
external name 'XReadBitmapFile';

function XReadBitmapFileData (FileName: PChar; var WidthRet, HeightRet: Cardinal;
  var DataRet: PByteCardsArray; var XHotRet, YHotRet: Integer): Integer;
external name 'XReadBitmapFileData';

type
  PByteCard = ^ByteCard;

function XRebindKeysym (Dpy: PDisplay; Keysym: TKeysym; aList: PKeysymsArray;
  ModCount: Integer; aString: PByteCard; BytesString: Integer): Integer;
external name 'XRebindKeysym';

function XRecolorCursor (Dpy: PDisplay; Cursor: TCursor;
  FgColor, BgColor: PXColor): Integer;
external name 'XRecolorCursor';

function XRefreshKeyboardMapping (var EvtMap: TXMappingEvent): Integer;
external name 'XRefreshKeyboardMapping';

function XRemoveFromSaveSet (Dpy: PDisplay; Win: TWindow): Integer;
external name 'XRemoveFromSaveSet';

function XRemoveHost (Dpy: PDisplay; Host: PXHostAddress): Integer;
external name 'XRemoveHost';

function XRemoveHosts (Dpy: PDisplay; Hosts: PXHostAddressArray;
  NumHosts: Integer): Integer;
external name 'XRemoveHosts';

function XReparentWindow (Dpy: PDisplay; Win, Parent: TWindow; x, y: Integer): Integer;
external name 'XReparentWindow';

function XResetScreenSaver (Dpy: PDisplay): Integer;
external name 'XResetScreenSaver';

function XResizeWindow (Dpy: PDisplay; Win: TWindow; Width, Height: Integer): Integer;
external name 'XResizeWindow';

function XRestackWindows (Dpy: PDisplay; Windows: PWindowsArray;
  NumWin: Integer): Integer;
external name 'XRestackWindows';

function XRotateBuffers (Dpy: PDisplay; Rotate: Integer): Integer;
external name 'XRotateBuffers';

function XRotateWindowProperties (Dpy: PDisplay; Win: TWindow; Properties:
  PAtomsArray; NumProp, NPositions: Integer): Integer;
external name 'XRotateWindowProperties';

function XScreenCount (Dpy: PDisplay): Integer;
external name 'XScreenCount';

function XSelectInput (Dpy: PDisplay; Win: TWindow; EvtMask: MedInt): Integer;
external name 'XSelectInput';

function XSendEvent (Dpy: PDisplay; Win: TWindow; propagate: TBool;
  EvtMask: MedInt; EvtSend: PXEvent): TStatus;
external name 'XSendEvent';

function XSetAccessControl (Dpy: PDisplay; Mode: Integer): Integer;
external name 'XSetAccessControl';

{ ArcMode can have ArcChord or ArcPieSlice }
function XSetArcMode (Dpy: PDisplay; GC: PGC; ArcMode: Integer): Integer;
external name 'XSetArcMode';

function XSetBackground (Dpy: PDisplay; GC: PGC; Background: MedCard): Integer;
external name 'XSetBackground';

function XSetClipMask (Dpy: PDisplay; GC: PGC; Pixmap: TPixmap): Integer;
external name 'XSetClipMask';

function XSetClipOrigin (Dpy: PDisplay; GC: PGC; ClipXOrigin,
  ClipYOrigin: Integer): Integer;
external name 'XSetClipOrigin';

function XSetClipRectangles (Dpy: PDisplay; GC: PGC; ClipXOrigin,
  ClipYOrigin: Integer; rectangles: PXRectanglesArray; n,
  Ordering: Integer): Integer;
external name 'XRectangle';

function XSetCloseDownMode (Dpy: PDisplay; CloseMode: Integer): Integer;
external name 'XSetCloseDownMode';

function XSetCommand (Dpy: PDisplay; Win: TWindow; aArgv: PCharsetListArray;
  aArgc: Integer): Integer;
external name 'XSetCommand';

function XSetDashes (Dpy: PDisplay; GC: PGC; DashOffset: Integer;
  DashList: PChar; Num: Integer): Integer;
external name 'XSetDashes';

function XSetFillRule (Dpy: PDisplay; GC: PGC; FillRule: Integer): Integer;
external name 'XSetFillRule';

function XSetFillStyle (Dpy: PDisplay; GC: PGC; FillStyle: Integer): Integer;
external name 'XSetFillStyle';

function XSetFont (Dpy: PDisplay; GC: PGC; Font: TFont): Integer;
external name 'XSetFont';

function XSetFontPath (Dpy: PDisplay; Directories: PCharsetListArray;
  NumDirs: Integer): Integer;
external name 'XSetFontPath';

function XSetForeground (Dpy: PDisplay; GC: PGC; Foreground: MedCard): Integer;
external name 'XSetForeground';

function XSetFunction (Dpy: PDisplay; GC: PGC; aFunction: Integer): Integer;
external name 'XSetFunction';

function XSetGraphicsExposures (Dpy: PDisplay; GC: PGC; GraphExp: TBool): Integer;
external name 'XSetGraphicsExposures';

function XSetIconName (Dpy: PDisplay; Win: TWindow; IconName: PChar): Integer;
external name 'XSetIconName';

function XSetInputFocus (Dpy: PDisplay; Focus: TWindow; RevertTo: Integer;
  Time: TTime): Integer;
external name 'XSetInputFocus';

function XSetLineAttributes (Dpy: PDisplay; GC: PGC; LineWidth: Cardinal;
  LineStyle, CapStyle, JoinStyle: Integer): Integer;
external name 'XSetLineAttributes';

function XSetModifierMapping (Dpy: PDisplay; Modmap: PXModifierKeymap): Integer;
external name 'XSetModifierMapping';

function XSetPlaneMask (Dpy: PDisplay; GC: PGC; PlaneMask: MedCard): Integer;
external name 'XSetPlaneMask';

function XSetPointerMapping (Dpy: PDisplay; Map: PByteCard;
  NMap: Integer): Integer;
external name 'XSetPointerMapping';

function XSetScreenSaver (Dpy: PDisplay; Timeout, Interval, PrefBlank,
  AllowExp: Integer): Integer;
external name 'XSetScreenSaver';

function XSetSelectionOwner (Dpy: PDisplay; Selection: TAtom; Owner: TWindow;
  Time: TTime): Integer;
external name 'XSetSelectionOwner';

function XSetState (Dpy: PDisplay; GC: PGC; Foreground, Background: MedCard;
  functio: Integer; PlaneMask: MedCard): Integer;
external name 'XSetState';

function XSetStipple (Dpy: PDisplay; GC: PGC; Stripple: TPixmap): Integer;
external name 'XSetStipple';

function XSetSubwindowMode (Dpy: PDisplay; GC: PGC;
  SubwindowMode: Integer): Integer;
external name 'XSetSubwindowMode';

function XSetTSOrigin (Dpy: PDisplay; GC: PGC; TsXOrigin,
  TsYOrigin: Integer): Integer;
external name 'XSetTSOrigin';

function XSetTile (Dpy: PDisplay; GC: PGC; Tile: TPixmap): Integer;
external name 'XSetTile';

function XSetWindowBackground (Dpy: PDisplay; Window: TWindow;
  BackgroundPixel: MedCard): Integer;
external name 'XSetWindowBackground';

function XSetWindowBackgroundPixmap (Dpy: PDisplay; Window: TWindow;
  BackgroundPixmap: TPixmap): Integer;
external name 'XSetWindowBackgroundPixmap';

function XSetWindowBorder (Dpy: PDisplay; Window: TWindow; 
  BorderPixel: MedCard): Integer;
external name 'XSetWindowBorder';

function XSetWindowBorderPixmap (Dpy: PDisplay; Window: TWindow;
  BorderPixmap: TPixmap): Integer;
external name 'XSetWindowBorderPixmap';

function XSetWindowBorderWidth (Dpy: PDisplay; Window: TWindow;
  Width: Cardinal): Integer;
external name 'XSetWindowBorderWidth';

function XSetWindowColormap (Dpy: PDisplay; Window: TWindow;
  Colormap: TColormap): Integer;
external name 'XSetWindowColormap';

function XStoreBuffer (Dpy: PDisplay; Bytes: PChar; NBytes,
  Buffer: Integer): Integer;
external name 'XStoreBuffer';

function XStoreBytes (Dpy: PDisplay; Bytes: PChar;
  NBytes: Integer): Integer;
external name 'XStoreBytes';

function XStoreColor (Dpy: PDisplay; Colormap: TColormap;
  Color: PXColor): Integer;
external name 'XStoreColor';

function XStoreColors (Dpy: PDisplay; Colormap: TColormap;
  Color: PXColor; NColors: Integer): Integer;
external name 'XStoreColors';

function XStoreName (Dpy: PDisplay; Window: TWindow;
  WindowName: PChar): Integer;
external name 'XStoreName';

function XStoreNamedColor (Dpy: PDisplay; Colormap: TColormap;
  Color: PChar; Pixel: MedCard; Flags: Integer): Integer;
external name 'XStoreNamedColor';

function XSync (Dpy: PDisplay; Discard: TBool): Integer;
external name 'XSync';

function XTextExtents (FontStruct: PXFontStruct; aString: PChar;
  NChars: Integer; var DirectionRet, FontAscentRet,
  FontDescentRet: Integer; var OverallRet: TXCharStruct): Integer;
external name 'XTextExtents';

function XTextExtents16 (FontStruct: PXFontStruct; aString16: PXChar2b;
  NChars: Integer; var DirectionRet, FontAscentRet,
  FontDescentRet: Integer; var OverallRet: TXCharStruct): Integer;
external name 'XTextExtents16';

function XTextWidth (FontStruct: PXFontStruct; aString: PChar;
  Count: Integer): Integer;
external name 'XTextWidth';

function XTextWidth16 (FontStruct: PXFontStruct; aString16: PXChar2b;
  Count: Integer): Integer;
external name 'XTextWidth16';

function XTranslateCoordinates (Dpy: PDisplay; SrcWin, DestWin: TWindow;
  SrcX, SrcY: Integer; var DestXRet, DestYRet: Integer;
  var ChildRet: TWindow): TBool;
external name 'XTranslateCoordinates';

function XUndefineCursor (Dpy: PDisplay; Window: TWindow): Integer;
external name 'XUndefineCursor';

function XUngrabButton (Dpy: PDisplay; Button, Modifiers: Cardinal;
  GrabWindow: TWindow): Integer;
external name 'XUngrabButton';

function XUngrabKey (Dpy: PDisplay; KeyCode: Integer; Modifiers: Cardinal;
  GrabWindow: TWindow): Integer;
external name 'XUngrabKey';

function XUngrabKeyboard (Dpy: PDisplay; Time: TTime): Integer;
external name 'XUngrabKeyboard';

function XUngrabPointer (Dpy: PDisplay; Time: TTime): Integer;
external name 'XUngrabPointer';

function XUngrabServer (Dpy: PDisplay): Integer;
external name 'XUngrabServer';

function XUninstallColormap (Dpy: PDisplay; Colormap: TColormap): Integer;
external name 'XUninstallColormap';

function XUnloadFont (Dpy: PDisplay; Font: TFont): Integer;
external name 'XUnloadFont';

function XUnmapSubwindows (Dpy: PDisplay; Window: TWindow): Integer;
external name 'XUnmapSubwindows';

function XUnmapWindow (Dpy: PDisplay; Window: TWindow): Integer;
external name 'XUnmapWindow';

function XVendorRelease (Dpy: PDisplay): Integer;
external name 'XVendorRelease';

function XWarpPointer (Dpy: PDisplay; SrcWin, DestWin: TWindow;
  SrcX, SrcY: Integer; SrcWidth, SrcHEight: Cardinal;
  DestX, DestY: Integer): Integer;
external name 'XWarpPointer';

function XWidthMMOfScreen (Screen: PScreen): Integer;
external name 'XWidthMMOfScreen';

function XWidthOfScreen (Screen: PScreen): Integer;
external name 'XWidthOfScreen';

function XWindowEvent (Dpy: PDisplay; Window: TWindow;
  EventMask: MedInt; var EvtRet: TXEvent): Integer;
external name 'XWindowEvent';

function XWriteBitmapFile (Dpy: PDisplay; Path: PChar; Bitmap: TPixmap;
  Width, Height: Cardinal; XHot, YHot: Integer): Integer;
external name 'XWriteBitmapFile';

function XSupportsLocale: TBool;
external name 'XSupportsLocale';

function XSetLocaleModifiers (ModifierList: PChar): PChar;
external name 'XSetLocaleModifiers';

{ @@ rdb is struct _XrmHashBucketRec* }
function XOpenOM (Dpy: PDisplay; rdb: Pointer;
  ResName, ResClass: PChar): PXOM;
external name 'XOpenOM';

function XCloseOM (om: PXOM): TStatus;
external name 'XCloseOM';

function XSetOMValues (om: PXOM; ...): PChar;
external name 'XSetOMValues';

function XGetOMValues (om: PXOM; ...): PChar;
external name 'XGetOMValues';

function XDisplayOfOM (om: PXOM): PDisplay;
external name 'XDisplayOfOM';

function XLocaleOfOM (om: PXOM): PChar;
external name 'XLocaleOfOM';

function XCreateOC (om: PXOM; ...): PXOC;
external name 'XCreateOC';

procedure XDestroyOC (oc: PXOC);
external name 'XDestroyOC';

function XOMOfOC (oc: PXOC): PXOM;
external name 'XOMOfOC';

function XSetOCValues (oc: PXOC; ...): PChar;
external name 'XSetOCValues';

function XGetOCValues (oc: PXOC; ...): PChar;
external name 'XGetOCValues';

function XCreateFontSet (Dpy: PDisplay; BaseFontNameList: PChar;
  var MissingCharsetList: PCharsetListArray;
  var MissingCharsetCount: Integer; 
  DefString: PCharsetListArray): PXFontSet;
external name 'XCreateFontSet';

procedure XFreeFontSet (Dpy: PDisplay; FontSet: PXFontSet);
external name 'XFreeFontSet';

function XFontsOfFontSet (FontSet: PXFontSet;
  var FontStructList: PPXFontStruct; 
  var FontNameList: PCharsetListArray): Integer;
external name 'XFontsOfFontSet';

function XBaseFontNameListOfFontSet (FontSet: PXFontSet): PChar;
external name 'XBaseFontNameListOfFontSet';

function XLocaleOfFontSet (FontSet: PXFontSet): PChar;
external name 'XLocaleOfFontSet';

function XContextDependentDrawing (FontSet: PXFontSet): TBool;
external name 'XContextDependentDrawing';

function XDirectionalDependentDrawing (FontSet: PXFontSet): TBool;
external name 'XDirectionalDependentDrawing';

function XContextualDrawing (FontSet: PXFontSet): TBool;
external name 'XContextualDrawing';

function XExtentsOfFontSet (FontSet: PXFontSet): PXFontSetExtents;
external name 'XExtentsOfFontSet';

function XmbTextEscapement (FontSet: PXFontSet; Text: PChar;
  BytesText: Integer): Integer;
external name 'XmbTextEscapement';

function XwcTextEscapement (FontSet: PXFontSet; aText: PWCharT;
  NumWChars: Integer): Integer;
external name 'XwcTextEscapement';

function XmbTextExtents (FontSet: PXFontSet; aText: PChar;
  BytesText: Integer;
  var OverallInkReturn, OverallLogicalReturn: TXRectangle): Integer;
external name 'XmbTextExtents';

function XwcTextExtents (FontSet: PXFontSet; aText: PWCharT;
  NumWChars: Integer; 
  var OverallInkReturn, OverallLogicalReturn: TXRectangle): Integer;
external name 'XwcTextExtents';

function XmbTextPerCharExtents (FontSet: PXFontSet; aText: PChar;
  BytesText: Integer; 
  InkExtendsBuffer, LogicalExtendsBuffer: PXRectangle;
  BufferSize: Integer; var NumChars: Integer; 
  var OverallInkReturn, OverallLogicalReturn: TXRectangle): TStatus;
external name 'XmbTextPerCharExtents';

function XwcTextPerCharExtents (FontSet: PXFontSet; aText: PWCharT;
  NumWChars: Integer; 
  InkExtendsBuffer, LogicalExtendsBuffer: PXRectangle;
  BufferSize: Integer; var NumChars: Integer; 
  var OverallInkReturn, OverallLogicalReturn: TXRectangle): TStatus;
external name 'XwcTextPerCharExtents';

procedure XmbDrawText (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; TextItems: PXmbTextItem; NItems: Integer);
external name 'XmbDrawText';

procedure XwcDrawText (Dpy: PDisplay; d: TDrawable; GC: PGC;
  x, y: Integer; TextItems: PXwcTextItem);
external name 'XwcDrawText';

procedure XmbDrawString (Dpy: PDisplay; d: TDrawable; FontSet: PXFontSet;
  GC: PGC; x, y: Integer; aText: PChar; BytesText: Integer);
external name 'XmbDrawString';

procedure XwcDrawString (Dpy: PDisplay; d: TDrawable; FontSet: PXFontSet;
  GC: PGC; x, y: Integer; aText: PWCharT; NumWChars: Integer);
external name 'XwcDrawString';

procedure XmbDrawImageString (Dpy: PDisplay; d: TDrawable;
  FontSet: PXFontSet; GC: PGC; x, y: Integer; aText: PChar;
  BytesText: Integer);
external name 'XmbDrawImageString';

procedure XwcDrawImageString (Dpy: PDisplay; d: TDrawable;
  FontSet: PXFontSet; GC: PGC; x, y: Integer; aText: PWCharT;
  NumWChars: Integer);
external name 'XwcDrawImageString';

{ @@ rdb is struct _XrmHashBucketRec* }
function XOpenIM (Dpy: PDisplay; rdb: Pointer;
  ResName, ResClass: PChar): PXIM;
external name 'XOpenIM';

function XCloseIM (im: PXIM): TStatus;
external name 'XCloseIM';

function XGetIMValues (im: PXIM; ...): PChar;
external name 'XGetIMValues';

function XSetIMValues (im: PXIM; ...): PChar;
external name 'XSetIMValues';

function XDisplayOfIM (im: PXIM): PDisplay;
external name 'XDisplayOfIM';

function XLocaleOfIM (im: PXIM): PChar;
external name 'XLocaleOfIM';

function XCreateIC (im: PXIM; ...): PXIC;
external name 'XCreateIC';

procedure XDestroyIC (ic: PXIC);
external name 'XDestroyIC';

procedure XSetICFocus (ic: PXIC);
external name 'XSetICFocus';

procedure XUnsetICFocus (ic: PXIC);
external name 'XUnsetICFocus';

function XwcResetIC (ic: PXIC): PWCharT;
external name 'XwcResetIC';

function XmbResetIC (ic: PXIC): PChar;
external name 'XmbResetIC';

function XSetICValues (ic: PXIC; ...): PChar;
external name 'XSetICValues';

function XGetICValues (ic: PXIC; ...): PChar;
external name 'XGetICValues';

function XIMOfIC (ic: PXIC): PXIM;
external name 'XIMOfIC';

function XFilterEvent (Event: PXEvent; Window: TWindow): TBool;
external name 'XFilterEvent';

function XmbLookupString (ic: PXIC; Event: PXKeyPressedEvent;
  BufferRet: PChar; BytesBuffer: Integer; var KeysymRet: TKeysym;
  var StatusRet: TStatus): Integer;
external name 'XmbLookupString';

function XwcLookupString (ic: PXIC; Event: PXKeyPressedEvent;
  BufferRet: PWCharT; WCHarsBuf: Integer; var KeysymRet: TKeysym;
  var StatusRet: TStatus): Integer;
external name 'XwcLookupString';

{@subsection internal connections for IMs }

{ @@ rdb is struct _XrmHashBucketRec* }
function XRegisterIMInstantiateCallback (Dpy: PDisplay; rdb: Pointer;
  ResName, ResClass: PChar; Callback: PXIDProc;
  ClientData: TXPointer): TBool;
external name 'XRegisterIMInstantiateCallback';

{ @@ rdb is struct _XrmHashBucketRec* }
function XUnregisterIMInstantiateCallback (Dpy: PDisplay; rdb: Pointer;
  ResName, ResClass: PChar; Callback: PXIDProc;
  ClientData: TXPointer): TBool;
external name 'XUnregisterIMInstantiateCallback';

type
  PXConnectionWatchProc = ^procedure (Dpy: PDisplay; ClientData: TXPointer;
    Fd: Integer; Opening: TBool; WatchData: PXPointer);

function XInternalConnectionNumbers (Dpy: PDisplay; var FdRet: TIntegerArray;
  var CountRet: Integer): TStatus;
external name 'XInternalConnectionNumbers'; 

procedure XProcessInternalConnection (Dpy: PDisplay; Fd: Integer);
external name 'XProcessInternalConnection';

function XAddConnectionWatch (Dpy: PDisplay;
  Callback: PXConnectionWatchProc; ClientData: TXPointer): TStatus;
external name 'XAddConnectionWatch';

procedure XRemoveConnectionWatch (Dpy: PDisplay;
  Callback: PXConnectionWatchProc; ClientData: TXPointer);
external name 'XRemoveConnectionWatch';


implementation

{$L xlibc.c}
{$L X11}

{ functions for checking the type sizes }

function CSizeofWCharT: Cardinal;
external name '__sizeof_wchar_t';
function PSizeofTWCharT: Cardinal;
begin
  PSizeofTWCharT := SizeOf (TWCharT)
end;

function CSizeofXExtData: Cardinal;
external name '__sizeof_xextdata';
function PSizeofTXExtData: Cardinal;
begin
  PSizeofTXExtData := SizeOf (TXExtData)
end;

function CSizeofXExtCodes: Cardinal;
external name '__sizeof_xextcodes';
function PSizeofTXExtCodes: Cardinal;
begin
  PSizeofTXExtCodes := SizeOf (TXExtCodes)
end;

function CSizeofXPixmapFormatValues: Cardinal;
external name '__sizeof_xpixmapformatvalues';
function PSizeofTXPixmapFormatValues: Cardinal;
begin
  PSizeofTXPixmapFormatValues := SizeOf (TXPixmapFormatValues)
end;

function CSizeofXGCValues: Cardinal;
external name '__sizeof_xgcvalues';
function PSizeofTXGCValues: Cardinal;
begin
  PSizeofTXGCValues := SizeOf (TXGCValues)
end;

function CSizeofVisual: Cardinal;
external name '__sizeof_visual';
function PSizeofTVisual: Cardinal;
begin
  PSizeofTVisual := SizeOf (TVisual)
end;

function CSizeofDepth: Cardinal;
external name '__sizeof_depth';
function PSizeofTDepth: Cardinal;
begin
  PSizeofTDepth := SizeOf (TDepth)
end;

function CSizeofScreen: Cardinal;
external name '__sizeof_screen';
function PSizeofTScreen: Cardinal;
begin
  PSizeofTScreen := SizeOf (TScreen)
end;

function CSizeofScreenFormat: Cardinal;
external name '__sizeof_screenformat';
function PSizeofTScreenFormat: Cardinal;
begin
  PSizeofTScreenFormat := SizeOf (TScreenFormat)
end;

function CSizeofXWindowAttributes: Cardinal;
external name '__sizeof_xwindowattributes';
function PSizeofTXWindowAttributes: Cardinal;
begin
  PSizeofTXWindowAttributes := SizeOf (TXWindowAttributes)
end;

function CSizeofXSetWindowAttributes: Cardinal;
external name '__sizeof_xsetwindowattributes';
function PSizeofTXSetWindowAttributes: Cardinal;
begin
  PSizeofTXSetWindowAttributes := SizeOf (TXSetWindowAttributes)
end;

function CSizeofXHostAddress: Cardinal;
external name '__sizeof_xhostaddress';
function PSizeofTXHostAddress: Cardinal;
begin
  PSizeofTXHostAddress := SizeOf (TXHostAddress)
end;

function CSizeofXImage: Cardinal;
external name '__sizeof_ximage';
function PSizeofTXImage: Cardinal;
begin
  PSizeofTXImage := SizeOf (TXImage)
end;

function CSizeofXWindowChanges: Cardinal;
external name '__sizeof_xwindowchanges';
function PSizeofTXWindowChanges: Cardinal;
begin
  PSizeofTXWindowChanges := SizeOf (TXWindowChanges)
end;

function CSizeofXColor: Cardinal;
external name '__sizeof_xcolor';
function PSizeofTXColor: Cardinal;
begin
  PSizeofTXColor := SizeOf (TXColor)
end;

function CSizeofXKeyboardControl: Cardinal;
external name '__sizeof_xkeyboardcontrol';
function PSizeofTXKeyboardControl: Cardinal;
begin
  PSizeofTXKeyboardControl := SizeOf (TXKeyboardControl)
end;

function CSizeofXKeyboardState: Cardinal;
external name '__sizeof_xkeyboardstate';
function PSizeofTXKeyboardState: Cardinal;
begin
  PSizeofTXKeyboardState := SizeOf (TXKeyboardState)
end;

function CSizeofXModifierKeymap: Cardinal;
external name '__sizeof_xmodifierkeymap';
function PSizeofTXModifierKeymap: Cardinal;
begin
  PSizeofTXModifierKeymap := SizeOf (TXModifierKeymap)
end;

function CSizeofXKeyEvent: Cardinal;
external name '__sizeof_xkeyevent';
function PSizeofTXKeyEvent: Cardinal;
begin
  PSizeofTXKeyEvent := SizeOf (TXKeyEvent)
end;

function CSizeofXMotionEvent: Cardinal;
external name '__sizeof_xmotionevent';
function PSizeofTXMotionEvent: Cardinal;
begin
  PSizeofTXMotionEvent := SizeOf (TXMotionEvent)
end;

function CSizeofXCrossingEvent: Cardinal;
external name '__sizeof_xcrossingevent';
function PSizeofTXCrossingEvent: Cardinal;
begin
  PSizeofTXCrossingEvent := SizeOf (TXCrossingEvent)
end;

function CSizeofXFocusChangeEvent: Cardinal;
external name '__sizeof_xfocuschangeevent';
function PSizeofTXFocusChangeEvent: Cardinal;
begin
  PSizeofTXFocusChangeEvent := SizeOf (TXFocusChangeEvent)
end;

function CSizeofXGraphicsExposeEvent: Cardinal;
external name '__sizeof_xgraphicsexposeevent';
function PSizeofTXGraphicsExposeEvent: Cardinal;
begin
  PSizeofTXGraphicsExposeEvent := SizeOf (TXGraphicsExposeEvent)
end;

function CSizeofXClientMessageEvent: Cardinal;
external name '__sizeof_xclientmessageevent';
function PSizeofTXClientMessageEvent: Cardinal;
begin
  PSizeofTXClientMessageEvent := SizeOf (TXClientMessageEvent)
end;

function CSizeofXEvent: Cardinal;
external name '__sizeof_xevent';
function PSizeofTXEvent: Cardinal;
begin
  PSizeofTXEvent := SizeOf (TXEvent)
end;

function CSizeofXFontStruct: Cardinal;
external name '__sizeof_xfontstruct';
function PSizeofTXFontStruct: Cardinal;
begin
  PSizeofTXFontStruct := SizeOf (TXFontStruct)
end;

function CSizeofXEDataObject: Cardinal;
external name '__sizeof_xedataobject';
function PSizeofTXEDataObject: Cardinal;
begin
  PSizeofTXEDataObject := SizeOf (TXEDataObject)
end;

function CSizeofXmbTextItem: Cardinal;
external name '__sizeof_xmbtextitem';
function PSizeofTXmbTextItem: Cardinal;
begin
  PSizeofTXmbTextItem := SizeOf (TXmbTextItem)
end;

function CSizeofXwcTextItem: Cardinal;
external name '__sizeof_xwctextitem';
function PSizeofTXwcTextItem: Cardinal;
begin
  PSizeofTXwcTextItem := SizeOf (TXwcTextItem)
end;

function CSizeofXOMCharSetList: Cardinal;
external name '__sizeof_xomcharsetlist';
function PSizeofTXOMCharSetList: Cardinal;
begin
  PSizeofTXOMCharSetList := SizeOf (TXOMCharSetList)
end;

function CSizeofXOMOrientation: Cardinal;
external name '__sizeof_xomorientation';
function PSizeofTXOMOrientation: Cardinal;
begin
  PSizeofTXOMOrientation := SizeOf (TXOMOrientation)
end;

function CSizeofXOMFontInfo: Cardinal;
external name '__sizeof_xomfontinfo';
function PSizeofTXOMFontInfo: Cardinal;
begin
  PSizeofTXOMFontInfo := SizeOf (TXOMFontInfo)
end;

function CSizeofXVaNestedList: Cardinal;
external name '__sizeof_xvanestedlist';
function  PSizeofXVaNestedList: Cardinal;
begin
  PSizeofXVaNestedList := SizeOf (PXVaNestedList)
end;

function CSizeofXIMStyles: Cardinal;
external name '__sizeof_ximstyles';
function  PSizeofXIMStyles: Cardinal;
begin
  PSizeofXIMStyles := SizeOf (TXIMStyles)
end;

function CSizeofXIMCallback: Cardinal;
external name '__sizeof_ximcallback';
function  PSizeofXIMCallback: Cardinal;
begin
  PSizeofXIMCallback := SizeOf (TXIMCallback)
end;

function CSizeofXICCallback: Cardinal;
external name '__sizeof_xiccallback';
function  PSizeofXICCallback: Cardinal;
begin
  PSizeofXICCallback := SizeOf (TXICCallback)
end;

function CSizeofXIMText: Cardinal;
external name '__sizeof_ximtext';
function  PSizeofXIMText: Cardinal;
begin
  PSizeofXIMText := SizeOf (TXIMText)
end;

function CSizeofXIMPreeditStateNotifyCallbackStruct: Cardinal;
external name '__sizeof_ximpreeditstatenotifycallbackstruct';
function  PSizeofXIMPreeditStateNotifyCallbackStruct: Cardinal;
begin
  PSizeofXIMPreeditStateNotifyCallbackStruct := SizeOf
    (TXIMPreeditStateNotifyCallbackStruct)
end;

function CSizeofXIMStringConversionText: Cardinal;
external name '__sizeof_ximstringconversiontext';
function  PSizeofXIMStringConversionText: Cardinal;
begin
  PSizeofXIMStringConversionText := SizeOf (TXIMStringConversionText)
end;

function CSizeofXIMCaretDirection: Cardinal;
external name '__sizeof_ximcaretdirection';
function  PSizeofXIMCaretDirection: Cardinal;
begin
  PSizeofXIMCaretDirection := SizeOf (TXIMCaretDirection)
end;

function CSizeofXIMStringConversionCallbackStruct: Cardinal;
external name '__sizeof_ximstringconversioncallbackstruct';
function  PSizeofXIMStringConversionCallbackStruct: Cardinal;
begin
  PSizeofXIMStringConversionCallbackStruct := SizeOf
    (TXIMStringConversionCallbackStruct)
end;

function CSizeofXIMPreeditDrawCallbackStruct: Cardinal;
external name '__sizeof_ximpreeditdrawcallbackstruct';
function  PSizeofXIMPreeditDrawCallbackStruct: Cardinal;
begin
  PSizeofXIMPreeditDrawCallbackStruct := SizeOf
    (TXIMPreeditDrawCallbackStruct)
end;

function CSizeofXIMCaretStyle: Cardinal;
external name '__sizeof_ximcaretstyle';
function  PSizeofXIMCaretStyle: Cardinal;
begin
  PSizeofXIMCaretStyle := SizeOf (TXIMCaretStyle)
end;

function CSizeofXIMPreeditCaretCallbackStruct: Cardinal;
external name '__sizeof_ximpreeditcaretcallbackstruct';
function  PSizeofXIMPreeditCaretCallbackStruct: Cardinal;
begin
  PSizeofXIMPreeditCaretCallbackStruct := SizeOf
    (TXIMPreeditCaretCallbackStruct)
end;

function CSizeofXIMStatusDataType: Cardinal;
external name '__sizeof_ximstatusdatatype';
function  PSizeofXIMStatusDataType: Cardinal;
begin
  PSizeofXIMStatusDataType := SizeOf (TXIMStatusDataType)
end;

function CSizeofXIMStatusDrawCallbackStruct: Cardinal;
external name '__sizeof_ximstatusdrawcallbackstruct';
function  PSizeofXIMStatusDrawCallbackStruct: Cardinal;
begin
  PSizeofXIMStatusDrawCallbackStruct := SizeOf (TXIMStatusDrawCallbackStruct)
end;

function CSizeofXIMHotKeyTrigger: Cardinal;
external name '__sizeof_ximhotkeytrigger';
function  PSizeofXIMHotKeyTrigger: Cardinal;
begin
  PSizeofXIMHotKeyTrigger := SizeOf (TXIMHotKeyTrigger)
end;

function CSizeofXIMHotKeyTriggers: Cardinal;
external name '__sizeof_ximhotkeytriggers';
function  PSizeofXIMHotKeyTriggers: Cardinal;
begin
  PSizeofXIMHotKeyTriggers := SizeOf (TXIMHotKeyTriggers)
end;

function CSizeofXIMValuesList: Cardinal;
external name '__sizeof_ximvaluelist';
function  PSizeofXIMValuesList: Cardinal;
begin
  PSizeofXIMValuesList := SizeOf (TXIMValuesList)
end;

to begin do
  begin
    if CSizeofWCharT <> PSizeofTWCharT then
      begin
        WriteLn (StdErr, '(T)WCharT size mismatch!');
        Halt
      end;
    if CSizeofXExtData <> PSizeofTXExtData then
      begin
        WriteLn (StdErr, '(T)XExtData size mismatch!');
        Halt
      end;
    if CSizeofXExtCodes <> PSizeofTXExtCodes then
      begin
        WriteLn (StdErr, '(T)XExtCodes size mismatch!');
        Halt
      end;
    if CSizeofXPixmapFormatValues <> PSizeofTXPixmapFormatValues then
      begin
        WriteLn (StdErr, '(T)XPixmapFormatValues size mismatch!');
        Halt
      end;
    if CSizeofXGCValues <> PSizeofTXGCValues then
      begin
        WriteLn (StdErr, '(T)XGCValues size mismatch!');
        Halt
      end;
    if CSizeofVisual <> PSizeofTVisual then
      begin
        WriteLn (StdErr, '(T)Visual size mismatch!');
        Halt
      end;
    if CSizeofDepth <> PSizeofTDepth then
      begin
        WriteLn (StdErr, '(T)Depth size mismatch!');
        Halt
      end;
    if CSizeofScreen <> PSizeofTScreen then
      begin
        WriteLn (StdErr, '(T)Screen size mismatch!');
        Halt
      end;
    if CSizeofScreenFormat <> PSizeofTScreenFormat then
      begin
        WriteLn (StdErr, '(T)ScreenFormat size mismatch!');
        Halt
      end;
    if CSizeofXWindowAttributes <> PSizeofTXWindowAttributes then
      begin
        WriteLn (StdErr, '(T)XWindowAttributes size mismatch!');
        Halt
      end;
    if CSizeofXSetWindowAttributes <> PSizeofTXSetWindowAttributes then
      begin
        WriteLn (StdErr, '(T)XSetWindowAttributes size mismatch!');
        Halt
      end;
    if CSizeofXHostAddress <> PSizeofTXHostAddress then
      begin
        WriteLn (StdErr, '(T)XHostAddress size mismatch!');
        Halt
      end;
    if CSizeofXImage <> PSizeofTXImage then
      begin
        WriteLn (StdErr, '(T)XImage size mismatch!');
        Halt
      end;
    if CSizeofXWindowChanges <> PSizeofTXWindowChanges then
      begin
        WriteLn (StdErr, '(T)XWindowChanges size mismatch!');
        Halt
      end;
    if CSizeofXColor <> PSizeofTXColor then
      begin
        WriteLn (StdErr, '(T)XColor size mismatch!');
        Halt
      end;
    if CSizeofXKeyboardControl <> PSizeofTXKeyboardControl then
      begin
        WriteLn (StdErr, '(T)XKeyboardControl size mismatch!');
        Halt
      end;
    if CSizeofXKeyboardState <> PSizeofTXKeyboardState then
      begin
        WriteLn (StdErr, '(T)XKeyboardState size mismatch!');
        Halt
      end;
    if CSizeofXModifierKeymap <> PSizeofTXModifierKeymap then
      begin
        WriteLn (StdErr, '(T)XModifierKeymap size mismatch!');
        Halt
      end;
    if CSizeofXKeyEvent <> PSizeofTXKeyEvent then
      begin
        WriteLn (StdErr, '(T)XKeyEvent size mismatch!');
        Halt
      end;
    if CSizeofXMotionEvent <> PSizeofTXMotionEvent then
      begin
        WriteLn (StdErr, '(T)XMotionEvent size mismatch!');
        Halt
      end;
    if CSizeofXCrossingEvent <> PSizeofTXCrossingEvent then
      begin
        WriteLn (StdErr, '(T)XCrossingEvent size mismatch!');
        Halt
    end;
    if CSizeofXFocusChangeEvent <> PSizeofTXFocusChangeEvent then
      begin
        WriteLn (StdErr, '(T)XFocusChangeEvent size mismatch!');
        Halt
      end;
    if CSizeofXGraphicsExposeEvent <> PSizeofTXGraphicsExposeEvent then
      begin
        WriteLn (StdErr, '(T)XGraphicsExposeEvent size mismatch!');
        Halt
      end;
    if CSizeofXClientMessageEvent <> PSizeofTXClientMessageEvent then
      begin
        WriteLn (StdErr, '(T)XClientMessageEvent size mismatch!');
        Halt
      end;
    if CSizeofXEvent <> PSizeofTXEvent then
      begin
        WriteLn (StdErr, '(T)XEvent size mismatch!');
        Halt
      end;
    if CSizeofXFontStruct <> PSizeofTXFontStruct then
      begin
        WriteLn (StdErr, '(T)XFontStruct size mismatch!');
        Halt
      end;
    if CSizeofXEDataObject <> PSizeofTXEDataObject then
      begin
        WriteLn (StdErr, '(T)XEDataObject size mismatch!');
        Halt
      end;
    if CSizeofXmbTextItem <> PSizeofTXmbTextItem then
      begin
        WriteLn (StdErr, '(T)XmbTextItem size mismatch!');
        Halt
      end;
    if CSizeofXwcTextItem <> PSizeofTXwcTextItem then
      begin
        WriteLn (StdErr, '(T)XwcTextItem size mismatch!');
        Halt
      end;
    if CSizeofXOMCharSetList <> PSizeofTXOMCharSetList then
      begin
        WriteLn (StdErr, '(T)XOMCharSetList size mismatch!');
        Halt
      end;
    if CSizeofXOMOrientation <> PSizeofTXOMOrientation then
      begin
        WriteLn (StdErr, '(T)XOMOrientation size mismatch!');
        Halt
      end;
    if CSizeofXOMFontInfo <> PSizeofTXOMFontInfo then
      begin
        WriteLn (StdErr, '(T)XOMFontInfo size mismatch!');
        Halt
      end;
    if CSizeofXVaNestedList <> PSizeofXVaNestedList then
      begin
        WriteLn (StdErr, '(T)XVaNestedList size mismatch!');
        Halt
      end;
    if CSizeofXIMStyles <> PSizeofXIMStyles then
      begin
        WriteLn (StdErr, '(T)XIMStyles size mismatch!');
        Halt
      end;
    if CSizeofXIMCallback <> PSizeofXIMCallback then
      begin
        WriteLn (StdErr, '(T)XIMCallback size mismatch!');
        Halt
      end;
    if CSizeofXICCallback <> PSizeofXICCallback then
      begin
        WriteLn (StdErr, '(T)XICCallback size mismatch!');
        Halt
      end;
    if CSizeofXIMText <> PSizeofXIMText then
      begin
        WriteLn (StdErr, '(T)XIMText size mismatch!');
        Halt
      end;
    if CSizeofXIMPreeditStateNotifyCallbackStruct <> PSizeofXIMPreeditStateNotifyCallbackStruct then
      begin
        WriteLn (StdErr, '(T)XIMPreeditStateNotifyCallbackStruct size mismatch!');
        Halt
      end;
    if CSizeofXIMStringConversionText <> PSizeofXIMStringConversionText then
      begin
        WriteLn (StdErr, '(T)XIMStringConversionText size mismatch!');
        Halt
      end;
    if CSizeofXIMCaretDirection <> PSizeofXIMCaretDirection then
      begin
        WriteLn (StdErr, '(T)XIMCaretDirection size mismatch!');
        Halt
      end;
    if CSizeofXIMStringConversionCallbackStruct <> PSizeofXIMStringConversionCallbackStruct then
      begin
        WriteLn (StdErr, '(T)XIMStringConversionCallbackStruct size mismatch!');
        Halt
      end;
    if CSizeofXIMPreeditDrawCallbackStruct <> PSizeofXIMPreeditDrawCallbackStruct then
      begin
        WriteLn (StdErr, '(T)XIMPreeditDrawCallbackStruct size mismatch!');
        Halt
      end;
    if CSizeofXIMCaretStyle <> PSizeofXIMCaretStyle then
      begin
        WriteLn (StdErr, '(T)XIMCaretStyle size mismatch!');
        Halt
      end;
    if CSizeofXIMPreeditCaretCallbackStruct <> PSizeofXIMPreeditCaretCallbackStruct then
      begin
        WriteLn (StdErr, '(T)XIMPreeditCaretCallbackStruct size mismatch!');
        Halt
      end;
    if CSizeofXIMStatusDataType <> PSizeofXIMStatusDataType then
      begin
        WriteLn (StdErr, '(T)XIMStatusDataType size mismatch!');
        Halt
      end;
    if CSizeofXIMStatusDrawCallbackStruct <> PSizeofXIMStatusDrawCallbackStruct then
      begin
        WriteLn (StdErr, '(T)XIMStatusDrawCallbackStruct size mismatch!');
        Halt
      end;
    if CSizeofXIMHotKeyTrigger <> PSizeofXIMHotKeyTrigger then
      begin
        WriteLn (StdErr, '(T)XIMHotKeyTrigger size mismatch!');
        Halt
      end;
    if CSizeofXIMHotKeyTriggers <> PSizeofXIMHotKeyTriggers then
      begin
        WriteLn (StdErr, '(T)XIMHotKeyTriggers size mismatch!');
        Halt
      end;
    if CSizeofXIMValuesList <> PSizeofXIMValuesList then
      begin
        WriteLn (StdErr, '(T)XIMValuesList size mismatch!');
        Halt
      end;
  end;
end.
