/*Support routines for xlib.pas, Xlib unit for GNU Pascal

  Copyright (C) 2002,2003 by Eike Lange

  Author: Eike Lange <eike@g-n-u.de>

  This unit is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as
  published by the Free Software Foundation, version 2.

  This unit is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; see the file COPYING.LIB. If not,
  write to the Free Software Foundation, Inc., 59 Temple Place -
  Suite 330, Boston, MA 02111-1307, USA. */

/*Please note the original copyright notice on top of
  Xlib.h and X.h */

#include <X11/X.h>
#include <X11/Xlib.h>

/* Consts from X.h */
int _p_X_PROTOCOL = X_PROTOCOL;
int _p_X_PROTOCOL_REVISION = X_PROTOCOL_REVISION;
int _p_None = None;
int _p_ParentRelative = ParentRelative;
int _p_CopyFromParent = CopyFromParent;
int _p_PointerWindow = PointerWindow;
int _p_InputFocus = InputFocus;
int _p_PointerRoot = PointerRoot;
int _p_AnyPropertyType = AnyPropertyType;
int _p_AnyKey = AnyKey;
int _p_AnyButton = AnyButton;
int _p_AllTemporary = AllTemporary;
int _p_CurrentTime = CurrentTime;
int _p_NoSymbol = NoSymbol;
int _p_NoEventMask = NoEventMask;
int _p_KeyPressMask = KeyPressMask;
int _p_KeyReleaseMask = KeyReleaseMask;
int _p_ButtonPressMask = ButtonPressMask;
int _p_ButtonReleaseMask = ButtonReleaseMask;
int _p_EnterWindowMask = EnterWindowMask;
int _p_LeaveWindowMask = LeaveWindowMask;
int _p_PointerMotionMask = PointerMotionMask;
int _p_PointerMotionHintMask = PointerMotionHintMask;
int _p_Button1MotionMask = Button1MotionMask;
int _p_Button2MotionMask = Button2MotionMask;
int _p_Button3MotionMask = Button3MotionMask;
int _p_Button4MotionMask = Button4MotionMask;
int _p_Button5MotionMask = Button5MotionMask;
int _p_ButtonMotionMask = ButtonMotionMask;
int _p_KeymapStateMask = KeymapStateMask;
int _p_ExposureMask = ExposureMask;
int _p_VisibilityChangeMask = VisibilityChangeMask;
int _p_StructureNotifyMask = StructureNotifyMask;
int _p_ResizeRedirectMask = ResizeRedirectMask;
int _p_SubstructureNotifyMask = SubstructureNotifyMask;
int _p_SubstructureRedirectMask = SubstructureRedirectMask;
int _p_FocusChangeMask = FocusChangeMask;
int _p_PropertyChangeMask = PropertyChangeMask;
int _p_ColormapChangeMask = ColormapChangeMask;
int _p_OwnerGrabButtonMask = OwnerGrabButtonMask;
int _p_KeyPress = KeyPress;
int _p_KeyRelease = KeyRelease;
int _p_ButtonPress = ButtonPress;
int _p_ButtonRelease = ButtonRelease;
int _p_MotionNotify = MotionNotify;
int _p_EnterNotify = EnterNotify;
int _p_LeaveNotify = LeaveNotify;
int _p_FocusIn = FocusIn;
int _p_FocusOut = FocusOut;
int _p_KeymapNotify = KeymapNotify;
int _p_Expose = Expose;
int _p_GraphicsExpose = GraphicsExpose;
int _p_NoExpose = NoExpose;
int _p_VisibilityNotify = VisibilityNotify;
int _p_CreateNotify = CreateNotify;
int _p_DestroyNotify = DestroyNotify;
int _p_UnmapNotify = UnmapNotify;
int _p_MapNotify = MapNotify;
int _p_MapRequest = MapRequest;
int _p_ReparentNotify = ReparentNotify;
int _p_ConfigureNotify = ConfigureNotify;
int _p_ConfigureRequest = ConfigureRequest;
int _p_GravityNotify = GravityNotify;
int _p_ResizeRequest = ResizeRequest;
int _p_CirculateNotify = CirculateNotify;
int _p_CirculateRequest = CirculateRequest;
int _p_PropertyNotify = PropertyNotify;
int _p_SelectionClear = SelectionClear;
int _p_SelectionRequest = SelectionRequest;
int _p_SelectionNotify = SelectionNotify;
int _p_ColormapNotify = ColormapNotify;
int _p_ClientMessage = ClientMessage;
int _p_MappingNotify = MappingNotify;
int _p_LASTEvent = LASTEvent;
int _p_ShiftMask = ShiftMask;
int _p_LockMask = LockMask;
int _p_ControlMask = ControlMask;
int _p_Mod1Mask = Mod1Mask;
int _p_Mod2Mask = Mod2Mask;
int _p_Mod3Mask = Mod3Mask;
int _p_Mod4Mask = Mod4Mask;
int _p_Mod5Mask = Mod5Mask;
int _p_ShiftMapIndex = ShiftMapIndex;
int _p_LockMapIndex = LockMapIndex;
int _p_ControlMapIndex = ControlMapIndex;
int _p_Mod1MapIndex = Mod1MapIndex;
int _p_Mod2MapIndex = Mod2MapIndex;
int _p_Mod3MapIndex = Mod3MapIndex;
int _p_Mod4MapIndex = Mod4MapIndex;
int _p_Mod5MapIndex = Mod5MapIndex;
int _p_Button1Mask = Button1Mask;
int _p_Button2Mask = Button2Mask;
int _p_Button3Mask = Button3Mask;
int _p_Button4Mask = Button4Mask;
int _p_Button5Mask = Button5Mask;
int _p_AnyModifier = AnyModifier;
int _p_Button1 = Button1;
int _p_Button2 = Button2;
int _p_Button3 = Button3;
int _p_Button4 = Button4;
int _p_Button5 = Button5;
int _p_NotifyNormal = NotifyNormal;
int _p_NotifyGrab = NotifyGrab;
int _p_NotifyUngrab = NotifyUngrab;
int _p_NotifyWhileGrabbed = NotifyWhileGrabbed;
int _p_NotifyHint = NotifyHint;
int _p_NotifyAncestor = NotifyAncestor;
int _p_NotifyVirtual = NotifyVirtual;
int _p_NotifyInferior = NotifyInferior;
int _p_NotifyNonlinear = NotifyNonlinear;
int _p_NotifyNonlinearVirtual = NotifyNonlinearVirtual;
int _p_NotifyPointer = NotifyPointer;
int _p_NotifyPointerRoot = NotifyPointerRoot;
int _p_NotifyDetailNone = NotifyDetailNone;
int _p_VisibilityUnobscured = VisibilityUnobscured;
int _p_VisibilityPartiallyObscured = VisibilityPartiallyObscured;
int _p_VisibilityFullyObscured = VisibilityFullyObscured;
int _p_PlaceOnTop = PlaceOnTop;
int _p_PlaceOnBottom = PlaceOnBottom;
int _p_FamilyInternet = FamilyInternet;
int _p_FamilyDECnet = FamilyDECnet;
int _p_FamilyChaos = FamilyChaos;
int _p_PropertyNewValue = PropertyNewValue;
int _p_PropertyDelete = PropertyDelete;
int _p_ColormapUninstalled = ColormapUninstalled;
int _p_ColormapInstalled = ColormapInstalled;
int _p_GrabModeSync = GrabModeSync;
int _p_GrabModeAsync = GrabModeAsync;
int _p_GrabSuccess = GrabSuccess;
int _p_AlreadyGrabbed = AlreadyGrabbed;
int _p_GrabInvalidTime = GrabInvalidTime;
int _p_GrabNotViewable = GrabNotViewable;
int _p_GrabFrozen = GrabFrozen;
int _p_AsyncPointer = AsyncPointer;
int _p_SyncPointer = SyncPointer;
int _p_ReplayPointer = ReplayPointer;
int _p_AsyncKeyboard = AsyncKeyboard;
int _p_SyncKeyboard = SyncKeyboard;
int _p_ReplayKeyboard = ReplayKeyboard;
int _p_AsyncBoth = AsyncBoth;
int _p_SyncBoth = SyncBoth;
int _p_RevertToNone = RevertToNone;
int _p_RevertToPointerRoot = RevertToPointerRoot;
int _p_RevertToParent = RevertToParent;
int _p_Success = Success;
int _p_BadRequest = BadRequest;
int _p_BadValue = BadValue;
int _p_BadWindow = BadWindow;
int _p_BadPixmap = BadPixmap;
int _p_BadAtom = BadAtom;
int _p_BadCursor = BadCursor;
int _p_BadFont = BadFont;
int _p_BadMatch = BadMatch;
int _p_BadDrawable = BadDrawable;
int _p_BadAccess = BadAccess;
int _p_BadAlloc = BadAlloc;
int _p_BadColor = BadColor;
int _p_BadGC = BadGC;
int _p_BadIDChoice = BadIDChoice;
int _p_BadName = BadName;
int _p_BadLength = BadLength;
int _p_BadImplementation = BadImplementation;
int _p_FirstExtensionError = FirstExtensionError;
int _p_LastExtensionError = LastExtensionError;
int _p_InputOutput = InputOutput;
int _p_InputOnly = InputOnly;
int _p_CWBackPixmap = CWBackPixmap;
int _p_CWBackPixel = CWBackPixel;
int _p_CWBorderPixmap = CWBorderPixmap;
int _p_CWBorderPixel = CWBorderPixel;
int _p_CWBitGravity = CWBitGravity;
int _p_CWWinGravity = CWWinGravity;
int _p_CWBackingStore = CWBackingStore;
int _p_CWBackingPlanes = CWBackingPlanes;
int _p_CWBackingPixel = CWBackingPixel;
int _p_CWOverrideRedirect = CWOverrideRedirect;
int _p_CWSaveUnder = CWSaveUnder;
int _p_CWEventMask = CWEventMask;
int _p_CWDontPropagate = CWDontPropagate;
int _p_CWColormap = CWColormap;
int _p_CWCursor = CWCursor;
int _p_CWX = CWX;
int _p_CWY = CWY;
int _p_CWWidth = CWWidth;
int _p_CWHeight = CWHeight;
int _p_CWBorderWidth = CWBorderWidth;
int _p_CWSibling = CWSibling;
int _p_CWStackMode = CWStackMode;
int _p_ForgetGravity = ForgetGravity;
int _p_NorthWestGravity = NorthWestGravity;
int _p_NorthGravity = NorthGravity;
int _p_NorthEastGravity = NorthEastGravity;
int _p_WestGravity = WestGravity;
int _p_CenterGravity = CenterGravity;
int _p_EastGravity = EastGravity;
int _p_SouthWestGravity = SouthWestGravity;
int _p_SouthGravity = SouthGravity;
int _p_SouthEastGravity = SouthEastGravity;
int _p_StaticGravity = StaticGravity;
int _p_UnmapGravity = UnmapGravity;
int _p_NotUseful = NotUseful;
int _p_WhenMapped = WhenMapped;
int _p_Always = Always;
int _p_IsUnmapped = IsUnmapped;
int _p_IsUnviewable = IsUnviewable;
int _p_IsViewable = IsViewable;
int _p_SetModeInsert = SetModeInsert;
int _p_SetModeDelete = SetModeDelete;
int _p_DestroyAll = DestroyAll;
int _p_RetainPermanent = RetainPermanent;
int _p_RetainTemporary = RetainTemporary;
int _p_Above = Above;
int _p_Below = Below;
int _p_TopIf = TopIf;
int _p_BottomIf = BottomIf;
int _p_Opposite = Opposite;
int _p_RaiseLowest = RaiseLowest;
int _p_LowerHighest = LowerHighest;
int _p_PropModeReplace = PropModeReplace;
int _p_PropModePrepend = PropModePrepend;
int _p_PropModeAppend = PropModeAppend;
int _p_GXclear = GXclear;
int _p_GXand = GXand;
int _p_GXandReverse = GXandReverse;
int _p_GXcopy = GXcopy;
int _p_GXandInverted = GXandInverted;
int _p_GXnoop = GXnoop;
int _p_GXxor = GXxor;
int _p_GXor = GXor;
int _p_GXnor = GXnor;
int _p_GXequiv = GXequiv;
int _p_GXinvert = GXinvert;
int _p_GXorReverse = GXorReverse;
int _p_GXcopyInverted = GXcopyInverted;
int _p_GXorInverted = GXorInverted;
int _p_GXnand = GXnand;
int _p_GXset = GXset;
int _p_LineSolid = LineSolid;
int _p_LineOnOffDash = LineOnOffDash;
int _p_LineDoubleDash = LineDoubleDash;
int _p_CapNotLast = CapNotLast;
int _p_CapButt = CapButt;
int _p_CapRound = CapRound;
int _p_CapProjecting = CapProjecting;
int _p_JoinMiter = JoinMiter;
int _p_JoinRound = JoinRound;
int _p_JoinBevel = JoinBevel;
int _p_FillSolid = FillSolid;
int _p_FillTiled = FillTiled;
int _p_FillStippled = FillStippled;
int _p_FillOpaqueStippled = FillOpaqueStippled;
int _p_EvenOddRule = EvenOddRule;
int _p_WindingRule = WindingRule;
int _p_ClipByChildren = ClipByChildren;
int _p_IncludeInferiors = IncludeInferiors;
int _p_Unsorted = Unsorted;
int _p_YSorted = YSorted;
int _p_YXSorted = YXSorted;
int _p_YXBanded = YXBanded;
int _p_CoordModeOrigin = CoordModeOrigin;
int _p_CoordModePrevious = CoordModePrevious;
int _p_Complex = Complex;
int _p_Nonconvex = Nonconvex;
int _p_Convex = Convex;
int _p_ArcChord = ArcChord;
int _p_ArcPieSlice = ArcPieSlice;
int _p_GCFunction = GCFunction;
int _p_GCPlaneMask = GCPlaneMask;
int _p_GCForeground = GCForeground;
int _p_GCBackground = GCBackground;
int _p_GCLineWidth = GCLineWidth;
int _p_GCLineStyle = GCLineStyle;
int _p_GCCapStyle = GCCapStyle;
int _p_GCJoinStyle = GCJoinStyle;
int _p_GCFillStyle = GCFillStyle;
int _p_GCFillRule = GCFillRule;
int _p_GCTile = GCTile;
int _p_GCStipple = GCStipple;
int _p_GCTileStipXOrigin = GCTileStipXOrigin;
int _p_GCTileStipYOrigin = GCTileStipYOrigin;
int _p_GCFont = GCFont;
int _p_GCSubwindowMode = GCSubwindowMode;
int _p_GCGraphicsExposures = GCGraphicsExposures;
int _p_GCClipXOrigin = GCClipXOrigin;
int _p_GCClipYOrigin = GCClipYOrigin;
int _p_GCClipMask = GCClipMask;
int _p_GCDashOffset = GCDashOffset;
int _p_GCDashList = GCDashList;
int _p_GCArcMode = GCArcMode;
int _p_GCLastBit = GCLastBit;
int _p_FontLeftToRight = FontLeftToRight;
int _p_FontRightToLeft = FontRightToLeft;
int _p_FontChange = FontChange;
int _p_XYBitmap = XYBitmap;
int _p_XYPixmap = XYPixmap;
int _p_ZPixmap = ZPixmap;
int _p_AllocNone = AllocNone;
int _p_AllocAll = AllocAll;
int _p_DoRed = DoRed;
int _p_DoGreen = DoGreen;
int _p_DoBlue = DoBlue;
int _p_CursorShape = CursorShape;
int _p_TileShape = TileShape;
int _p_StippleShape = StippleShape;
int _p_AutoRepeatModeOff = AutoRepeatModeOff;
int _p_AutoRepeatModeOn = AutoRepeatModeOn;
int _p_AutoRepeatModeDefault = AutoRepeatModeDefault;
int _p_LedModeOff = LedModeOff;
int _p_LedModeOn = LedModeOn;
int _p_KBKeyClickPercent = KBKeyClickPercent;
int _p_KBBellPercent = KBBellPercent;
int _p_KBBellPitch = KBBellPitch;
int _p_KBBellDuration = KBBellDuration;
int _p_KBLed = KBLed;
int _p_KBLedMode = KBLedMode;
int _p_KBKey = KBKey;
int _p_KBAutoRepeatMode = KBAutoRepeatMode;
int _p_MappingSuccess = MappingSuccess;
int _p_MappingBusy = MappingBusy;
int _p_MappingFailed = MappingFailed;
int _p_MappingModifier = MappingModifier;
int _p_MappingKeyboard = MappingKeyboard;
int _p_MappingPointer = MappingPointer;
int _p_DontPreferBlanking = DontPreferBlanking;
int _p_PreferBlanking = PreferBlanking;
int _p_DefaultBlanking = DefaultBlanking;
int _p_DisableScreenSaver = DisableScreenSaver;
int _p_DisableScreenInterval = DisableScreenInterval;
int _p_DontAllowExposures = DontAllowExposures;
int _p_AllowExposures = AllowExposures;
int _p_DefaultExposures = DefaultExposures;
int _p_ScreenSaverReset = ScreenSaverReset;
int _p_ScreenSaverActive = ScreenSaverActive;
int _p_HostInsert = HostInsert;
int _p_HostDelete = HostDelete;
int _p_EnableAccess = EnableAccess;
int _p_DisableAccess = DisableAccess;
int _p_StaticGray = StaticGray;
int _p_GrayScale = GrayScale;
int _p_StaticColor = StaticColor;
int _p_PseudoColor = PseudoColor;
int _p_TrueColor = TrueColor;
int _p_DirectColor = DirectColor;
int _p_LSBFirst = LSBFirst;
int _p_MSBFirst = MSBFirst;

/* Consts from Xlib.h */
int _p_True = True;
int _p_False = False;
int _p_QueuedAlready = QueuedAlready;
int _p_QueuedAfterReading = QueuedAfterReading;
int _p_QueuedAfterFlush = QueuedAfterFlush;
int _p_XIMPreeditArea = XIMPreeditArea;
int _p_XIMPreeditCallbacks = XIMPreeditCallbacks;
int _p_XIMPreeditPosition = XIMPreeditPosition;
int _p_XIMPreeditNothing = XIMPreeditNothing;
int _p_XIMPreeditNone = XIMPreeditNone;
int _p_XIMStatusArea = XIMStatusArea;
int _p_XIMStatusCallbacks = XIMStatusCallbacks;
int _p_XIMStatusNothing = XIMStatusNothing;
int _p_XIMStatusNone = XIMStatusNone;
int _p_XBufferOverflow = XBufferOverflow;
int _p_XLookupNone = XLookupNone;
int _p_XLookupChars = XLookupChars;
int _p_XLookupKeySym = XLookupKeySym;
int _p_XLookupBoth = XLookupBoth;
int _p_XIMReverse = XIMReverse;
int _p_XIMUnderline = XIMUnderline;
int _p_XIMHighlight = XIMHighlight;
int _p_XIMPrimary = XIMPrimary;
int _p_XIMSecondary = XIMSecondary;
int _p_XIMTertiary = XIMTertiary;
int _p_XIMVisibleToForward = XIMVisibleToForward;
int _p_XIMVisibleToBackword = XIMVisibleToBackword;
int _p_XIMVisibleToCenter = XIMVisibleToCenter;
char* _p_XNRequiredCharSet = XNRequiredCharSet;
char* _p_XNQueryOrientation = XNQueryOrientation;
char* _p_XNBaseFontName = XNBaseFontName;
char* _p_XNOMAutomatic = XNOMAutomatic;
char* _p_XNMissingCharSet = XNMissingCharSet;
char* _p_XNDefaultString = XNDefaultString;
char* _p_XNOrientation = XNOrientation;
char* _p_XNDirectionalDependentDrawing = XNDirectionalDependentDrawing;
char* _p_XNContextualDrawing = XNContextualDrawing;
char* _p_XNFontInfo = XNFontInfo;
char* _p_XNVaNestedList = XNVaNestedList;
char* _p_XNQueryInputStyle = XNQueryInputStyle;
char* _p_XNClientWindow = XNClientWindow;
char* _p_XNInputStyle = XNInputStyle;
char* _p_XNFocusWindow = XNFocusWindow;
char* _p_XNResourceName = XNResourceName;
char* _p_XNResourceClass = XNResourceClass;
char* _p_XNGeometryCallback = XNGeometryCallback;
char* _p_XNDestroyCallback = XNDestroyCallback;
char* _p_XNFilterEvents = XNFilterEvents;
char* _p_XNPreeditStartCallback = XNPreeditStartCallback;
char* _p_XNPreeditDoneCallback = XNPreeditDoneCallback;
char* _p_XNPreeditDrawCallback = XNPreeditDrawCallback;
char* _p_XNPreeditCaretCallback = XNPreeditCaretCallback;
char* _p_XNPreeditStateNotifyCallback = XNPreeditStateNotifyCallback;
char* _p_XNPreeditAttributes = XNPreeditAttributes;
char* _p_XNStatusStartCallback = XNStatusStartCallback;
char* _p_XNStatusDoneCallback = XNStatusDoneCallback;
char* _p_XNStatusDrawCallback = XNStatusDrawCallback;
char* _p_XNStatusAttributes = XNStatusAttributes;
char* _p_XNArea = XNArea;
char* _p_XNAreaNeeded = XNAreaNeeded;
char* _p_XNSpotLocation = XNSpotLocation;
char* _p_XNColormap = XNColormap;
char* _p_XNStdColormap = XNStdColormap;
char* _p_XNForeground = XNForeground;
char* _p_XNBackground = XNBackground;
char* _p_XNBackgroundPixmap = XNBackgroundPixmap;
char* _p_XNFontSet = XNFontSet;
char* _p_XNLineSpace = XNLineSpace;
char* _p_XNCursor = XNCursor;
char* _p_XNQueryIMValuesList = XNQueryIMValuesList;
char* _p_XNQueryICValuesList = XNQueryICValuesList;
char* _p_XNVisiblePosition = XNVisiblePosition;
char* _p_XNR6PreeditCallback = XNR6PreeditCallback;
char* _p_XNStringConversionCallback = XNStringConversionCallback;
char* _p_XNStringConversion = XNStringConversion;
char* _p_XNResetState = XNResetState;
char* _p_XNHotKey = XNHotKey;
char* _p_XNHotKeyState = XNHotKeyState;
char* _p_XNPreeditState = XNPreeditState;
char* _p_XNSeparatorofNestedList = XNSeparatorofNestedList;

int _p_XIMPreeditUnKnown = XIMPreeditUnKnown;
int _p_XIMPreeditEnable = XIMPreeditEnable;
int _p_XIMPreeditDisable = XIMPreeditDisable;
int _p_XIMInitialState = XIMInitialState;
int _p_XIMPreserveState = XIMPreserveState;
int _p_XIMStringConversionLeftEdge = XIMStringConversionLeftEdge;
int _p_XIMStringConversionRightEdge = XIMStringConversionRightEdge;
int _p_XIMStringConversionTopEdge = XIMStringConversionTopEdge;
int _p_XIMStringConversionBottomEdge = XIMStringConversionBottomEdge;
int _p_XIMStringConversionConcealed = XIMStringConversionConcealed;
int _p_XIMStringConversionWrapped = XIMStringConversionWrapped;
int _p_XIMStringConversionBuffer = XIMStringConversionBuffer;
int _p_XIMStringConversionLine = XIMStringConversionLine;
int _p_XIMStringConversionWord = XIMStringConversionWord;
int _p_XIMStringConversionChar = XIMStringConversionChar;
int _p_XIMStringConversionSubstitution = XIMStringConversionSubstitution;
int _p_XIMStringConversionRetrieval = XIMStringConversionRetrieval;
int _p_XIMHotKeyStateON = XIMHotKeyStateON;
int _p_XIMHotKeyStateOFF = XIMHotKeyStateOFF;

/* consts from enums in Xlib.h */
int _p_XOMOrientation_LTR_TTB = XOMOrientation_LTR_TTB;
int _p_XOMOrientation_RTL_TTB = XOMOrientation_RTL_TTB;
int _p_XOMOrientation_TTB_LTR = XOMOrientation_TTB_LTR;
int _p_XOMOrientation_TTB_RTL = XOMOrientation_TTB_RTL;
int _p_XOMOrientation_Context = XOMOrientation_Context;
int _p_XIMForwardChar = XIMForwardChar;
int _p_XIMBackwardChar = XIMBackwardChar;
int _p_XIMForwardWord = XIMForwardWord;
int _p_XIMBackwardWord = XIMBackwardWord;
int _p_XIMCaretUp = XIMCaretUp;
int _p_XIMCaretDown = XIMCaretDown;
int _p_XIMNextLine = XIMNextLine;
int _p_XIMPreviousLine = XIMPreviousLine;
int _p_XIMLineStart = XIMLineStart;
int _p_XIMLineEnd = XIMLineEnd;
int _p_XIMAbsolutePosition = XIMAbsolutePosition;
int _p_XIMDontChange = XIMDontChange;
int _p_XIMIsInvisible = XIMIsInvisible;
int _p_XIMIsPrimary = XIMIsPrimary;
int _p_XIMIsSecondary = XIMIsSecondary;
int _p_XIMTextType = XIMTextType;
int _p_XIMBitmapType = XIMBitmapType;

/* Macros from Xlib.h */

int _p_ConnectionNumber (Display *dpy)
{
  return ConnectionNumber (dpy);
}

Window _p_RootWindow(Display *dpy, int scr)
{
  return RootWindow(dpy, scr);
}

int _p_DefaultScreen (Display *dpy)
{
  return DefaultScreen (dpy);
}

Window _p_DefaultRootWindow (Display *dpy)
{
  return DefaultRootWindow (dpy);
}

Visual *_p_DefaultVisual(Display *dpy, int scr)
{
  return DefaultVisual(dpy, scr);
}

GC _p_DefaultGC(Display *dpy, int scr)
{
  return DefaultGC(dpy, scr);
}

unsigned long _p_BlackPixel(Display *dpy, int scr)
{
  return BlackPixel(dpy, scr);
}

unsigned long _p_WhitePixel(Display *dpy, int scr)
{
  return WhitePixel(dpy, scr);
}

unsigned long _p_AllPlanes ()
{
  return AllPlanes;
}

int _p_QLength(Display *dpy)
{
  return QLength(dpy);
}

int _p_DisplayWidth(Display *dpy, int scr)
{
  return DisplayWidth(dpy, scr);
}

int _p_DisplayHeight(Display *dpy, int scr)
{
  return DisplayHeight(dpy, scr);
}

int _p_DisplayWidthMM(Display *dpy, int scr)
{
  return DisplayWidthMM(dpy, scr);
}

int _p_DisplayHeightMM(Display *dpy, int scr)
{
  return DisplayHeightMM(dpy, scr);
}

int _p_DisplayPlanes(Display *dpy, int scr)
{
  return DisplayPlanes(dpy, scr);
}

int _p_DisplayCells(Display *dpy, int scr)
{
  return DisplayCells(dpy, scr);
}

int _p_ScreenCount(Display *dpy)
{
  return ScreenCount(dpy);
}

char *_p_ServerVendor(Display *dpy)
{
  return ServerVendor(dpy);
}

int _p_ProtocolVersion(Display *dpy)
{
  return ProtocolVersion(dpy);
}

int _p_ProtocolRevision(Display *dpy)
{
  return ProtocolRevision(dpy);
}

int _p_VendorRelease(Display *dpy)
{
  return VendorRelease(dpy);
}

char *_p_DisplayString(Display *dpy)
{
  return DisplayString(dpy);
}

int _p_DefaultDepth(Display *dpy, int scr)
{
  return DefaultDepth(dpy, scr);
}

Colormap _p_DefaultColormap(Display *dpy, int scr)
{
  return DefaultColormap(dpy, scr);
}

int _p_BitmapUnit(Display *dpy)
{
  return BitmapUnit(dpy);
}

int _p_BitmapBitOrder(Display *dpy)
{
  return BitmapBitOrder(dpy);
}

int _p_BitmapPad(Display *dpy)
{
  return BitmapPad(dpy);
}

int _p_ImageByteOrder(Display *dpy)
{
  return ImageByteOrder(dpy);
}

unsigned long _p_NextRequest(Display *dpy)
{
  return NextRequest(dpy);
}

unsigned long _p_LastKnownRequestProcessed(Display *dpy)
{
  return LastKnownRequestProcessed(dpy);
}

/* Toolkit Makros from Xlib.h */

Screen *_p_ScreenOfDisplay(Display *dpy, int scr)
{
  return ScreenOfDisplay(dpy, scr);
}

Screen *_p_DefaultScreenOfDisplay(Display *dpy)
{
  return DefaultScreenOfDisplay(dpy);
}

Display *_p_DisplayOfScreen(Screen *s)
{
  return DisplayOfScreen(s);
}

Window _p_RootWindowOfScreen(Screen *s)
{
  return RootWindowOfScreen(s);
}

unsigned long _p_BlackPixelOfScreen(Screen *s)
{
  return BlackPixelOfScreen(s);
}

unsigned long _p_WhitePixelOfScreen(Screen *s)
{
  return WhitePixelOfScreen(s);
}

Colormap _p_DefaultColormapOfScreen(Screen *s)
{
  return DefaultColormapOfScreen(s);
}

int _p_DefaultDepthOfScreen(Screen *s)
{
  return DefaultDepthOfScreen(s);
}

GC _p_DefaultGCOfScreen(Screen *s)
{
  return DefaultGCOfScreen(s);
}

Visual *_p_DefaultVisualOfScreen(Screen *s)
{
  return DefaultVisualOfScreen(s);
}

int _p_WidthOfScreen(Screen *s)
{
  return WidthOfScreen(s);
}

int _p_HeightOfScreen(Screen *s)
{
  return HeightOfScreen(s);
}

int _p_WidthMMOfScreen(Screen *s)
{
  return WidthMMOfScreen(s);
}

int _p_HeightMMOfScreen(Screen *s)
{
  return HeightMMOfScreen(s);
}

int _p_PlanesOfScreen(Screen *s)
{
  return PlanesOfScreen(s);
}

int _p_CellsOfScreen(Screen *s)
{
  return CellsOfScreen(s);
}

int _p_MinCmapsOfScreen(Screen *s)
{
  return MinCmapsOfScreen(s);
}

int _p_MaxCmapsOfScreen(Screen *s)
{
  return MaxCmapsOfScreen(s);
}

Bool _p_DoesSaveUnders(Screen *s)
{
  return DoesSaveUnders(s);
}

int _p_DoesBackingStore(Screen *s)
{
  return DoesBackingStore(s);
}

long _p_EventMaskOfScreen(Screen *s)
{
  return EventMaskOfScreen(s);
}

XID _p_XAllocID(Display *dpy)
{
  return XAllocID(dpy);
}

/* type checking for Xlib.h */

unsigned int  __sizeof_wchar_t (void)
{
  return (sizeof (wchar_t));
}
unsigned int  __sizeof_xextdata (void)
{
  return (sizeof (XExtData));
}
unsigned int  __sizeof_xextcodes (void)
{
  return (sizeof (XExtCodes));
}
unsigned int  __sizeof_xpixmapformatvalues (void)
{
  return (sizeof (XPixmapFormatValues));
}
unsigned int  __sizeof_xgcvalues (void)
{
  return (sizeof (XGCValues));
}
unsigned int  __sizeof_visual (void)
{
  return (sizeof (Visual));
}
unsigned int  __sizeof_depth (void)
{
  return (sizeof (Depth));
}
unsigned int  __sizeof_screen (void)
{
  return (sizeof (Screen));
}
unsigned int  __sizeof_screenformat (void)
{
  return (sizeof (ScreenFormat));
}
unsigned int  __sizeof_xwindowattributes (void)
{
  return (sizeof (XWindowAttributes));
}
unsigned int  __sizeof_xsetwindowattributes (void)
{
  return (sizeof (XSetWindowAttributes));
}
unsigned int  __sizeof_xhostaddress (void)
{
  return (sizeof (XHostAddress));
}
unsigned int  __sizeof_ximage (void)
{
  return (sizeof (XImage));
}
unsigned int  __sizeof_xwindowchanges (void)
{
  return (sizeof (XWindowChanges));
}
unsigned int  __sizeof_xcolor (void)
{
  return (sizeof (XColor));
}
unsigned int  __sizeof_xkeyboardcontrol (void)
{
  return (sizeof (XKeyboardControl));
}
unsigned int  __sizeof_xkeyboardstate (void)
{
  return (sizeof (XKeyboardState));
}
unsigned int  __sizeof_xmodifierkeymap (void)
{
  return (sizeof (XModifierKeymap));
}
unsigned int  __sizeof_xkeyevent (void)
{
  return (sizeof (XKeyEvent));
}
unsigned int  __sizeof_xmotionevent (void)
{
  return (sizeof (XMotionEvent));
}
unsigned int  __sizeof_xcrossingevent (void)
{
  return (sizeof (XCrossingEvent));
}
unsigned int  __sizeof_xfocuschangeevent (void)
{
  return (sizeof (XFocusChangeEvent));
}
unsigned int  __sizeof_xgraphicsexposeevent (void)
{
  return (sizeof (XGraphicsExposeEvent));
}
unsigned int  __sizeof_xclientmessageevent (void)
{
  return (sizeof (XClientMessageEvent));
}
unsigned int  __sizeof_xevent (void)
{
  return (sizeof (XEvent));
}
unsigned int  __sizeof_xfontstruct (void)
{
  return (sizeof (XFontStruct));
}
unsigned int  __sizeof_xedataobject (void)
{
  return (sizeof (XEDataObject));
}
unsigned int  __sizeof_xmbtextitem (void)
{
  return (sizeof (XmbTextItem));
}
unsigned int  __sizeof_xwctextitem (void)
{
  return (sizeof (XwcTextItem));
}
unsigned int  __sizeof_xomcharsetlist (void)
{
  return (sizeof (XOMCharSetList));
}
unsigned int  __sizeof_xomorientation (void)
{
  return (sizeof (XOMOrientation));
}
unsigned int  __sizeof_xomfontinfo (void)
{
  return (sizeof (XOMFontInfo));
}
unsigned int __sizeof_xvanestedlist (void)
{
  return (sizeof (XVaNestedList));
}
unsigned int __sizeof_ximstyles (void)
{
  return (sizeof (XIMStyles));
}
unsigned int __sizeof_ximcallback (void)
{
  return (sizeof (XIMCallback));
}
unsigned int __sizeof_xiccallback (void)
{
  return (sizeof (XICCallback));
}
unsigned int __sizeof_ximtext (void)
{
  return (sizeof (XIMText));
}
unsigned int __sizeof_ximpreeditstatenotifycallbackstruct (void)
{
  return (sizeof (XIMPreeditStateNotifyCallbackStruct));
}
unsigned int __sizeof_ximstringconversiontext (void)
{
  return (sizeof (XIMStringConversionText));
}
unsigned int __sizeof_ximcaretdirection (void)
{
  return (sizeof (XIMCaretDirection));
}
unsigned int __sizeof_ximstringconversioncallbackstruct (void)
{
  return (sizeof (XIMStringConversionCallbackStruct));
}
unsigned int __sizeof_ximpreeditdrawcallbackstruct (void)
{
  return (sizeof (XIMPreeditDrawCallbackStruct));
}
unsigned int __sizeof_ximcaretstyle (void)
{
  return (sizeof (XIMCaretStyle));
}
unsigned int __sizeof_ximpreeditcaretcallbackstruct (void)
{
  return (sizeof (XIMPreeditCaretCallbackStruct));
}
unsigned int __sizeof_ximstatusdatatype (void)
{
  return (sizeof (XIMStatusDataType));
}
unsigned int __sizeof_ximstatusdrawcallbackstruct (void)
{
  return (sizeof (XIMStatusDrawCallbackStruct));
}
unsigned int __sizeof_ximhotkeytrigger (void)
{
  return (sizeof (XIMHotKeyTrigger));
}
unsigned int __sizeof_ximhotkeytriggers (void)
{
  return (sizeof (XIMHotKeyTriggers));
}
unsigned int __sizeof_ximvaluelist (void)
{
  return (sizeof (XIMValuesList));
}
