{ Xlib unit test program for GNU Pascal

  Copyright (C) 2002 Eike Lange.

  Author: Eike Lange <eike@g-n-u.de>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation, version 2.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING. If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.

  As a special exception, if you incorporate even large parts of the
  code of this demo program into another program with substantially
  different functionality, this does not cause the other program to
  be covered by the GNU General Public License. This exception does
  not however invalidate any other reasons why it might be covered
  by the GNU General Public License. }

program XTest;

uses GPC, Xlib;

{ Global Variables }
var
  XDisplay: PDisplay Value Nil;
  XRoot: TWindow; 
  XVisual: PVisual;
  XScreen, XDepth: Integer;

function InitX: Boolean;
begin
  XDisplay := XOpenDisplay (Nil);
  if XDisplay <> Nil then
    begin
      XRoot   := DefaultRootWindow (XDisplay);
      XScreen := DefaultScreen (XDisplay);
      XVisual := DefaultVisual (XDisplay, XScreen);
      XDepth  := DefaultDepth (XDisplay, XScreen);
      WriteLn (StdErr, 'ScrNum= ', XScreen, '   Depth= ', XDepth);
      InitX := True
    end
  else
    InitX := False
end;

procedure ExitX;
var
  Dummy: Integer;
begin
  Dummy := XCloseDisplay (XDisplay)
end;

function CreateWindow: TWindow;
var
  Attr: TXSetWindowAttributes;
  Mask: MedCard Value 0;
begin
  Attr.BackingStore := Always;
  Mask := Mask or CWBackingStore;
  Attr.BorderPixel := 16#FF0000;
  Mask := Mask or CWBorderPixel;
  Attr.BackgroundPixel := 16#FF0000;
  Mask := Mask or CWBackPixel;
  Attr.EventMask := StructureNotifyMask or KeyPressMask or 
    KeyReleaseMask or ButtonPressMask or ButtonReleaseMask or
    ButtonMotionMask or PointerMotionMask;
  Mask := Mask or CWEventMask;
  CreateWindow := XCreateWindow (XDisplay, XRoot, 0, 0,
    200, 200, 0, XDepth, InputOutput, XVisual, Mask, @Attr)
end;

function CreateSubwindow (Parent: TWindow): TWindow;
var
  Dummy: Integer;
  Attr: TXSetWindowAttributes;
  WinAttr: TXWindowAttributes;
  Mask: MedCard Value 0;
begin
  Attr.BackingStore := Always;
  Attr.BackgroundPixel := 2000;
  Attr.BorderPixel := 0;
  Attr.EventMask := StructureNotifyMask or KeyPressMask or 
    KeyReleaseMask or ButtonPressMask or ButtonReleaseMask or
    ButtonMotionMask or PointerMotionMask;  
  Mask := CWBackingStore or CWBackPixel or CWBorderPixel or CWEventMask;
  Dummy := XGetWindowAttributes (XDisplay, Parent, WinAttr);
  CreateSubwindow :=  XCreateWindow (XDisplay, Parent, 5, 5,
    WinAttr.Width - 10, WinAttr.Height - 10, 0, XDepth,
    InputOutput, XVisual, Mask, @Attr)
end;

{ Variables common to main program }
var
  Dummy: Integer;
  Win1, Win2: TWindow;
  Evt: TXEvent;

begin
  if InitX then
    begin
      Win1 := CreateWindow;
      Dummy := XMapRaised (XDisplay, Win1);
      Win2 := CreateSubwindow (Win1);
      Dummy := XMapRaised (XDisplay, Win2);
      while True do
        begin
          Dummy := XNextEvent (XDisplay, Evt);
          WriteLn ('Actual Event= ', Evt.EventType)
        end;
      ExitX
    end
  else
    WriteLn (StdErr, 'ERROR: InitX returns FALSE!')
end.
